import{s as dt,f as vt,n as mt,o as wt}from"../chunks/scheduler.37c15a92.js";import{S as xt,i as Lt,g as l,s as i,u as ee,A as bt,h as o,f as t,c as r,j as u,v as te,y as g,k as s,o as h,a,w as ne,d as ae,t as le,x as oe}from"../chunks/index.b01106c0.js";import{I as ie}from"../chunks/IconCopyLink.77b762b4.js";function yt(Ie){let f,re,B,se,p,x,K,k,Se,U,Fe="Language models in RL",he,c,L,Q,$,Ne,j,Oe="LMs encode useful knowledge for agents",ue,C,Ue="<strong>Language models</strong> (LMs) can exhibit impressive abilities when manipulating text such as question-answering or even step-by-step reasoning. Additionally, their training on massive text corpora allowed them to <strong>encode various types of knowledge including abstract ones about the physical rules of our world</strong> (for instance what is possible to do with an object, what happens when one rotates an object…).",ge,M,je="A natural question recently studied was whether such knowledge could benefit agents such as robots when trying to solve everyday tasks. And while these works showed interesting results, the proposed agents lacked any learning method. <strong>This limitation prevents these agent from adapting to the environment (e.g. fixing wrong knowledge) or learning new skills.</strong>",fe,P,De='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit12/language.png" alt="Language"/> <figcaption>Source: <a href="https://ai.googleblog.com/2022/08/towards-helpful-robots-grounding.html">Towards Helpful Robots: Grounding Language in Robotic Affordances</a></figcaption>',pe,d,b,W,T,Ge,D,Je="LMs and RL",ce,A,Ve="There is therefore a potential synergy between LMs which can bring knowledge about the world, and RL which can align and correct this knowledge by interacting with an environment. It is especially interesting from a RL point-of-view as the RL field mostly relies on the <strong>Tabula-rasa</strong> setup where everything is learned from scratch by the agent leading to:",de,H,Be="1) Sample inefficiency",ve,R,Ke="2) Unexpected behaviors from humans’ eyes",me,E,Qe='As a first attempt, the paper <a href="https://arxiv.org/abs/2302.02662v1" rel="nofollow">“Grounding Large Language Models with Online Reinforcement Learning”</a> tackled the problem of <strong>adapting or aligning a LM to a textual environment using PPO</strong>. They showed that the knowledge encoded in the LM lead to a fast adaptation to the environment (opening avenues for sample efficient RL agents) but also that such knowledge allowed the LM to better generalize to new tasks once aligned.',we,v,We,xe,S,Xe='Another direction studied in <a href="https://arxiv.org/abs/2302.06692" rel="nofollow">“Guiding Pretraining in Reinforcement Learning with Large Language Models”</a> was to keep the LM frozen but leverage its knowledge to <strong>guide an RL agent’s exploration</strong>. Such a method allows the RL agent to be guided towards human-meaningful and plausibly useful behaviors without requiring a human in the loop during training.',Le,N,Ye='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit12/language2.png" alt="Language"/> <figcaption>Source: <a href="https://ai.googleblog.com/2022/08/towards-helpful-robots-grounding.html">Towards Helpful Robots: Grounding Language in Robotic Affordances</a></figcaption>',be,G,Ze="Several limitations make these works still very preliminary such as the need to convert the agent’s observation to text before giving it to a LM as well as the compute cost of interacting with very large LMs.",ye,m,y,X,q,qe,J,et="Further reading",_e,z,tt="For more information we recommend you check out the following resources:",ke,I,nt='<li><a href="https://ai.googleblog.com/2023/02/google-research-2022-beyond-robotics.html" rel="nofollow">Google Research, 2022 &amp; beyond: Robotics</a></li> <li><a href="https://arxiv.org/abs/2202.01771" rel="nofollow">Pre-Trained Language Models for Interactive Decision-Making</a></li> <li><a href="https://arxiv.org/abs/2302.02662v1" rel="nofollow">Grounding Large Language Models with Online Reinforcement Learning</a></li> <li><a href="https://arxiv.org/abs/2302.06692" rel="nofollow">Guiding Pretraining in Reinforcement Learning with Large Language Models</a></li>',$e,w,_,Y,F,ze,V,at="Author",Ce,O,lt='This section was written by <a href="https://twitter.com/ClementRomac">Clément Romac</a>',Me,Z,Pe;return k=new ie({}),$=new ie({}),T=new ie({}),q=new ie({}),F=new ie({}),{c(){f=l("meta"),re=i(),B=l("p"),se=i(),p=l("h1"),x=l("a"),K=l("span"),ee(k.$$.fragment),Se=i(),U=l("span"),U.textContent=Fe,he=i(),c=l("h2"),L=l("a"),Q=l("span"),ee($.$$.fragment),Ne=i(),j=l("span"),j.textContent=Oe,ue=i(),C=l("p"),C.innerHTML=Ue,ge=i(),M=l("p"),M.innerHTML=je,fe=i(),P=l("figure"),P.innerHTML=De,pe=i(),d=l("h2"),b=l("a"),W=l("span"),ee(T.$$.fragment),Ge=i(),D=l("span"),D.textContent=Je,ce=i(),A=l("p"),A.innerHTML=Ve,de=i(),H=l("p"),H.textContent=Be,ve=i(),R=l("p"),R.textContent=Ke,me=i(),E=l("p"),E.innerHTML=Qe,we=i(),v=l("video"),xe=i(),S=l("p"),S.innerHTML=Xe,Le=i(),N=l("figure"),N.innerHTML=Ye,be=i(),G=l("p"),G.textContent=Ze,ye=i(),m=l("h2"),y=l("a"),X=l("span"),ee(q.$$.fragment),qe=i(),J=l("span"),J.textContent=et,_e=i(),z=l("p"),z.textContent=tt,ke=i(),I=l("ul"),I.innerHTML=nt,$e=i(),w=l("h2"),_=l("a"),Y=l("span"),ee(F.$$.fragment),ze=i(),V=l("span"),V.textContent=at,Ce=i(),O=l("p"),O.innerHTML=lt,Me=i(),Z=l("p"),this.h()},l(e){const n=bt("svelte-1phssyn",document.head);f=o(n,"META",{name:!0,content:!0}),n.forEach(t),re=r(e),B=o(e,"P",{}),u(B).forEach(t),se=r(e),p=o(e,"H1",{class:!0});var Te=u(p);x=o(Te,"A",{id:!0,class:!0,href:!0});var ot=u(x);K=o(ot,"SPAN",{});var it=u(K);te(k.$$.fragment,it),it.forEach(t),ot.forEach(t),Se=r(Te),U=o(Te,"SPAN",{"data-svelte-h":!0}),g(U)!=="svelte-5i4jk0"&&(U.textContent=Fe),Te.forEach(t),he=r(e),c=o(e,"H2",{class:!0});var Ae=u(c);L=o(Ae,"A",{id:!0,class:!0,href:!0});var rt=u(L);Q=o(rt,"SPAN",{});var st=u(Q);te($.$$.fragment,st),st.forEach(t),rt.forEach(t),Ne=r(Ae),j=o(Ae,"SPAN",{"data-svelte-h":!0}),g(j)!=="svelte-1tu3blk"&&(j.textContent=Oe),Ae.forEach(t),ue=r(e),C=o(e,"P",{"data-svelte-h":!0}),g(C)!=="svelte-1ia9etz"&&(C.innerHTML=Ue),ge=r(e),M=o(e,"P",{"data-svelte-h":!0}),g(M)!=="svelte-mx2vzz"&&(M.innerHTML=je),fe=r(e),P=o(e,"FIGURE",{"data-svelte-h":!0}),g(P)!=="svelte-mlzssa"&&(P.innerHTML=De),pe=r(e),d=o(e,"H2",{class:!0});var He=u(d);b=o(He,"A",{id:!0,class:!0,href:!0});var ht=u(b);W=o(ht,"SPAN",{});var ut=u(W);te(T.$$.fragment,ut),ut.forEach(t),ht.forEach(t),Ge=r(He),D=o(He,"SPAN",{"data-svelte-h":!0}),g(D)!=="svelte-19981b2"&&(D.textContent=Je),He.forEach(t),ce=r(e),A=o(e,"P",{"data-svelte-h":!0}),g(A)!=="svelte-1krps7c"&&(A.innerHTML=Ve),de=r(e),H=o(e,"P",{"data-svelte-h":!0}),g(H)!=="svelte-t591em"&&(H.textContent=Be),ve=r(e),R=o(e,"P",{"data-svelte-h":!0}),g(R)!=="svelte-wkrady"&&(R.textContent=Ke),me=r(e),E=o(e,"P",{"data-svelte-h":!0}),g(E)!=="svelte-10nvdwf"&&(E.innerHTML=Qe),we=r(e),v=o(e,"VIDEO",{src:!0,type:!0}),u(v).forEach(t),xe=r(e),S=o(e,"P",{"data-svelte-h":!0}),g(S)!=="svelte-p7dns2"&&(S.innerHTML=Xe),Le=r(e),N=o(e,"FIGURE",{"data-svelte-h":!0}),g(N)!=="svelte-qaexsq"&&(N.innerHTML=Ye),be=r(e),G=o(e,"P",{"data-svelte-h":!0}),g(G)!=="svelte-1ti66le"&&(G.textContent=Ze),ye=r(e),m=o(e,"H2",{class:!0});var Re=u(m);y=o(Re,"A",{id:!0,class:!0,href:!0});var gt=u(y);X=o(gt,"SPAN",{});var ft=u(X);te(q.$$.fragment,ft),ft.forEach(t),gt.forEach(t),qe=r(Re),J=o(Re,"SPAN",{"data-svelte-h":!0}),g(J)!=="svelte-1gvwyzx"&&(J.textContent=et),Re.forEach(t),_e=r(e),z=o(e,"P",{"data-svelte-h":!0}),g(z)!=="svelte-12yec34"&&(z.textContent=tt),ke=r(e),I=o(e,"UL",{"data-svelte-h":!0}),g(I)!=="svelte-k5x2wu"&&(I.innerHTML=nt),$e=r(e),w=o(e,"H2",{class:!0});var Ee=u(w);_=o(Ee,"A",{id:!0,class:!0,href:!0});var pt=u(_);Y=o(pt,"SPAN",{});var ct=u(Y);te(F.$$.fragment,ct),ct.forEach(t),pt.forEach(t),ze=r(Ee),V=o(Ee,"SPAN",{"data-svelte-h":!0}),g(V)!=="svelte-hw3i4s"&&(V.textContent=at),Ee.forEach(t),Ce=r(e),O=o(e,"P",{"data-svelte-h":!0}),g(O)!=="svelte-a8x2u9"&&(O.innerHTML=lt),Me=r(e),Z=o(e,"P",{}),u(Z).forEach(t),this.h()},h(){s(f,"name","hf:doc:metadata"),s(f,"content",JSON.stringify(_t)),s(x,"id","language-models-in-rl"),s(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(x,"href","#language-models-in-rl"),s(p,"class","relative group"),s(L,"id","lms-encode-useful-knowledge-for-agents"),s(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(L,"href","#lms-encode-useful-knowledge-for-agents"),s(c,"class","relative group"),s(b,"id","lms-and-rl"),s(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(b,"href","#lms-and-rl"),s(d,"class","relative group"),vt(v.src,We="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit12/papier_v4.mp4")||s(v,"src",We),s(v,"type","video/mp4"),v.controls=!0,s(y,"id","further-reading"),s(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(y,"href","#further-reading"),s(m,"class","relative group"),s(_,"id","author"),s(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(_,"href","#author"),s(w,"class","relative group")},m(e,n){h(document.head,f),a(e,re,n),a(e,B,n),a(e,se,n),a(e,p,n),h(p,x),h(x,K),ne(k,K,null),h(p,Se),h(p,U),a(e,he,n),a(e,c,n),h(c,L),h(L,Q),ne($,Q,null),h(c,Ne),h(c,j),a(e,ue,n),a(e,C,n),a(e,ge,n),a(e,M,n),a(e,fe,n),a(e,P,n),a(e,pe,n),a(e,d,n),h(d,b),h(b,W),ne(T,W,null),h(d,Ge),h(d,D),a(e,ce,n),a(e,A,n),a(e,de,n),a(e,H,n),a(e,ve,n),a(e,R,n),a(e,me,n),a(e,E,n),a(e,we,n),a(e,v,n),a(e,xe,n),a(e,S,n),a(e,Le,n),a(e,N,n),a(e,be,n),a(e,G,n),a(e,ye,n),a(e,m,n),h(m,y),h(y,X),ne(q,X,null),h(m,qe),h(m,J),a(e,_e,n),a(e,z,n),a(e,ke,n),a(e,I,n),a(e,$e,n),a(e,w,n),h(w,_),h(_,Y),ne(F,Y,null),h(w,ze),h(w,V),a(e,Ce,n),a(e,O,n),a(e,Me,n),a(e,Z,n),Pe=!0},p:mt,i(e){Pe||(ae(k.$$.fragment,e),ae($.$$.fragment,e),ae(T.$$.fragment,e),ae(q.$$.fragment,e),ae(F.$$.fragment,e),Pe=!0)},o(e){le(k.$$.fragment,e),le($.$$.fragment,e),le(T.$$.fragment,e),le(q.$$.fragment,e),le(F.$$.fragment,e),Pe=!1},d(e){e&&(t(re),t(B),t(se),t(p),t(he),t(c),t(ue),t(C),t(ge),t(M),t(fe),t(P),t(pe),t(d),t(ce),t(A),t(de),t(H),t(ve),t(R),t(me),t(E),t(we),t(v),t(xe),t(S),t(Le),t(N),t(be),t(G),t(ye),t(m),t(_e),t(z),t(ke),t(I),t($e),t(w),t(Ce),t(O),t(Me),t(Z)),t(f),oe(k),oe($),oe(T),oe(q),oe(F)}}}const _t={local:"language-models-in-rl",sections:[{local:"lms-encode-useful-knowledge-for-agents",title:"LMs encode useful knowledge for agents"},{local:"lms-and-rl",title:"LMs and RL"},{local:"further-reading",title:"Further reading"},{local:"author",title:"Author"}],title:"Language models in RL"};function kt(Ie){return wt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pt extends xt{constructor(f){super(),Lt(this,f,kt,yt,dt,{})}}export{Pt as component};
