import{s as $t,n as kt,o as Lt}from"../chunks/scheduler.37c15a92.js";import{S as Pt,i as Rt,g as a,s as i,u as oe,A as Tt,h as r,f as t,c as l,j as u,v as ae,y as s,k as h,o as p,a as o,w as re,d as ie,t as le,x as se}from"../chunks/index.b01106c0.js";import{I as he}from"../chunks/IconCopyLink.77b762b4.js";function Ht(Oe){let d,pe,V,ue,c,g,X,_,Be,O,Ue="Brief introduction to RL documentation",de,$,We=`In this advanced topic, we address the question: <strong>how should we monitor and keep track of powerful reinforcement learning agents that we are training in the real world and
interfacing with humans?</strong>`,ce,k,Ke="As machine learning systems have increasingly impacted modern life, the <strong>call for the documentation of these systems has grown</strong>.",fe,L,Qe=`Such documentation can cover aspects such as the training data used — where it is stored, when it was collected, who was involved, etc.
— or the model optimization framework — the architecture, evaluation metrics, relevant papers, etc. — and more.`,me,P,Ve=`Today, model cards and datasheets are becoming increasingly available. For example, on the Hub
(see documentation <a href="https://huggingface.co/docs/hub/model-cards" rel="nofollow">here</a>).`,ve,R,Xe='If you click on a <a href="https://huggingface.co/models" rel="nofollow">popular model on the Hub</a>, you can learn about its creation process.',we,T,Ye=`These model and data specific logs are designed to be completed when the model or dataset are created, leaving them to go un-updated when these models are built into evolving systems in the future.
​`,ge,f,x,Y,H,De,U,Ze="Motivating Reward Reports",xe,M,et=`Reinforcement learning systems are fundamentally designed to optimize based on measurements of reward and time.
While the notion of a reward function can be mapped nicely to many well-understood fields of supervised learning (via a loss function),
understanding of how machine learning systems evolve over time is limited.`,be,A,tt=`To that end, the authors introduce <a href="https://www.notion.so/Brief-introduction-to-RL-documentation-b8cbda5a6f5242338e0756e6bef72af4" rel="nofollow"><em>Reward Reports for Reinforcement Learning</em></a> (the pithy naming is designed to mirror the popular papers <em>Model Cards for Model Reporting</em> and <em>Datasheets for Datasets</em>).
The goal is to propose a type of documentation focused on the <strong>human factors of reward</strong> and <strong>time-varying feedback systems</strong>.`,ye,E,nt='Building on the documentation frameworks for <a href="https://arxiv.org/abs/1810.03993" rel="nofollow">model cards</a> and <a href="https://arxiv.org/abs/1803.09010" rel="nofollow">datasheets</a> proposed by Mitchell et al. and Gebru et al., we argue the need for Reward Reports for AI systems.',Ce,S,ot="<strong>Reward Reports</strong> are living documents for proposed RL deployments that demarcate design choices.",_e,N,at=`However, many questions remain about the applicability of this framework to different RL applications, roadblocks to system interpretability,
and the resonances between deployed supervised machine learning systems and the sequential decision-making utilized in RL.`,$e,q,rt=`At a minimum, Reward Reports are an opportunity for RL practitioners to deliberate on these questions and begin the work of deciding how to resolve them in practice.
​`,ke,m,b,Z,z,Fe,W,it="Capturing temporal behavior with documentation",Le,I,lt=`The core piece specific to documentation designed for RL and feedback-driven ML systems is a <em>change-log</em>. The change-log updates information
from the designer (changed training parameters, data, etc.) along with noticed changes from the user (harmful behavior, unexpected responses, etc.).`,Pe,j,st="The change log is accompanied by update triggers that encourage monitoring these effects.",Re,v,y,ee,B,Ge,K,ht="Contributing",Te,D,pt=`Some of the most impactful RL-driven systems are multi-stakeholder in nature and behind the closed doors of private corporations.
These corporations are largely without regulation, so the burden of documentation falls on the public.`,He,F,ut=`If you are interested in contributing, we are building Reward Reports for popular machine learning systems on a public
record on <a href="https://github.com/RewardReports/reward-reports" rel="nofollow">GitHub</a>.
​
For further reading, you can visit the Reward Reports <a href="https://arxiv.org/abs/2204.10817" rel="nofollow">paper</a>
or look <a href="https://github.com/RewardReports/reward-reports/tree/main/examples" rel="nofollow">an example report</a>.`,Me,w,C,te,G,Je,Q,dt="Author",Ae,J,ct='This section was written by <a href="https://twitter.com/natolambert">Nathan Lambert</a>',Ee,ne,Se;return _=new he({}),H=new he({}),z=new he({}),B=new he({}),G=new he({}),{c(){d=a("meta"),pe=i(),V=a("p"),ue=i(),c=a("h1"),g=a("a"),X=a("span"),oe(_.$$.fragment),Be=i(),O=a("span"),O.textContent=Ue,de=i(),$=a("p"),$.innerHTML=We,ce=i(),k=a("p"),k.innerHTML=Ke,fe=i(),L=a("p"),L.textContent=Qe,me=i(),P=a("p"),P.innerHTML=Ve,ve=i(),R=a("p"),R.innerHTML=Xe,we=i(),T=a("p"),T.textContent=Ye,ge=i(),f=a("h2"),x=a("a"),Y=a("span"),oe(H.$$.fragment),De=i(),U=a("span"),U.textContent=Ze,xe=i(),M=a("p"),M.textContent=et,be=i(),A=a("p"),A.innerHTML=tt,ye=i(),E=a("p"),E.innerHTML=nt,Ce=i(),S=a("p"),S.innerHTML=ot,_e=i(),N=a("p"),N.textContent=at,$e=i(),q=a("p"),q.textContent=rt,ke=i(),m=a("h2"),b=a("a"),Z=a("span"),oe(z.$$.fragment),Fe=i(),W=a("span"),W.textContent=it,Le=i(),I=a("p"),I.innerHTML=lt,Pe=i(),j=a("p"),j.textContent=st,Re=i(),v=a("h2"),y=a("a"),ee=a("span"),oe(B.$$.fragment),Ge=i(),K=a("span"),K.textContent=ht,Te=i(),D=a("p"),D.textContent=pt,He=i(),F=a("p"),F.innerHTML=ut,Me=i(),w=a("h2"),C=a("a"),te=a("span"),oe(G.$$.fragment),Je=i(),Q=a("span"),Q.textContent=dt,Ae=i(),J=a("p"),J.innerHTML=ct,Ee=i(),ne=a("p"),this.h()},l(e){const n=Tt("svelte-1phssyn",document.head);d=r(n,"META",{name:!0,content:!0}),n.forEach(t),pe=l(e),V=r(e,"P",{}),u(V).forEach(t),ue=l(e),c=r(e,"H1",{class:!0});var Ne=u(c);g=r(Ne,"A",{id:!0,class:!0,href:!0});var ft=u(g);X=r(ft,"SPAN",{});var mt=u(X);ae(_.$$.fragment,mt),mt.forEach(t),ft.forEach(t),Be=l(Ne),O=r(Ne,"SPAN",{"data-svelte-h":!0}),s(O)!=="svelte-1x2a1sw"&&(O.textContent=Ue),Ne.forEach(t),de=l(e),$=r(e,"P",{"data-svelte-h":!0}),s($)!=="svelte-vtjhob"&&($.innerHTML=We),ce=l(e),k=r(e,"P",{"data-svelte-h":!0}),s(k)!=="svelte-1fronss"&&(k.innerHTML=Ke),fe=l(e),L=r(e,"P",{"data-svelte-h":!0}),s(L)!=="svelte-18x38zx"&&(L.textContent=Qe),me=l(e),P=r(e,"P",{"data-svelte-h":!0}),s(P)!=="svelte-1dlzh15"&&(P.innerHTML=Ve),ve=l(e),R=r(e,"P",{"data-svelte-h":!0}),s(R)!=="svelte-11x8tuw"&&(R.innerHTML=Xe),we=l(e),T=r(e,"P",{"data-svelte-h":!0}),s(T)!=="svelte-1m80jls"&&(T.textContent=Ye),ge=l(e),f=r(e,"H2",{class:!0});var qe=u(f);x=r(qe,"A",{id:!0,class:!0,href:!0});var vt=u(x);Y=r(vt,"SPAN",{});var wt=u(Y);ae(H.$$.fragment,wt),wt.forEach(t),vt.forEach(t),De=l(qe),U=r(qe,"SPAN",{"data-svelte-h":!0}),s(U)!=="svelte-1pv3ish"&&(U.textContent=Ze),qe.forEach(t),xe=l(e),M=r(e,"P",{"data-svelte-h":!0}),s(M)!=="svelte-uuu9we"&&(M.textContent=et),be=l(e),A=r(e,"P",{"data-svelte-h":!0}),s(A)!=="svelte-163ow0b"&&(A.innerHTML=tt),ye=l(e),E=r(e,"P",{"data-svelte-h":!0}),s(E)!=="svelte-iy1n1"&&(E.innerHTML=nt),Ce=l(e),S=r(e,"P",{"data-svelte-h":!0}),s(S)!=="svelte-1q2xcek"&&(S.innerHTML=ot),_e=l(e),N=r(e,"P",{"data-svelte-h":!0}),s(N)!=="svelte-j1zl9k"&&(N.textContent=at),$e=l(e),q=r(e,"P",{"data-svelte-h":!0}),s(q)!=="svelte-1w6v3rz"&&(q.textContent=rt),ke=l(e),m=r(e,"H2",{class:!0});var ze=u(m);b=r(ze,"A",{id:!0,class:!0,href:!0});var gt=u(b);Z=r(gt,"SPAN",{});var xt=u(Z);ae(z.$$.fragment,xt),xt.forEach(t),gt.forEach(t),Fe=l(ze),W=r(ze,"SPAN",{"data-svelte-h":!0}),s(W)!=="svelte-xgdm4q"&&(W.textContent=it),ze.forEach(t),Le=l(e),I=r(e,"P",{"data-svelte-h":!0}),s(I)!=="svelte-5kkp2w"&&(I.innerHTML=lt),Pe=l(e),j=r(e,"P",{"data-svelte-h":!0}),s(j)!=="svelte-1j0m0fx"&&(j.textContent=st),Re=l(e),v=r(e,"H2",{class:!0});var Ie=u(v);y=r(Ie,"A",{id:!0,class:!0,href:!0});var bt=u(y);ee=r(bt,"SPAN",{});var yt=u(ee);ae(B.$$.fragment,yt),yt.forEach(t),bt.forEach(t),Ge=l(Ie),K=r(Ie,"SPAN",{"data-svelte-h":!0}),s(K)!=="svelte-d2xthp"&&(K.textContent=ht),Ie.forEach(t),Te=l(e),D=r(e,"P",{"data-svelte-h":!0}),s(D)!=="svelte-i3qq7q"&&(D.textContent=pt),He=l(e),F=r(e,"P",{"data-svelte-h":!0}),s(F)!=="svelte-ihbc3x"&&(F.innerHTML=ut),Me=l(e),w=r(e,"H2",{class:!0});var je=u(w);C=r(je,"A",{id:!0,class:!0,href:!0});var Ct=u(C);te=r(Ct,"SPAN",{});var _t=u(te);ae(G.$$.fragment,_t),_t.forEach(t),Ct.forEach(t),Je=l(je),Q=r(je,"SPAN",{"data-svelte-h":!0}),s(Q)!=="svelte-hw3i4s"&&(Q.textContent=dt),je.forEach(t),Ae=l(e),J=r(e,"P",{"data-svelte-h":!0}),s(J)!=="svelte-17c4ke5"&&(J.innerHTML=ct),Ee=l(e),ne=r(e,"P",{}),u(ne).forEach(t),this.h()},h(){h(d,"name","hf:doc:metadata"),h(d,"content",JSON.stringify(Mt)),h(g,"id","brief-introduction-to-rl-documentation"),h(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(g,"href","#brief-introduction-to-rl-documentation"),h(c,"class","relative group"),h(x,"id","motivating-reward-reports"),h(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(x,"href","#motivating-reward-reports"),h(f,"class","relative group"),h(b,"id","capturing-temporal-behavior-with-documentation"),h(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(b,"href","#capturing-temporal-behavior-with-documentation"),h(m,"class","relative group"),h(y,"id","contributing"),h(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(y,"href","#contributing"),h(v,"class","relative group"),h(C,"id","author"),h(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(C,"href","#author"),h(w,"class","relative group")},m(e,n){p(document.head,d),o(e,pe,n),o(e,V,n),o(e,ue,n),o(e,c,n),p(c,g),p(g,X),re(_,X,null),p(c,Be),p(c,O),o(e,de,n),o(e,$,n),o(e,ce,n),o(e,k,n),o(e,fe,n),o(e,L,n),o(e,me,n),o(e,P,n),o(e,ve,n),o(e,R,n),o(e,we,n),o(e,T,n),o(e,ge,n),o(e,f,n),p(f,x),p(x,Y),re(H,Y,null),p(f,De),p(f,U),o(e,xe,n),o(e,M,n),o(e,be,n),o(e,A,n),o(e,ye,n),o(e,E,n),o(e,Ce,n),o(e,S,n),o(e,_e,n),o(e,N,n),o(e,$e,n),o(e,q,n),o(e,ke,n),o(e,m,n),p(m,b),p(b,Z),re(z,Z,null),p(m,Fe),p(m,W),o(e,Le,n),o(e,I,n),o(e,Pe,n),o(e,j,n),o(e,Re,n),o(e,v,n),p(v,y),p(y,ee),re(B,ee,null),p(v,Ge),p(v,K),o(e,Te,n),o(e,D,n),o(e,He,n),o(e,F,n),o(e,Me,n),o(e,w,n),p(w,C),p(C,te),re(G,te,null),p(w,Je),p(w,Q),o(e,Ae,n),o(e,J,n),o(e,Ee,n),o(e,ne,n),Se=!0},p:kt,i(e){Se||(ie(_.$$.fragment,e),ie(H.$$.fragment,e),ie(z.$$.fragment,e),ie(B.$$.fragment,e),ie(G.$$.fragment,e),Se=!0)},o(e){le(_.$$.fragment,e),le(H.$$.fragment,e),le(z.$$.fragment,e),le(B.$$.fragment,e),le(G.$$.fragment,e),Se=!1},d(e){e&&(t(pe),t(V),t(ue),t(c),t(de),t($),t(ce),t(k),t(fe),t(L),t(me),t(P),t(ve),t(R),t(we),t(T),t(ge),t(f),t(xe),t(M),t(be),t(A),t(ye),t(E),t(Ce),t(S),t(_e),t(N),t($e),t(q),t(ke),t(m),t(Le),t(I),t(Pe),t(j),t(Re),t(v),t(Te),t(D),t(He),t(F),t(Me),t(w),t(Ae),t(J),t(Ee),t(ne)),t(d),se(_),se(H),se(z),se(B),se(G)}}}const Mt={local:"brief-introduction-to-rl-documentation",sections:[{local:"motivating-reward-reports",title:"Motivating Reward Reports"},{local:"capturing-temporal-behavior-with-documentation",title:"Capturing temporal behavior with documentation"},{local:"contributing",title:"Contributing"},{local:"author",title:"Author"}],title:"Brief introduction to RL documentation"};function At(Oe){return Lt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qt extends Pt{constructor(d){super(),Rt(this,d,At,Ht,$t,{})}}export{qt as component};
