import{s as Le,f as Te,n as ye,o as Me}from"../chunks/scheduler.37c15a92.js";import{S as He,i as Ce,g as l,s as a,u as be,A as Ee,h as o,f as t,c as r,j as q,v as ke,y as s,k as p,o as S,a as i,w as Pe,d as $e,t as Ie,x as qe}from"../chunks/index.b01106c0.js";import{I as Se}from"../chunks/IconCopyLink.77b762b4.js";function je(ne){let u,j,P,z,f,m,$,v,te,k,ie="The Exploration/Exploitation trade-off",A,x,le="Finally, before looking at the different methods to solve Reinforcement Learning problems, we must cover one more very important topic: <em>the exploration/exploitation trade-off.</em>",R,g,oe="<li><em>Exploration</em> is exploring the environment by trying random actions in order to <strong>find more information about the environment.</strong></li> <li><em>Exploitation</em> is <strong>exploiting known information to maximize the reward.</strong></li>",U,d,ae="Remember, the goal of our RL agent is to maximize the expected cumulative reward. However, <strong>we can fall into a common trap</strong>.",B,w,re="Let’s take an example:",G,h,se,N,_,pe="In this game, our mouse can have an <strong>infinite amount of small cheese</strong> (+1 each). But at the top of the maze, there is a gigantic sum of cheese (+1000).",F,T,ue="However, if we only focus on exploitation, our agent will never reach the gigantic sum of cheese. Instead, it will only exploit <strong>the nearest source of rewards,</strong> even if this source is small (exploitation).",W,L,fe="But if our agent does a little bit of exploration, it can <strong>discover the big reward</strong> (the pile of big cheese).",J,y,me="This is what we call the exploration/exploitation trade-off. We need to balance how much we <strong>explore the environment</strong> and how much we <strong>exploit what we know about the environment.</strong>",O,M,he="Therefore, we must <strong>define a rule that helps to handle this trade-off</strong>. We’ll see the different ways to handle it in the future units.",Y,H,ce="If it’s still confusing, <strong>think of a real problem: the choice of picking a restaurant:</strong>",D,C,ve='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/exp_2.jpg" alt="Exploration"/> <figcaption>Source: <a href="https://inst.eecs.berkeley.edu/~cs188/sp20/assets/lecture/lec15_6up.pdf">Berkley AI Course</a></figcaption>',K,b,xe="<li><em>Exploitation</em>: You go to the same one that you know is good every day and <strong>take the risk to miss another better restaurant.</strong></li> <li><em>Exploration</em>: Try restaurants you never went to before, with the risk of having a bad experience <strong>but the probable opportunity of a fantastic experience.</strong></li>",Q,E,ge="To recap:",V,c,de,X,I,Z;return v=new Se({}),{c(){u=l("meta"),j=a(),P=l("p"),z=a(),f=l("h1"),m=l("a"),$=l("span"),be(v.$$.fragment),te=a(),k=l("span"),k.textContent=ie,A=a(),x=l("p"),x.innerHTML=le,R=a(),g=l("ul"),g.innerHTML=oe,U=a(),d=l("p"),d.innerHTML=ae,B=a(),w=l("p"),w.textContent=re,G=a(),h=l("img"),N=a(),_=l("p"),_.innerHTML=pe,F=a(),T=l("p"),T.innerHTML=ue,W=a(),L=l("p"),L.innerHTML=fe,J=a(),y=l("p"),y.innerHTML=me,O=a(),M=l("p"),M.innerHTML=he,Y=a(),H=l("p"),H.innerHTML=ce,D=a(),C=l("figure"),C.innerHTML=ve,K=a(),b=l("ul"),b.innerHTML=xe,Q=a(),E=l("p"),E.textContent=ge,V=a(),c=l("img"),X=a(),I=l("p"),this.h()},l(e){const n=Ee("svelte-1phssyn",document.head);u=o(n,"META",{name:!0,content:!0}),n.forEach(t),j=r(e),P=o(e,"P",{}),q(P).forEach(t),z=r(e),f=o(e,"H1",{class:!0});var ee=q(f);m=o(ee,"A",{id:!0,class:!0,href:!0});var we=q(m);$=o(we,"SPAN",{});var _e=q($);ke(v.$$.fragment,_e),_e.forEach(t),we.forEach(t),te=r(ee),k=o(ee,"SPAN",{"data-svelte-h":!0}),s(k)!=="svelte-1t678u4"&&(k.textContent=ie),ee.forEach(t),A=r(e),x=o(e,"P",{"data-svelte-h":!0}),s(x)!=="svelte-fbv3pl"&&(x.innerHTML=le),R=r(e),g=o(e,"UL",{"data-svelte-h":!0}),s(g)!=="svelte-nc85ql"&&(g.innerHTML=oe),U=r(e),d=o(e,"P",{"data-svelte-h":!0}),s(d)!=="svelte-2jh1qs"&&(d.innerHTML=ae),B=r(e),w=o(e,"P",{"data-svelte-h":!0}),s(w)!=="svelte-1wtngfz"&&(w.textContent=re),G=r(e),h=o(e,"IMG",{src:!0,alt:!0,width:!0}),N=r(e),_=o(e,"P",{"data-svelte-h":!0}),s(_)!=="svelte-1kw5ynv"&&(_.innerHTML=pe),F=r(e),T=o(e,"P",{"data-svelte-h":!0}),s(T)!=="svelte-qt6w4m"&&(T.innerHTML=ue),W=r(e),L=o(e,"P",{"data-svelte-h":!0}),s(L)!=="svelte-16dhxd1"&&(L.innerHTML=fe),J=r(e),y=o(e,"P",{"data-svelte-h":!0}),s(y)!=="svelte-13goax7"&&(y.innerHTML=me),O=r(e),M=o(e,"P",{"data-svelte-h":!0}),s(M)!=="svelte-65jqh4"&&(M.innerHTML=he),Y=r(e),H=o(e,"P",{"data-svelte-h":!0}),s(H)!=="svelte-1qfk4tu"&&(H.innerHTML=ce),D=r(e),C=o(e,"FIGURE",{"data-svelte-h":!0}),s(C)!=="svelte-sgn18n"&&(C.innerHTML=ve),K=r(e),b=o(e,"UL",{"data-svelte-h":!0}),s(b)!=="svelte-1yngr8f"&&(b.innerHTML=xe),Q=r(e),E=o(e,"P",{"data-svelte-h":!0}),s(E)!=="svelte-mz2ztc"&&(E.textContent=ge),V=r(e),c=o(e,"IMG",{src:!0,alt:!0,width:!0}),X=r(e),I=o(e,"P",{}),q(I).forEach(t),this.h()},h(){p(u,"name","hf:doc:metadata"),p(u,"content",JSON.stringify(ze)),p(m,"id","exp-exp-tradeoff"),p(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(m,"href","#exp-exp-tradeoff"),p(f,"class","relative group"),Te(h.src,se="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/exp_1.jpg")||p(h,"src",se),p(h,"alt","Exploration"),p(h,"width","100%"),Te(c.src,de="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/expexpltradeoff.jpg")||p(c,"src",de),p(c,"alt","Exploration Exploitation Tradeoff"),p(c,"width","100%")},m(e,n){S(document.head,u),i(e,j,n),i(e,P,n),i(e,z,n),i(e,f,n),S(f,m),S(m,$),Pe(v,$,null),S(f,te),S(f,k),i(e,A,n),i(e,x,n),i(e,R,n),i(e,g,n),i(e,U,n),i(e,d,n),i(e,B,n),i(e,w,n),i(e,G,n),i(e,h,n),i(e,N,n),i(e,_,n),i(e,F,n),i(e,T,n),i(e,W,n),i(e,L,n),i(e,J,n),i(e,y,n),i(e,O,n),i(e,M,n),i(e,Y,n),i(e,H,n),i(e,D,n),i(e,C,n),i(e,K,n),i(e,b,n),i(e,Q,n),i(e,E,n),i(e,V,n),i(e,c,n),i(e,X,n),i(e,I,n),Z=!0},p:ye,i(e){Z||($e(v.$$.fragment,e),Z=!0)},o(e){Ie(v.$$.fragment,e),Z=!1},d(e){e&&(t(j),t(P),t(z),t(f),t(A),t(x),t(R),t(g),t(U),t(d),t(B),t(w),t(G),t(h),t(N),t(_),t(F),t(T),t(W),t(L),t(J),t(y),t(O),t(M),t(Y),t(H),t(D),t(C),t(K),t(b),t(Q),t(E),t(V),t(c),t(X),t(I)),t(u),qe(v)}}}const ze={local:"exp-exp-tradeoff",title:"The Exploration/Exploitation trade-off "};function Ae(ne){return Me(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ge extends He{constructor(u){super(),Ce(this,u,Ae,je,Le,{})}}export{Ge as component};
