import{s as Ye,f as rt,o as Ze}from"../chunks/scheduler.37c15a92.js";import{S as ti,i as ei,g as a,s,u as ft,A as ii,h as n,f as e,c as o,j as p,v as vt,y as u,k as r,o as c,a as l,w as mt,d as dt,t as wt,x as _t,m as li,n as ai}from"../chunks/index.b01106c0.js";import{T as ni}from"../chunks/Tip.47ade202.js";import{I as se}from"../chunks/IconCopyLink.77b762b4.js";function si(yt){let h;return{c(){h=li("Now that we learned the RL framework, how do we solve the RL problem?")},l(g){h=ai(g,"Now that we learned the RL framework, how do we solve the RL problem?")},m(g,H){l(g,h,H)},d(g){g&&e(h)}}}function oi(yt){let h,g,H,bt,f,w,ut,k,oe,at,he="Two main approaches for solving RL problems",xt,_,Tt,E,pe="In other words, how do we build an RL agent that can <strong>select the actions that maximize its expected cumulative reward?</strong>",Lt,v,y,ct,I,re,nt,ge="The Policy π: the agent’s brain",$t,A,fe="The Policy <strong>π</strong> is the <strong>brain of our Agent</strong>, it’s the function that tells us what <strong>action to take given the state we are in.</strong> So it <strong>defines the agent’s behavior</strong> at a given time.",Mt,R,ve='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_1.jpg" alt="Policy"/> <figcaption>Think of policy as the brain of our agent, the function that will tell us the action to take given a state</figcaption>',Ct,j,me="This Policy <strong>is the function we want to learn</strong>, our goal is to find the optimal policy π*, the policy that <strong>maximizes expected return</strong> when the agent acts according to it. We find this π* <strong>through training.</strong>",Pt,S,de="There are two approaches to train our agent to find this optimal policy π*:",Ht,G,we="<li><strong>Directly,</strong> by teaching the agent to learn which <strong>action to take,</strong> given the current state: <strong>Policy-Based Methods.</strong></li> <li>Indirectly, <strong>teach the agent to learn which state is more valuable</strong> and then take the action that <strong>leads to the more valuable states</strong>: Value-Based Methods.</li>",kt,m,b,ht,N,ue,st,_e="Policy-Based Methods",Et,U,ye="In Policy-Based methods, <strong>we learn a policy function directly.</strong>",It,V,be="This function will define a mapping from each state to the best corresponding action. Alternatively, it could define <strong>a probability distribution over the set of possible actions at that state.</strong>",At,B,xe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_2.jpg" alt="Policy"/> <figcaption>As we can see here, the policy (deterministic) <b>directly indicates the action to take for each step.</b></figcaption>',Rt,F,Te="We have two types of policies:",jt,q,Le="<li><em>Deterministic</em>: a policy at a given state <strong>will always return the same action.</strong></li>",St,z,$e='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_3.jpg" alt="Policy"/> <figcaption>action = policy(state)</figcaption>',Gt,x,Me,Nt,D,Ce="<li><em>Stochastic</em>: outputs <strong>a probability distribution over actions.</strong></li>",Ut,W,Pe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_5.jpg" alt="Policy"/> <figcaption>policy(actions | state) = probability distribution over the set of actions given the current state</figcaption>',Vt,J,He='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy-based.png" alt="Policy Based"/> <figcaption>Given an initial state, our stochastic policy will output probability distributions over the possible actions at that state.</figcaption>',Bt,O,ke="If we recap:",Ft,T,Ee,qt,L,Ie,zt,d,$,pt,K,ce,ot,Ae="Value-based methods",Dt,Q,Re="In value-based methods, instead of learning a policy function, we <strong>learn a value function</strong> that maps a state to the expected value <strong>of being at that state.</strong>",Wt,X,je="The value of a state is the <strong>expected discounted return</strong> the agent can get if it <strong>starts in that state, and then acts according to our policy.</strong>",Jt,Y,Se="“Act according to our policy” just means that our policy is <strong>“going to the state with the highest value”.</strong>",Ot,M,Ge,Kt,Z,Ne="Here we see that our value function <strong>defined values for each possible state.</strong>",Qt,tt,Ue='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/value_2.jpg" alt="Value based RL"/> <figcaption>Thanks to our value function, at each step our policy will select the state with the biggest value defined by the value function: -7, then -6, then -5 (and so on) to attain the goal.</figcaption>',Xt,et,Ve="Thanks to our value function, at each step our policy will select the state with the biggest value defined by the value function: -7, then -6, then -5 (and so on) to attain the goal.",Yt,it,Be="If we recap:",Zt,C,Fe,te,P,qe,ee,gt,ie;return k=new se({}),_=new ni({props:{$$slots:{default:[si]},$$scope:{ctx:yt}}}),I=new se({}),N=new se({}),K=new se({}),{c(){h=a("meta"),g=s(),H=a("p"),bt=s(),f=a("h1"),w=a("a"),ut=a("span"),ft(k.$$.fragment),oe=s(),at=a("span"),at.textContent=he,xt=s(),ft(_.$$.fragment),Tt=s(),E=a("p"),E.innerHTML=pe,Lt=s(),v=a("h2"),y=a("a"),ct=a("span"),ft(I.$$.fragment),re=s(),nt=a("span"),nt.textContent=ge,$t=s(),A=a("p"),A.innerHTML=fe,Mt=s(),R=a("figure"),R.innerHTML=ve,Ct=s(),j=a("p"),j.innerHTML=me,Pt=s(),S=a("p"),S.textContent=de,Ht=s(),G=a("ul"),G.innerHTML=we,kt=s(),m=a("h2"),b=a("a"),ht=a("span"),ft(N.$$.fragment),ue=s(),st=a("span"),st.textContent=_e,Et=s(),U=a("p"),U.innerHTML=ye,It=s(),V=a("p"),V.innerHTML=be,At=s(),B=a("figure"),B.innerHTML=xe,Rt=s(),F=a("p"),F.textContent=Te,jt=s(),q=a("ul"),q.innerHTML=Le,St=s(),z=a("figure"),z.innerHTML=$e,Gt=s(),x=a("img"),Nt=s(),D=a("ul"),D.innerHTML=Ce,Ut=s(),W=a("figure"),W.innerHTML=Pe,Vt=s(),J=a("figure"),J.innerHTML=He,Bt=s(),O=a("p"),O.textContent=ke,Ft=s(),T=a("img"),qt=s(),L=a("img"),zt=s(),d=a("h2"),$=a("a"),pt=a("span"),ft(K.$$.fragment),ce=s(),ot=a("span"),ot.textContent=Ae,Dt=s(),Q=a("p"),Q.innerHTML=Re,Wt=s(),X=a("p"),X.innerHTML=je,Jt=s(),Y=a("p"),Y.innerHTML=Se,Ot=s(),M=a("img"),Kt=s(),Z=a("p"),Z.innerHTML=Ne,Qt=s(),tt=a("figure"),tt.innerHTML=Ue,Xt=s(),et=a("p"),et.textContent=Ve,Yt=s(),it=a("p"),it.textContent=Be,Zt=s(),C=a("img"),te=s(),P=a("img"),ee=s(),gt=a("p"),this.h()},l(t){const i=ii("svelte-1phssyn",document.head);h=n(i,"META",{name:!0,content:!0}),i.forEach(e),g=o(t),H=n(t,"P",{}),p(H).forEach(e),bt=o(t),f=n(t,"H1",{class:!0});var lt=p(f);w=n(lt,"A",{id:!0,class:!0,href:!0});var ze=p(w);ut=n(ze,"SPAN",{});var De=p(ut);vt(k.$$.fragment,De),De.forEach(e),ze.forEach(e),oe=o(lt),at=n(lt,"SPAN",{"data-svelte-h":!0}),u(at)!=="svelte-1wg4ob5"&&(at.textContent=he),lt.forEach(e),xt=o(t),vt(_.$$.fragment,t),Tt=o(t),E=n(t,"P",{"data-svelte-h":!0}),u(E)!=="svelte-1poqzkt"&&(E.innerHTML=pe),Lt=o(t),v=n(t,"H2",{class:!0});var le=p(v);y=n(le,"A",{id:!0,class:!0,href:!0});var We=p(y);ct=n(We,"SPAN",{});var Je=p(ct);vt(I.$$.fragment,Je),Je.forEach(e),We.forEach(e),re=o(le),nt=n(le,"SPAN",{"data-svelte-h":!0}),u(nt)!=="svelte-1mk4oxw"&&(nt.textContent=ge),le.forEach(e),$t=o(t),A=n(t,"P",{"data-svelte-h":!0}),u(A)!=="svelte-1sury9w"&&(A.innerHTML=fe),Mt=o(t),R=n(t,"FIGURE",{"data-svelte-h":!0}),u(R)!=="svelte-wr9ae2"&&(R.innerHTML=ve),Ct=o(t),j=n(t,"P",{"data-svelte-h":!0}),u(j)!=="svelte-g271gb"&&(j.innerHTML=me),Pt=o(t),S=n(t,"P",{"data-svelte-h":!0}),u(S)!=="svelte-7rf0mi"&&(S.textContent=de),Ht=o(t),G=n(t,"UL",{"data-svelte-h":!0}),u(G)!=="svelte-1dvt8p7"&&(G.innerHTML=we),kt=o(t),m=n(t,"H2",{class:!0});var ae=p(m);b=n(ae,"A",{id:!0,class:!0,href:!0});var Oe=p(b);ht=n(Oe,"SPAN",{});var Ke=p(ht);vt(N.$$.fragment,Ke),Ke.forEach(e),Oe.forEach(e),ue=o(ae),st=n(ae,"SPAN",{"data-svelte-h":!0}),u(st)!=="svelte-14y417d"&&(st.textContent=_e),ae.forEach(e),Et=o(t),U=n(t,"P",{"data-svelte-h":!0}),u(U)!=="svelte-4zn9b3"&&(U.innerHTML=ye),It=o(t),V=n(t,"P",{"data-svelte-h":!0}),u(V)!=="svelte-oozyd0"&&(V.innerHTML=be),At=o(t),B=n(t,"FIGURE",{"data-svelte-h":!0}),u(B)!=="svelte-1m4eqa9"&&(B.innerHTML=xe),Rt=o(t),F=n(t,"P",{"data-svelte-h":!0}),u(F)!=="svelte-119iy72"&&(F.textContent=Te),jt=o(t),q=n(t,"UL",{"data-svelte-h":!0}),u(q)!=="svelte-h86bbg"&&(q.innerHTML=Le),St=o(t),z=n(t,"FIGURE",{"data-svelte-h":!0}),u(z)!=="svelte-15macrs"&&(z.innerHTML=$e),Gt=o(t),x=n(t,"IMG",{src:!0,alt:!0,width:!0}),Nt=o(t),D=n(t,"UL",{"data-svelte-h":!0}),u(D)!=="svelte-1q48317"&&(D.innerHTML=Ce),Ut=o(t),W=n(t,"FIGURE",{"data-svelte-h":!0}),u(W)!=="svelte-dxiuol"&&(W.innerHTML=Pe),Vt=o(t),J=n(t,"FIGURE",{"data-svelte-h":!0}),u(J)!=="svelte-120mc27"&&(J.innerHTML=He),Bt=o(t),O=n(t,"P",{"data-svelte-h":!0}),u(O)!=="svelte-1uwte4"&&(O.textContent=ke),Ft=o(t),T=n(t,"IMG",{src:!0,alt:!0,width:!0}),qt=o(t),L=n(t,"IMG",{src:!0,alt:!0,width:!0}),zt=o(t),d=n(t,"H2",{class:!0});var ne=p(d);$=n(ne,"A",{id:!0,class:!0,href:!0});var Qe=p($);pt=n(Qe,"SPAN",{});var Xe=p(pt);vt(K.$$.fragment,Xe),Xe.forEach(e),Qe.forEach(e),ce=o(ne),ot=n(ne,"SPAN",{"data-svelte-h":!0}),u(ot)!=="svelte-1t7tjsk"&&(ot.textContent=Ae),ne.forEach(e),Dt=o(t),Q=n(t,"P",{"data-svelte-h":!0}),u(Q)!=="svelte-v48g1w"&&(Q.innerHTML=Re),Wt=o(t),X=n(t,"P",{"data-svelte-h":!0}),u(X)!=="svelte-1wvuk6o"&&(X.innerHTML=je),Jt=o(t),Y=n(t,"P",{"data-svelte-h":!0}),u(Y)!=="svelte-1xwf190"&&(Y.innerHTML=Se),Ot=o(t),M=n(t,"IMG",{src:!0,alt:!0,width:!0}),Kt=o(t),Z=n(t,"P",{"data-svelte-h":!0}),u(Z)!=="svelte-19buk39"&&(Z.innerHTML=Ne),Qt=o(t),tt=n(t,"FIGURE",{"data-svelte-h":!0}),u(tt)!=="svelte-hm65hv"&&(tt.innerHTML=Ue),Xt=o(t),et=n(t,"P",{"data-svelte-h":!0}),u(et)!=="svelte-4bnt7i"&&(et.textContent=Ve),Yt=o(t),it=n(t,"P",{"data-svelte-h":!0}),u(it)!=="svelte-1uwte4"&&(it.textContent=Be),Zt=o(t),C=n(t,"IMG",{src:!0,alt:!0,width:!0}),te=o(t),P=n(t,"IMG",{src:!0,alt:!0,width:!0}),ee=o(t),gt=n(t,"P",{}),p(gt).forEach(e),this.h()},h(){r(h,"name","hf:doc:metadata"),r(h,"content",JSON.stringify(ri)),r(w,"id","two-methods"),r(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(w,"href","#two-methods"),r(f,"class","relative group"),r(y,"id","policy"),r(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(y,"href","#policy"),r(v,"class","relative group"),r(b,"id","policy-based"),r(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(b,"href","#policy-based"),r(m,"class","relative group"),rt(x.src,Me="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_4.jpg")||r(x,"src",Me),r(x,"alt","Policy"),r(x,"width","100%"),rt(T.src,Ee="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/pbm_1.jpg")||r(T,"src",Ee),r(T,"alt","Pbm recap"),r(T,"width","100%"),rt(L.src,Ie="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/pbm_2.jpg")||r(L,"src",Ie),r(L,"alt","Pbm recap"),r(L,"width","100%"),r($,"id","value-based"),r($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r($,"href","#value-based"),r(d,"class","relative group"),rt(M.src,Ge="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/value_1.jpg")||r(M,"src",Ge),r(M,"alt","Value based RL"),r(M,"width","100%"),rt(C.src,Fe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/vbm_1.jpg")||r(C,"src",Fe),r(C,"alt","Vbm recap"),r(C,"width","100%"),rt(P.src,qe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/vbm_2.jpg")||r(P,"src",qe),r(P,"alt","Vbm recap"),r(P,"width","100%")},m(t,i){c(document.head,h),l(t,g,i),l(t,H,i),l(t,bt,i),l(t,f,i),c(f,w),c(w,ut),mt(k,ut,null),c(f,oe),c(f,at),l(t,xt,i),mt(_,t,i),l(t,Tt,i),l(t,E,i),l(t,Lt,i),l(t,v,i),c(v,y),c(y,ct),mt(I,ct,null),c(v,re),c(v,nt),l(t,$t,i),l(t,A,i),l(t,Mt,i),l(t,R,i),l(t,Ct,i),l(t,j,i),l(t,Pt,i),l(t,S,i),l(t,Ht,i),l(t,G,i),l(t,kt,i),l(t,m,i),c(m,b),c(b,ht),mt(N,ht,null),c(m,ue),c(m,st),l(t,Et,i),l(t,U,i),l(t,It,i),l(t,V,i),l(t,At,i),l(t,B,i),l(t,Rt,i),l(t,F,i),l(t,jt,i),l(t,q,i),l(t,St,i),l(t,z,i),l(t,Gt,i),l(t,x,i),l(t,Nt,i),l(t,D,i),l(t,Ut,i),l(t,W,i),l(t,Vt,i),l(t,J,i),l(t,Bt,i),l(t,O,i),l(t,Ft,i),l(t,T,i),l(t,qt,i),l(t,L,i),l(t,zt,i),l(t,d,i),c(d,$),c($,pt),mt(K,pt,null),c(d,ce),c(d,ot),l(t,Dt,i),l(t,Q,i),l(t,Wt,i),l(t,X,i),l(t,Jt,i),l(t,Y,i),l(t,Ot,i),l(t,M,i),l(t,Kt,i),l(t,Z,i),l(t,Qt,i),l(t,tt,i),l(t,Xt,i),l(t,et,i),l(t,Yt,i),l(t,it,i),l(t,Zt,i),l(t,C,i),l(t,te,i),l(t,P,i),l(t,ee,i),l(t,gt,i),ie=!0},p(t,[i]){const lt={};i&2&&(lt.$$scope={dirty:i,ctx:t}),_.$set(lt)},i(t){ie||(dt(k.$$.fragment,t),dt(_.$$.fragment,t),dt(I.$$.fragment,t),dt(N.$$.fragment,t),dt(K.$$.fragment,t),ie=!0)},o(t){wt(k.$$.fragment,t),wt(_.$$.fragment,t),wt(I.$$.fragment,t),wt(N.$$.fragment,t),wt(K.$$.fragment,t),ie=!1},d(t){t&&(e(g),e(H),e(bt),e(f),e(xt),e(Tt),e(E),e(Lt),e(v),e($t),e(A),e(Mt),e(R),e(Ct),e(j),e(Pt),e(S),e(Ht),e(G),e(kt),e(m),e(Et),e(U),e(It),e(V),e(At),e(B),e(Rt),e(F),e(jt),e(q),e(St),e(z),e(Gt),e(x),e(Nt),e(D),e(Ut),e(W),e(Vt),e(J),e(Bt),e(O),e(Ft),e(T),e(qt),e(L),e(zt),e(d),e(Dt),e(Q),e(Wt),e(X),e(Jt),e(Y),e(Ot),e(M),e(Kt),e(Z),e(Qt),e(tt),e(Xt),e(et),e(Yt),e(it),e(Zt),e(C),e(te),e(P),e(ee),e(gt)),e(h),_t(k),_t(_,t),_t(I),_t(N),_t(K)}}}const ri={local:"two-methods",sections:[{local:"policy",title:"The Policy π: the agent’s brain "},{local:"policy-based",title:"Policy-Based Methods "},{local:"value-based",title:"Value-based methods "}],title:"Two main approaches for solving RL problems "};function ui(yt){return Ze(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class fi extends ti{constructor(h){super(),ei(this,h,ui,oi,Ye,{})}}export{fi as component};
