import{s as bt,n as At,o as Et}from"../chunks/scheduler.37c15a92.js";import{S as Lt,i as Pt,g as n,s,u as F,A as Tt,h as i,f as t,c as h,j as p,v as W,y as c,k as o,o as r,a as l,w as J,d as V,t as B,x as K}from"../chunks/index.b01106c0.js";import{I as Q}from"../chunks/IconCopyLink.77b762b4.js";function Ht(Ve){let u,fe,ie,de,f,x,le,E,Oe,X,Be="Glossary",ve,L,Ke="This is a community-created glossary. Contributions are welcomed!",ge,d,$,oe,P,ze,Y,Qe="Strategies to find the optimal policy",me,T,Xe="<li><strong>Policy-based methods.</strong> The policy is usually trained with a neural network to select what action to take given a state. In this case it is the neural network which outputs the action that the agent should take instead of using a value function. Depending on the experience received by the environment, the neural network will be re-adjusted and will provide better actions.</li> <li><strong>Value-based methods.</strong> In this case, a value function is trained to output the value of a state or a state-action pair that will represent our policy. However, this value doesn’t define what action the agent should take. In contrast, we need to specify the behavior of the agent given the output of the value function. For example, we could decide to adopt a policy to take the action that always leads to the biggest reward (Greedy Policy). In summary, the policy is a Greedy Policy (or whatever decision the user takes) that uses the values of the value-function to decide the actions to take.</li>",ye,v,_,re,H,je,Z,Ye="Among the value-based methods, we can find two main strategies",we,M,Ze="<li><strong>The state-value function.</strong> For each state, the state-value function is the expected return if the agent starts in that state and follows the policy until the end.</li> <li><strong>The action-value function.</strong> In contrast to the state-value function, the action-value calculates for each state and action pair the expected return if the agent starts in that state, takes that action, and then follows the policy forever after.</li>",xe,g,C,se,S,Re,ee,et="Epsilon-greedy strategy:",$e,N,tt="<li>Common strategy used in reinforcement learning that involves balancing exploration and exploitation.</li> <li>Chooses the action with the highest expected reward with a probability of 1-epsilon.</li> <li>Chooses a random action with a probability of epsilon.</li> <li>Epsilon is typically decreased over time to shift focus towards exploitation.</li>",_e,m,k,he,I,Fe,te,at="Greedy strategy:",Ce,U,nt="<li>Involves always choosing the action that is expected to lead to the highest reward, based on the current knowledge of the environment. (Only exploitation)</li> <li>Always chooses the action with the highest expected reward.</li> <li>Does not include any exploration.</li> <li>Can be disadvantageous in environments with uncertainty or unknown optimal actions.</li>",ke,y,b,pe,D,We,ae,it="Off-policy vs on-policy algorithms",be,q,lt="<li><strong>Off-policy algorithms:</strong> A different policy is used at training time and inference time</li> <li><strong>On-policy algorithms:</strong> The same policy is used during training and inference</li>",Ae,w,A,ce,G,Je,ne,ot="Monte Carlo and Temporal Difference learning strategies",Ee,O,rt="<li><p><strong>Monte Carlo (MC):</strong> Learning at the end of the episode. With Monte Carlo, we wait until the episode ends and then we update the value function (or policy function) from a complete episode.</p></li> <li><p><strong>Temporal Difference (TD):</strong> Learning at each step. With Temporal Difference Learning, we update the value function (or policy function) at each step without requiring a complete episode.</p></li>",Le,z,st='If you want to improve the course, you can <a href="https://github.com/huggingface/deep-rl-class/pulls" rel="nofollow">open a Pull Request.</a>',Pe,j,ht="This glossary was made possible thanks to:",Te,R,pt='<li><a href="https://github.com/ramon-rd" rel="nofollow">Ramón Rueda</a></li> <li><a href="https://github.com/hasarinduperera/" rel="nofollow">Hasarindu Perera</a></li> <li><a href="https://github.com/arkadyark/" rel="nofollow">Arkady Arkhangorodsky</a></li>',He,ue,Me;return E=new Q({}),P=new Q({}),H=new Q({}),S=new Q({}),I=new Q({}),D=new Q({}),G=new Q({}),{c(){u=n("meta"),fe=s(),ie=n("p"),de=s(),f=n("h1"),x=n("a"),le=n("span"),F(E.$$.fragment),Oe=s(),X=n("span"),X.textContent=Be,ve=s(),L=n("p"),L.textContent=Ke,ge=s(),d=n("h3"),$=n("a"),oe=n("span"),F(P.$$.fragment),ze=s(),Y=n("span"),Y.textContent=Qe,me=s(),T=n("ul"),T.innerHTML=Xe,ye=s(),v=n("h3"),_=n("a"),re=n("span"),F(H.$$.fragment),je=s(),Z=n("span"),Z.textContent=Ye,we=s(),M=n("ul"),M.innerHTML=Ze,xe=s(),g=n("h3"),C=n("a"),se=n("span"),F(S.$$.fragment),Re=s(),ee=n("span"),ee.textContent=et,$e=s(),N=n("ul"),N.innerHTML=tt,_e=s(),m=n("h3"),k=n("a"),he=n("span"),F(I.$$.fragment),Fe=s(),te=n("span"),te.textContent=at,Ce=s(),U=n("ul"),U.innerHTML=nt,ke=s(),y=n("h3"),b=n("a"),pe=n("span"),F(D.$$.fragment),We=s(),ae=n("span"),ae.textContent=it,be=s(),q=n("ul"),q.innerHTML=lt,Ae=s(),w=n("h3"),A=n("a"),ce=n("span"),F(G.$$.fragment),Je=s(),ne=n("span"),ne.textContent=ot,Ee=s(),O=n("ul"),O.innerHTML=rt,Le=s(),z=n("p"),z.innerHTML=st,Pe=s(),j=n("p"),j.textContent=ht,Te=s(),R=n("ul"),R.innerHTML=pt,He=s(),ue=n("p"),this.h()},l(e){const a=Tt("svelte-1phssyn",document.head);u=i(a,"META",{name:!0,content:!0}),a.forEach(t),fe=h(e),ie=i(e,"P",{}),p(ie).forEach(t),de=h(e),f=i(e,"H1",{class:!0});var Se=p(f);x=i(Se,"A",{id:!0,class:!0,href:!0});var ct=p(x);le=i(ct,"SPAN",{});var ut=p(le);W(E.$$.fragment,ut),ut.forEach(t),ct.forEach(t),Oe=h(Se),X=i(Se,"SPAN",{"data-svelte-h":!0}),c(X)!=="svelte-vhnccz"&&(X.textContent=Be),Se.forEach(t),ve=h(e),L=i(e,"P",{"data-svelte-h":!0}),c(L)!=="svelte-m5t86f"&&(L.textContent=Ke),ge=h(e),d=i(e,"H3",{class:!0});var Ne=p(d);$=i(Ne,"A",{id:!0,class:!0,href:!0});var ft=p($);oe=i(ft,"SPAN",{});var dt=p(oe);W(P.$$.fragment,dt),dt.forEach(t),ft.forEach(t),ze=h(Ne),Y=i(Ne,"SPAN",{"data-svelte-h":!0}),c(Y)!=="svelte-1yg59h1"&&(Y.textContent=Qe),Ne.forEach(t),me=h(e),T=i(e,"UL",{"data-svelte-h":!0}),c(T)!=="svelte-4zruja"&&(T.innerHTML=Xe),ye=h(e),v=i(e,"H3",{class:!0});var Ie=p(v);_=i(Ie,"A",{id:!0,class:!0,href:!0});var vt=p(_);re=i(vt,"SPAN",{});var gt=p(re);W(H.$$.fragment,gt),gt.forEach(t),vt.forEach(t),je=h(Ie),Z=i(Ie,"SPAN",{"data-svelte-h":!0}),c(Z)!=="svelte-1346d2g"&&(Z.textContent=Ye),Ie.forEach(t),we=h(e),M=i(e,"UL",{"data-svelte-h":!0}),c(M)!=="svelte-1wxmu8n"&&(M.innerHTML=Ze),xe=h(e),g=i(e,"H3",{class:!0});var Ue=p(g);C=i(Ue,"A",{id:!0,class:!0,href:!0});var mt=p(C);se=i(mt,"SPAN",{});var yt=p(se);W(S.$$.fragment,yt),yt.forEach(t),mt.forEach(t),Re=h(Ue),ee=i(Ue,"SPAN",{"data-svelte-h":!0}),c(ee)!=="svelte-1xnqfid"&&(ee.textContent=et),Ue.forEach(t),$e=h(e),N=i(e,"UL",{"data-svelte-h":!0}),c(N)!=="svelte-1hskw15"&&(N.innerHTML=tt),_e=h(e),m=i(e,"H3",{class:!0});var De=p(m);k=i(De,"A",{id:!0,class:!0,href:!0});var wt=p(k);he=i(wt,"SPAN",{});var xt=p(he);W(I.$$.fragment,xt),xt.forEach(t),wt.forEach(t),Fe=h(De),te=i(De,"SPAN",{"data-svelte-h":!0}),c(te)!=="svelte-1niij62"&&(te.textContent=at),De.forEach(t),Ce=h(e),U=i(e,"UL",{"data-svelte-h":!0}),c(U)!=="svelte-1o2on46"&&(U.innerHTML=nt),ke=h(e),y=i(e,"H3",{class:!0});var qe=p(y);b=i(qe,"A",{id:!0,class:!0,href:!0});var $t=p(b);pe=i($t,"SPAN",{});var _t=p(pe);W(D.$$.fragment,_t),_t.forEach(t),$t.forEach(t),We=h(qe),ae=i(qe,"SPAN",{"data-svelte-h":!0}),c(ae)!=="svelte-1g99xqw"&&(ae.textContent=it),qe.forEach(t),be=h(e),q=i(e,"UL",{"data-svelte-h":!0}),c(q)!=="svelte-y25p8z"&&(q.innerHTML=lt),Ae=h(e),w=i(e,"H3",{class:!0});var Ge=p(w);A=i(Ge,"A",{id:!0,class:!0,href:!0});var Ct=p(A);ce=i(Ct,"SPAN",{});var kt=p(ce);W(G.$$.fragment,kt),kt.forEach(t),Ct.forEach(t),Je=h(Ge),ne=i(Ge,"SPAN",{"data-svelte-h":!0}),c(ne)!=="svelte-1r1vt0e"&&(ne.textContent=ot),Ge.forEach(t),Ee=h(e),O=i(e,"UL",{"data-svelte-h":!0}),c(O)!=="svelte-192xlrh"&&(O.innerHTML=rt),Le=h(e),z=i(e,"P",{"data-svelte-h":!0}),c(z)!=="svelte-1p0vyzq"&&(z.innerHTML=st),Pe=h(e),j=i(e,"P",{"data-svelte-h":!0}),c(j)!=="svelte-1abantd"&&(j.textContent=ht),Te=h(e),R=i(e,"UL",{"data-svelte-h":!0}),c(R)!=="svelte-pt1fzv"&&(R.innerHTML=pt),He=h(e),ue=i(e,"P",{}),p(ue).forEach(t),this.h()},h(){o(u,"name","hf:doc:metadata"),o(u,"content",JSON.stringify(Mt)),o(x,"id","glossary"),o(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(x,"href","#glossary"),o(f,"class","relative group"),o($,"id","strategies-to-find-the-optimal-policy"),o($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o($,"href","#strategies-to-find-the-optimal-policy"),o(d,"class","relative group"),o(_,"id","among-the-valuebased-methods-we-can-find-two-main-strategies"),o(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(_,"href","#among-the-valuebased-methods-we-can-find-two-main-strategies"),o(v,"class","relative group"),o(C,"id","epsilongreedy-strategy"),o(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(C,"href","#epsilongreedy-strategy"),o(g,"class","relative group"),o(k,"id","greedy-strategy"),o(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(k,"href","#greedy-strategy"),o(m,"class","relative group"),o(b,"id","offpolicy-vs-onpolicy-algorithms"),o(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(b,"href","#offpolicy-vs-onpolicy-algorithms"),o(y,"class","relative group"),o(A,"id","monte-carlo-and-temporal-difference-learning-strategies"),o(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(A,"href","#monte-carlo-and-temporal-difference-learning-strategies"),o(w,"class","relative group")},m(e,a){r(document.head,u),l(e,fe,a),l(e,ie,a),l(e,de,a),l(e,f,a),r(f,x),r(x,le),J(E,le,null),r(f,Oe),r(f,X),l(e,ve,a),l(e,L,a),l(e,ge,a),l(e,d,a),r(d,$),r($,oe),J(P,oe,null),r(d,ze),r(d,Y),l(e,me,a),l(e,T,a),l(e,ye,a),l(e,v,a),r(v,_),r(_,re),J(H,re,null),r(v,je),r(v,Z),l(e,we,a),l(e,M,a),l(e,xe,a),l(e,g,a),r(g,C),r(C,se),J(S,se,null),r(g,Re),r(g,ee),l(e,$e,a),l(e,N,a),l(e,_e,a),l(e,m,a),r(m,k),r(k,he),J(I,he,null),r(m,Fe),r(m,te),l(e,Ce,a),l(e,U,a),l(e,ke,a),l(e,y,a),r(y,b),r(b,pe),J(D,pe,null),r(y,We),r(y,ae),l(e,be,a),l(e,q,a),l(e,Ae,a),l(e,w,a),r(w,A),r(A,ce),J(G,ce,null),r(w,Je),r(w,ne),l(e,Ee,a),l(e,O,a),l(e,Le,a),l(e,z,a),l(e,Pe,a),l(e,j,a),l(e,Te,a),l(e,R,a),l(e,He,a),l(e,ue,a),Me=!0},p:At,i(e){Me||(V(E.$$.fragment,e),V(P.$$.fragment,e),V(H.$$.fragment,e),V(S.$$.fragment,e),V(I.$$.fragment,e),V(D.$$.fragment,e),V(G.$$.fragment,e),Me=!0)},o(e){B(E.$$.fragment,e),B(P.$$.fragment,e),B(H.$$.fragment,e),B(S.$$.fragment,e),B(I.$$.fragment,e),B(D.$$.fragment,e),B(G.$$.fragment,e),Me=!1},d(e){e&&(t(fe),t(ie),t(de),t(f),t(ve),t(L),t(ge),t(d),t(me),t(T),t(ye),t(v),t(we),t(M),t(xe),t(g),t($e),t(N),t(_e),t(m),t(Ce),t(U),t(ke),t(y),t(be),t(q),t(Ae),t(w),t(Ee),t(O),t(Le),t(z),t(Pe),t(j),t(Te),t(R),t(He),t(ue)),t(u),K(E),K(P),K(H),K(S),K(I),K(D),K(G)}}}const Mt={local:"glossary",sections:[{local:"strategies-to-find-the-optimal-policy",title:"Strategies to find the optimal policy"},{local:"among-the-valuebased-methods-we-can-find-two-main-strategies",title:"Among the value-based methods, we can find two main strategies"},{local:"epsilongreedy-strategy",title:"Epsilon-greedy strategy:"},{local:"greedy-strategy",title:"Greedy strategy:"},{local:"offpolicy-vs-onpolicy-algorithms",title:"Off-policy vs on-policy algorithms"},{local:"monte-carlo-and-temporal-difference-learning-strategies",title:"Monte Carlo and Temporal Difference learning strategies"}],title:"Glossary "};function St(Ve){return Et(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Dt extends Lt{constructor(u){super(),Pt(this,u,St,Ht,bt,{})}}export{Dt as component};
