import{s as sa,f as c,n as aa,o as na}from"../chunks/scheduler.37c15a92.js";import{S as la,i as ia,g as n,s as r,u as T,m as _t,H as es,A as ra,h as l,f as e,c as p,j as m,v as z,y as h,n as yt,B as ss,k as i,o,a,w as L,d as H,t as G,x as N}from"../chunks/index.b01106c0.js";import{I as Q}from"../chunks/IconCopyLink.77b762b4.js";function pa(as){let g,jt,Pt,Rt,u,$,It,q,Be,$t,ns="A Q-Learning example",Bt,j,ls="To better understand Q-Learning, let’s take a simple example:",Ut,R,is,Ot,B,rs="<li>You’re a mouse in this tiny maze. You always <strong>start at the same starting point.</strong></li> <li>The goal is <strong>to eat the big pile of cheese at the bottom right-hand corner</strong> and avoid the poison. After all, who doesn’t like cheese?</li> <li>The episode ends if we eat the poison, <strong>eat the big pile of cheese</strong>, or if we take more than five steps.</li> <li>The learning rate is 0.1</li> <li>The discount rate (gamma) is 0.99</li>",Wt,U,ps,Yt,O,os="The reward function goes like this:",Dt,W,ms="<li><strong>+0:</strong> Going to a state with no cheese in it.</li> <li><strong>+1:</strong> Going to a state with a small cheese in it.</li> <li><strong>+10:</strong> Going to the state with the big pile of cheese.</li> <li><strong>-10:</strong> Going to the state with the poison and thus dying.</li> <li><strong>+0</strong> If we take more than five steps.</li>",Jt,Y,hs,Ft,D,cs="To train our agent to have an optimal policy (so a policy that goes right, right, down), <strong>we will use the Q-Learning algorithm</strong>.",Kt,v,C,Tt,J,Ue,Ct,gs="Step 1: Initialize the Q-table",Vt,F,us,Xt,K,vs="So, for now, <strong>our Q-table is useless</strong>; we need <strong>to train our Q-function using the Q-Learning algorithm.</strong>",Zt,V,fs="Let’s do it for 2 training timesteps:",te,X,ds="Training timestep 1:",ee,f,b,zt,Z,Oe,bt,xs="Step 2: Choose an action using the Epsilon Greedy Strategy",se,tt,ws="Because epsilon is big (= 1.0), I take a random action. In this case, I go right.",ae,et,_s,ne,d,S,Lt,st,We,St,ys="Step 3: Perform action At, get Rt+1 and St+1",le,E,Ye,ie,Zs='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mn>1</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = 1</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',re,pe,at,$s,oe,x,M,Ht,nt,De,Et,Cs="Step 4: Update Q(St, At)",me,k,Je,he,ta='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q(S_t, A_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ce,ge,lt,bs,ue,it,Ss,ve,rt,Es="Training timestep 2:",fe,w,A,Gt,pt,Fe,Mt,Ms="Step 2: Choose an action using the Epsilon Greedy Strategy",de,ot,ks="<strong>I take a random action again, since epsilon=0.99 is big</strong>. (Notice we decay epsilon a little bit because, as the training progress, we want less and less exploration).",xe,mt,As="I took the action ‘down’. <strong>This is not a good action since it leads me to the poison.</strong>",we,ht,Ps,_e,_,P,Nt,ct,Ke,kt,Is="Step 3: Perform action At, get Rt+1 and St+1",ye,gt,Ve,ut,Xe,$e,ea='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mo>−</mo><mn>10</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = -10</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">−</span><span class="mord">10</span></span></span></span>',Ce,be,vt,Ts,Se,y,I,Qt,ft,Ze,At,zs="Step 4: Update Q(St, At)",Ee,dt,Ls,Me,xt,Hs="Because we’re dead, we start a new episode. But what we see here is that, <strong>with two explorations steps, my agent became smarter.</strong>",ke,wt,Gs="As we continue exploring and exploiting the environment and updating Q-values using the TD target, the <strong>Q-table will give us a better and better approximation. At the end of the training, we’ll get an estimate of the optimal Q-function.</strong>",Ae,qt,Pe;return q=new Q({}),J=new Q({}),Z=new Q({}),st=new Q({}),nt=new Q({}),pt=new Q({}),ct=new Q({}),ft=new Q({}),{c(){g=n("meta"),jt=r(),Pt=n("p"),Rt=r(),u=n("h1"),$=n("a"),It=n("span"),T(q.$$.fragment),Be=r(),$t=n("span"),$t.textContent=ns,Bt=r(),j=n("p"),j.textContent=ls,Ut=r(),R=n("img"),Ot=r(),B=n("ul"),B.innerHTML=rs,Wt=r(),U=n("img"),Yt=r(),O=n("p"),O.textContent=os,Dt=r(),W=n("ul"),W.innerHTML=ms,Jt=r(),Y=n("img"),Ft=r(),D=n("p"),D.innerHTML=cs,Kt=r(),v=n("h2"),C=n("a"),Tt=n("span"),T(J.$$.fragment),Ue=r(),Ct=n("span"),Ct.textContent=gs,Vt=r(),F=n("img"),Xt=r(),K=n("p"),K.innerHTML=vs,Zt=r(),V=n("p"),V.textContent=fs,te=r(),X=n("p"),X.textContent=ds,ee=r(),f=n("h2"),b=n("a"),zt=n("span"),T(Z.$$.fragment),Oe=r(),bt=n("span"),bt.textContent=xs,se=r(),tt=n("p"),tt.textContent=ws,ae=r(),et=n("img"),ne=r(),d=n("h2"),S=n("a"),Lt=n("span"),T(st.$$.fragment),We=r(),St=n("span"),St.textContent=ys,le=r(),E=n("p"),Ye=_t("By going right, I get a small cheese, so "),ie=new es(!1),re=_t(" and I’m in a new state."),pe=r(),at=n("img"),oe=r(),x=n("h2"),M=n("a"),Ht=n("span"),T(nt.$$.fragment),De=r(),Et=n("span"),Et.textContent=Cs,me=r(),k=n("p"),Je=_t("We can now update "),he=new es(!1),ce=_t(" using our formula."),ge=r(),lt=n("img"),ue=r(),it=n("img"),ve=r(),rt=n("p"),rt.textContent=Es,fe=r(),w=n("h2"),A=n("a"),Gt=n("span"),T(pt.$$.fragment),Fe=r(),Mt=n("span"),Mt.textContent=Ms,de=r(),ot=n("p"),ot.innerHTML=ks,xe=r(),mt=n("p"),mt.innerHTML=As,we=r(),ht=n("img"),_e=r(),_=n("h2"),P=n("a"),Nt=n("span"),T(ct.$$.fragment),Ke=r(),kt=n("span"),kt.textContent=Is,ye=r(),gt=n("p"),Ve=_t("Because I ate poison, "),ut=n("strong"),Xe=_t("I get "),$e=new es(!1),Ce=_t(", and I die."),be=r(),vt=n("img"),Se=r(),y=n("h2"),I=n("a"),Qt=n("span"),T(ft.$$.fragment),Ze=r(),At=n("span"),At.textContent=zs,Ee=r(),dt=n("img"),Me=r(),xt=n("p"),xt.innerHTML=Hs,ke=r(),wt=n("p"),wt.innerHTML=Gs,Ae=r(),qt=n("p"),this.h()},l(t){const s=ra("svelte-1phssyn",document.head);g=l(s,"META",{name:!0,content:!0}),s.forEach(e),jt=p(t),Pt=l(t,"P",{}),m(Pt).forEach(e),Rt=p(t),u=l(t,"H1",{class:!0});var Ie=m(u);$=l(Ie,"A",{id:!0,class:!0,href:!0});var Ns=m($);It=l(Ns,"SPAN",{});var Qs=m(It);z(q.$$.fragment,Qs),Qs.forEach(e),Ns.forEach(e),Be=p(Ie),$t=l(Ie,"SPAN",{"data-svelte-h":!0}),h($t)!=="svelte-kgq0ru"&&($t.textContent=ns),Ie.forEach(e),Bt=p(t),j=l(t,"P",{"data-svelte-h":!0}),h(j)!=="svelte-9fmuny"&&(j.textContent=ls),Ut=p(t),R=l(t,"IMG",{src:!0,alt:!0}),Ot=p(t),B=l(t,"UL",{"data-svelte-h":!0}),h(B)!=="svelte-n6lz09"&&(B.innerHTML=rs),Wt=p(t),U=l(t,"IMG",{src:!0,alt:!0}),Yt=p(t),O=l(t,"P",{"data-svelte-h":!0}),h(O)!=="svelte-dok1jh"&&(O.textContent=os),Dt=p(t),W=l(t,"UL",{"data-svelte-h":!0}),h(W)!=="svelte-93cdg2"&&(W.innerHTML=ms),Jt=p(t),Y=l(t,"IMG",{src:!0,alt:!0}),Ft=p(t),D=l(t,"P",{"data-svelte-h":!0}),h(D)!=="svelte-pbs6nn"&&(D.innerHTML=cs),Kt=p(t),v=l(t,"H2",{class:!0});var Te=m(v);C=l(Te,"A",{id:!0,class:!0,href:!0});var qs=m(C);Tt=l(qs,"SPAN",{});var js=m(Tt);z(J.$$.fragment,js),js.forEach(e),qs.forEach(e),Ue=p(Te),Ct=l(Te,"SPAN",{"data-svelte-h":!0}),h(Ct)!=="svelte-14qwd0r"&&(Ct.textContent=gs),Te.forEach(e),Vt=p(t),F=l(t,"IMG",{src:!0,alt:!0}),Xt=p(t),K=l(t,"P",{"data-svelte-h":!0}),h(K)!=="svelte-9m32nr"&&(K.innerHTML=vs),Zt=p(t),V=l(t,"P",{"data-svelte-h":!0}),h(V)!=="svelte-29jh6q"&&(V.textContent=fs),te=p(t),X=l(t,"P",{"data-svelte-h":!0}),h(X)!=="svelte-51ll5c"&&(X.textContent=ds),ee=p(t),f=l(t,"H2",{class:!0});var ze=m(f);b=l(ze,"A",{id:!0,class:!0,href:!0});var Rs=m(b);zt=l(Rs,"SPAN",{});var Bs=m(zt);z(Z.$$.fragment,Bs),Bs.forEach(e),Rs.forEach(e),Oe=p(ze),bt=l(ze,"SPAN",{"data-svelte-h":!0}),h(bt)!=="svelte-11rpcb"&&(bt.textContent=xs),ze.forEach(e),se=p(t),tt=l(t,"P",{"data-svelte-h":!0}),h(tt)!=="svelte-1hg390z"&&(tt.textContent=ws),ae=p(t),et=l(t,"IMG",{src:!0,alt:!0}),ne=p(t),d=l(t,"H2",{class:!0});var Le=m(d);S=l(Le,"A",{id:!0,class:!0,href:!0});var Us=m(S);Lt=l(Us,"SPAN",{});var Os=m(Lt);z(st.$$.fragment,Os),Os.forEach(e),Us.forEach(e),We=p(Le),St=l(Le,"SPAN",{"data-svelte-h":!0}),h(St)!=="svelte-1ppand8"&&(St.textContent=ys),Le.forEach(e),le=p(t),E=l(t,"P",{});var He=m(E);Ye=yt(He,"By going right, I get a small cheese, so "),ie=ss(He,!1),re=yt(He," and I’m in a new state."),He.forEach(e),pe=p(t),at=l(t,"IMG",{src:!0,alt:!0}),oe=p(t),x=l(t,"H2",{class:!0});var Ge=m(x);M=l(Ge,"A",{id:!0,class:!0,href:!0});var Ws=m(M);Ht=l(Ws,"SPAN",{});var Ys=m(Ht);z(nt.$$.fragment,Ys),Ys.forEach(e),Ws.forEach(e),De=p(Ge),Et=l(Ge,"SPAN",{"data-svelte-h":!0}),h(Et)!=="svelte-dskxu"&&(Et.textContent=Cs),Ge.forEach(e),me=p(t),k=l(t,"P",{});var Ne=m(k);Je=yt(Ne,"We can now update "),he=ss(Ne,!1),ce=yt(Ne," using our formula."),Ne.forEach(e),ge=p(t),lt=l(t,"IMG",{src:!0,alt:!0}),ue=p(t),it=l(t,"IMG",{src:!0,alt:!0}),ve=p(t),rt=l(t,"P",{"data-svelte-h":!0}),h(rt)!=="svelte-120ic1h"&&(rt.textContent=Es),fe=p(t),w=l(t,"H2",{class:!0});var Qe=m(w);A=l(Qe,"A",{id:!0,class:!0,href:!0});var Ds=m(A);Gt=l(Ds,"SPAN",{});var Js=m(Gt);z(pt.$$.fragment,Js),Js.forEach(e),Ds.forEach(e),Fe=p(Qe),Mt=l(Qe,"SPAN",{"data-svelte-h":!0}),h(Mt)!=="svelte-11rpcb"&&(Mt.textContent=Ms),Qe.forEach(e),de=p(t),ot=l(t,"P",{"data-svelte-h":!0}),h(ot)!=="svelte-14kapt5"&&(ot.innerHTML=ks),xe=p(t),mt=l(t,"P",{"data-svelte-h":!0}),h(mt)!=="svelte-7qp2oa"&&(mt.innerHTML=As),we=p(t),ht=l(t,"IMG",{src:!0,alt:!0}),_e=p(t),_=l(t,"H2",{class:!0});var qe=m(_);P=l(qe,"A",{id:!0,class:!0,href:!0});var Fs=m(P);Nt=l(Fs,"SPAN",{});var Ks=m(Nt);z(ct.$$.fragment,Ks),Ks.forEach(e),Fs.forEach(e),Ke=p(qe),kt=l(qe,"SPAN",{"data-svelte-h":!0}),h(kt)!=="svelte-1ppand8"&&(kt.textContent=Is),qe.forEach(e),ye=p(t),gt=l(t,"P",{});var ts=m(gt);Ve=yt(ts,"Because I ate poison, "),ut=l(ts,"STRONG",{});var je=m(ut);Xe=yt(je,"I get "),$e=ss(je,!1),Ce=yt(je,", and I die."),je.forEach(e),ts.forEach(e),be=p(t),vt=l(t,"IMG",{src:!0,alt:!0}),Se=p(t),y=l(t,"H2",{class:!0});var Re=m(y);I=l(Re,"A",{id:!0,class:!0,href:!0});var Vs=m(I);Qt=l(Vs,"SPAN",{});var Xs=m(Qt);z(ft.$$.fragment,Xs),Xs.forEach(e),Vs.forEach(e),Ze=p(Re),At=l(Re,"SPAN",{"data-svelte-h":!0}),h(At)!=="svelte-dskxu"&&(At.textContent=zs),Re.forEach(e),Ee=p(t),dt=l(t,"IMG",{src:!0,alt:!0}),Me=p(t),xt=l(t,"P",{"data-svelte-h":!0}),h(xt)!=="svelte-1heq24d"&&(xt.innerHTML=Hs),ke=p(t),wt=l(t,"P",{"data-svelte-h":!0}),h(wt)!=="svelte-1eluo1b"&&(wt.innerHTML=Gs),Ae=p(t),qt=l(t,"P",{}),m(qt).forEach(e),this.h()},h(){i(g,"name","hf:doc:metadata"),i(g,"content",JSON.stringify(oa)),i($,"id","q-learning-example"),i($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i($,"href","#q-learning-example"),i(u,"class","relative group"),c(R.src,is="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-Example-2.jpg")||i(R,"src",is),i(R,"alt","Maze-Example"),c(U.src,ps="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-1.jpg")||i(U,"src",ps),i(U,"alt","Maze-Example"),c(Y.src,hs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-2.jpg")||i(Y,"src",hs),i(Y,"alt","Maze-Example"),i(C,"id","step1"),i(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(C,"href","#step1"),i(v,"class","relative group"),c(F.src,us="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Example-1.jpg")||i(F,"src",us),i(F,"alt","Maze-Example"),i(b,"id","step2"),i(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(b,"href","#step2"),i(f,"class","relative group"),c(et.src,_s="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-3.jpg")||i(et,"src",_s),i(et,"alt","Maze-Example"),i(S,"id","step3"),i(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(S,"href","#step3"),i(d,"class","relative group"),ie.a=re,c(at.src,$s="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-4.jpg")||i(at,"src",$s),i(at,"alt","Maze-Example"),i(M,"id","step4"),i(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(M,"href","#step4"),i(x,"class","relative group"),he.a=ce,c(lt.src,bs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-5.jpg")||i(lt,"src",bs),i(lt,"alt","Maze-Example"),c(it.src,Ss="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Example-4.jpg")||i(it,"src",Ss),i(it,"alt","Maze-Example"),i(A,"id","step2-2"),i(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(A,"href","#step2-2"),i(w,"class","relative group"),c(ht.src,Ps="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-6.jpg")||i(ht,"src",Ps),i(ht,"alt","Maze-Example"),i(P,"id","step3-3"),i(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(P,"href","#step3-3"),i(_,"class","relative group"),$e.a=Ce,c(vt.src,Ts="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-7.jpg")||i(vt,"src",Ts),i(vt,"alt","Maze-Example"),i(I,"id","step4-4"),i(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(I,"href","#step4-4"),i(y,"class","relative group"),c(dt.src,Ls="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-8.jpg")||i(dt,"src",Ls),i(dt,"alt","Maze-Example")},m(t,s){o(document.head,g),a(t,jt,s),a(t,Pt,s),a(t,Rt,s),a(t,u,s),o(u,$),o($,It),L(q,It,null),o(u,Be),o(u,$t),a(t,Bt,s),a(t,j,s),a(t,Ut,s),a(t,R,s),a(t,Ot,s),a(t,B,s),a(t,Wt,s),a(t,U,s),a(t,Yt,s),a(t,O,s),a(t,Dt,s),a(t,W,s),a(t,Jt,s),a(t,Y,s),a(t,Ft,s),a(t,D,s),a(t,Kt,s),a(t,v,s),o(v,C),o(C,Tt),L(J,Tt,null),o(v,Ue),o(v,Ct),a(t,Vt,s),a(t,F,s),a(t,Xt,s),a(t,K,s),a(t,Zt,s),a(t,V,s),a(t,te,s),a(t,X,s),a(t,ee,s),a(t,f,s),o(f,b),o(b,zt),L(Z,zt,null),o(f,Oe),o(f,bt),a(t,se,s),a(t,tt,s),a(t,ae,s),a(t,et,s),a(t,ne,s),a(t,d,s),o(d,S),o(S,Lt),L(st,Lt,null),o(d,We),o(d,St),a(t,le,s),a(t,E,s),o(E,Ye),ie.m(Zs,E),o(E,re),a(t,pe,s),a(t,at,s),a(t,oe,s),a(t,x,s),o(x,M),o(M,Ht),L(nt,Ht,null),o(x,De),o(x,Et),a(t,me,s),a(t,k,s),o(k,Je),he.m(ta,k),o(k,ce),a(t,ge,s),a(t,lt,s),a(t,ue,s),a(t,it,s),a(t,ve,s),a(t,rt,s),a(t,fe,s),a(t,w,s),o(w,A),o(A,Gt),L(pt,Gt,null),o(w,Fe),o(w,Mt),a(t,de,s),a(t,ot,s),a(t,xe,s),a(t,mt,s),a(t,we,s),a(t,ht,s),a(t,_e,s),a(t,_,s),o(_,P),o(P,Nt),L(ct,Nt,null),o(_,Ke),o(_,kt),a(t,ye,s),a(t,gt,s),o(gt,Ve),o(gt,ut),o(ut,Xe),$e.m(ea,ut),o(ut,Ce),a(t,be,s),a(t,vt,s),a(t,Se,s),a(t,y,s),o(y,I),o(I,Qt),L(ft,Qt,null),o(y,Ze),o(y,At),a(t,Ee,s),a(t,dt,s),a(t,Me,s),a(t,xt,s),a(t,ke,s),a(t,wt,s),a(t,Ae,s),a(t,qt,s),Pe=!0},p:aa,i(t){Pe||(H(q.$$.fragment,t),H(J.$$.fragment,t),H(Z.$$.fragment,t),H(st.$$.fragment,t),H(nt.$$.fragment,t),H(pt.$$.fragment,t),H(ct.$$.fragment,t),H(ft.$$.fragment,t),Pe=!0)},o(t){G(q.$$.fragment,t),G(J.$$.fragment,t),G(Z.$$.fragment,t),G(st.$$.fragment,t),G(nt.$$.fragment,t),G(pt.$$.fragment,t),G(ct.$$.fragment,t),G(ft.$$.fragment,t),Pe=!1},d(t){t&&(e(jt),e(Pt),e(Rt),e(u),e(Bt),e(j),e(Ut),e(R),e(Ot),e(B),e(Wt),e(U),e(Yt),e(O),e(Dt),e(W),e(Jt),e(Y),e(Ft),e(D),e(Kt),e(v),e(Vt),e(F),e(Xt),e(K),e(Zt),e(V),e(te),e(X),e(ee),e(f),e(se),e(tt),e(ae),e(et),e(ne),e(d),e(le),e(E),e(pe),e(at),e(oe),e(x),e(me),e(k),e(ge),e(lt),e(ue),e(it),e(ve),e(rt),e(fe),e(w),e(de),e(ot),e(xe),e(mt),e(we),e(ht),e(_e),e(_),e(ye),e(gt),e(be),e(vt),e(Se),e(y),e(Ee),e(dt),e(Me),e(xt),e(ke),e(wt),e(Ae),e(qt)),e(g),N(q),N(J),N(Z),N(st),N(nt),N(pt),N(ct),N(ft)}}}const oa={local:"q-learning-example",sections:[{local:"step1",title:"Step 1: Initialize the Q-table "},{local:"step2",title:"Step 2: Choose an action using the Epsilon Greedy Strategy "},{local:"step3",title:"Step 3: Perform action At, get Rt+1 and St+1 "},{local:"step4",title:"Step 4: Update Q(St, At) "},{local:"step2-2",title:"Step 2: Choose an action using the Epsilon Greedy Strategy "},{local:"step3-3",title:"Step 3: Perform action At, get Rt+1 and St+1 "},{local:"step4-4",title:"Step 4: Update Q(St, At) "}],title:"A Q-Learning example "};function ma(as){return na(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ua extends la{constructor(g){super(),ia(this,g,ma,pa,sa,{})}}export{ua as component};
