import{s as Ha,f as ft,o as $a}from"../chunks/scheduler.37c15a92.js";import{S as Pa,i as Ea,g as n,s as i,u as ye,m as v,H as yt,A as Sa,h as l,f as e,c as o,j as c,v as xe,y as r,n as g,B as xt,k as u,o as p,a as s,w as _e,d as be,t as Me,x as Te}from"../chunks/index.b01106c0.js";import{T as Ia}from"../chunks/Tip.47ade202.js";import{I as qe}from"../chunks/IconCopyLink.77b762b4.js";function Aa(_t){let h;return{c(){h=v("But what does it mean to act according to our policy? After all, we don't have a policy in value-based methods since we train a value function and not a policy.")},l(f){h=g(f,"But what does it mean to act according to our policy? After all, we don't have a policy in value-based methods since we train a value function and not a policy.")},m(f,C){s(f,h,C)},d(f){f&&e(h)}}}function Ga(_t){let h,f,C,bt,d,x,vt,k,Le,rt,ze="Two types of value-based methods",Mt,H,Ne="In value-based methods, <strong>we learn a value function</strong> that <strong>maps a state to the expected value of being at that state.</strong>",Tt,$,Re,Lt,P,Fe="The value of a state is the <strong>expected discounted return</strong> the agent can get if it <strong>starts at that state and then acts according to our policy.</strong>",Ct,_,kt,E,Ue="Remember that the goal of an <strong>RL agent is to have an optimal policy π*.</strong>",Ht,S,Be="To find the optimal policy, we learned about two different methods:",$t,I,Oe="<li><em>Policy-based methods:</em> <strong>Directly train the policy</strong> to select what action to take given a state (or a probability distribution over actions at that state). In this case, we <strong>don’t have a value function.</strong></li>",Pt,A,Ve,Et,G,We="The policy takes a state as input and outputs what action to take at that state (deterministic policy: a policy that output one action given a state, contrary to stochastic policy that output a probability distribution over actions).",St,j,Qe="And consequently, <strong>we don’t define by hand the behavior of our policy; it’s the training that will define it.</strong>",It,q,De="<li><em>Value-based methods:</em> <strong>Indirectly, by training a value function</strong> that outputs the value of a state or a state-action pair. Given this value function, our policy <strong>will take an action.</strong></li>",At,z,Je="Since the policy is not trained/learned, <strong>we need to specify its behavior.</strong> For instance, if we want a policy that, given the value function, will take actions that always lead to the biggest reward, <strong>we’ll create a Greedy Policy.</strong>",Gt,N,Ke='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-approaches-3.jpg" alt="Two RL approaches"/> <figcaption>Given a state, our action-value function (that we train) outputs the value of each action at that state. Then, our pre-defined Greedy Policy selects the action that will yield the highest value given a state or a state action pair.</figcaption>',jt,R,Xe="Consequently, whatever method you use to solve your problem, <strong>you will have a policy</strong>. In the case of value-based methods, you don’t train the policy: your policy <strong>is just a simple pre-specified function</strong> (for instance, the Greedy Policy) that uses the values given by the value-function to select its actions.",qt,F,Ye="So the difference is:",zt,U,Ze="<li>In policy-based training, <strong>the optimal policy (denoted π*) is found by training the policy directly.</strong></li> <li>In value-based training, <strong>finding an optimal value function (denoted Q* or V*, we’ll study the difference below) leads to having an optimal policy.</strong></li>",Nt,B,ta,Rt,O,ea="In fact, most of the time, in value-based methods, you’ll use <strong>an Epsilon-Greedy Policy</strong> that handles the exploration/exploitation trade-off; we’ll talk about this when we talk about Q-Learning in the second part of this unit.",Ft,V,aa="As we mentioned above, we have two types of value-based functions:",Ut,w,b,gt,W,Ce,pt,sa="The state-value function",Bt,Q,na="We write the state value function under a policy π like this:",Ot,D,la,Vt,J,ia="For each state, the state-value function outputs the expected return if the agent <strong>starts at that state</strong> and then follows the policy forever afterward (for all future timesteps, if you prefer).",Wt,K,oa='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/state-value-function-2.jpg" alt="State value function"/> <figcaption>If we take the state with value -7: it&#39;s the expected return starting at that state and taking actions according to our policy (greedy policy), so right, right, right, down, down, right, right.</figcaption>',Qt,y,M,dt,X,ke,ut,ra="The action-value function",Dt,Y,pa="In the action-value function, for each state and action pair, the action-value function <strong>outputs the expected return</strong> if the agent starts in that state, takes that action, and then follows the policy forever after.",Jt,m,He,Kt,Ma='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>a</mi></mrow><annotation encoding="application/x-tex">a</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">a</span></span></span></span>',Xt,Yt,Ta='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>s</mi></mrow><annotation encoding="application/x-tex">s</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">s</span></span></span></span>',Zt,te,La='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">π</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',ee,ae,Z,ua,se,tt,ca,ne,et,ha="We see that the difference is:",le,T,ct,$e,ht,Pe,ie,Ca='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">S_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ee,mt,Se,at,Ie,oe,ka='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">S_t, A_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8778em;vertical-align:-0.1944em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',re,pe,st,ma='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-types.jpg" alt="Two types of value function"/> <figcaption>Note: We didn&#39;t fill all the state-action pairs for the example of Action-value function</figcaption>',ue,nt,fa="In either case, whichever value function we choose (state-value or action-value function), <strong>the returned value is the expected return.</strong>",ce,lt,va="However, the problem is that <strong>to calculate EACH value of a state or a state-action pair, we need to sum all the rewards an agent can get if it starts at that state.</strong>",he,it,ga="This can be a computationally expensive process, and that’s <strong>where the Bellman equation comes in to help us.</strong>",me,wt,fe;return k=new qe({}),_=new Ia({props:{$$slots:{default:[Aa]},$$scope:{ctx:_t}}}),W=new qe({}),X=new qe({}),{c(){h=n("meta"),f=i(),C=n("p"),bt=i(),d=n("h1"),x=n("a"),vt=n("span"),ye(k.$$.fragment),Le=i(),rt=n("span"),rt.textContent=ze,Mt=i(),H=n("p"),H.innerHTML=Ne,Tt=i(),$=n("img"),Lt=i(),P=n("p"),P.innerHTML=Fe,Ct=i(),ye(_.$$.fragment),kt=i(),E=n("p"),E.innerHTML=Ue,Ht=i(),S=n("p"),S.textContent=Be,$t=i(),I=n("ul"),I.innerHTML=Oe,Pt=i(),A=n("img"),Et=i(),G=n("p"),G.textContent=We,St=i(),j=n("p"),j.innerHTML=Qe,It=i(),q=n("ul"),q.innerHTML=De,At=i(),z=n("p"),z.innerHTML=Je,Gt=i(),N=n("figure"),N.innerHTML=Ke,jt=i(),R=n("p"),R.innerHTML=Xe,qt=i(),F=n("p"),F.textContent=Ye,zt=i(),U=n("ul"),U.innerHTML=Ze,Nt=i(),B=n("img"),Rt=i(),O=n("p"),O.innerHTML=ea,Ft=i(),V=n("p"),V.textContent=aa,Ut=i(),w=n("h2"),b=n("a"),gt=n("span"),ye(W.$$.fragment),Ce=i(),pt=n("span"),pt.textContent=sa,Bt=i(),Q=n("p"),Q.textContent=na,Ot=i(),D=n("img"),Vt=i(),J=n("p"),J.innerHTML=ia,Wt=i(),K=n("figure"),K.innerHTML=oa,Qt=i(),y=n("h2"),M=n("a"),dt=n("span"),ye(X.$$.fragment),ke=i(),ut=n("span"),ut.textContent=ra,Dt=i(),Y=n("p"),Y.innerHTML=pa,Jt=i(),m=n("p"),He=v("The value of taking action "),Kt=new yt(!1),Xt=v(" in state "),Yt=new yt(!1),Zt=v(" under a policy "),te=new yt(!1),ee=v(" is:"),ae=i(),Z=n("img"),se=i(),tt=n("img"),ne=i(),et=n("p"),et.textContent=ha,le=i(),T=n("ul"),ct=n("li"),$e=v("For the state-value function, we calculate "),ht=n("strong"),Pe=v("the value of a state "),ie=new yt(!1),Ee=i(),mt=n("li"),Se=v("For the action-value function, we calculate "),at=n("strong"),Ie=v("the value of the state-action pair ( "),oe=new yt(!1),re=v(" ) hence the value of taking that action at that state."),pe=i(),st=n("figure"),st.innerHTML=ma,ue=i(),nt=n("p"),nt.innerHTML=fa,ce=i(),lt=n("p"),lt.innerHTML=va,he=i(),it=n("p"),it.innerHTML=ga,me=i(),wt=n("p"),this.h()},l(t){const a=Sa("svelte-1phssyn",document.head);h=l(a,"META",{name:!0,content:!0}),a.forEach(e),f=o(t),C=l(t,"P",{}),c(C).forEach(e),bt=o(t),d=l(t,"H1",{class:!0});var ot=c(d);x=l(ot,"A",{id:!0,class:!0,href:!0});var da=c(x);vt=l(da,"SPAN",{});var wa=c(vt);xe(k.$$.fragment,wa),wa.forEach(e),da.forEach(e),Le=o(ot),rt=l(ot,"SPAN",{"data-svelte-h":!0}),r(rt)!=="svelte-1eob9xc"&&(rt.textContent=ze),ot.forEach(e),Mt=o(t),H=l(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1d7evji"&&(H.innerHTML=Ne),Tt=o(t),$=l(t,"IMG",{src:!0,alt:!0}),Lt=o(t),P=l(t,"P",{"data-svelte-h":!0}),r(P)!=="svelte-12fd7se"&&(P.innerHTML=Fe),Ct=o(t),xe(_.$$.fragment,t),kt=o(t),E=l(t,"P",{"data-svelte-h":!0}),r(E)!=="svelte-1urwfmu"&&(E.innerHTML=Ue),Ht=o(t),S=l(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-19ygivo"&&(S.textContent=Be),$t=o(t),I=l(t,"UL",{"data-svelte-h":!0}),r(I)!=="svelte-1ecrory"&&(I.innerHTML=Oe),Pt=o(t),A=l(t,"IMG",{src:!0,alt:!0}),Et=o(t),G=l(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-8jz7zd"&&(G.textContent=We),St=o(t),j=l(t,"P",{"data-svelte-h":!0}),r(j)!=="svelte-pqtqep"&&(j.innerHTML=Qe),It=o(t),q=l(t,"UL",{"data-svelte-h":!0}),r(q)!=="svelte-1vmcwmn"&&(q.innerHTML=De),At=o(t),z=l(t,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1erga7r"&&(z.innerHTML=Je),Gt=o(t),N=l(t,"FIGURE",{"data-svelte-h":!0}),r(N)!=="svelte-1wqg60u"&&(N.innerHTML=Ke),jt=o(t),R=l(t,"P",{"data-svelte-h":!0}),r(R)!=="svelte-dnwvfq"&&(R.innerHTML=Xe),qt=o(t),F=l(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-5p6c4e"&&(F.textContent=Ye),zt=o(t),U=l(t,"UL",{"data-svelte-h":!0}),r(U)!=="svelte-b6yrau"&&(U.innerHTML=Ze),Nt=o(t),B=l(t,"IMG",{src:!0,alt:!0}),Rt=o(t),O=l(t,"P",{"data-svelte-h":!0}),r(O)!=="svelte-3x2yxo"&&(O.innerHTML=ea),Ft=o(t),V=l(t,"P",{"data-svelte-h":!0}),r(V)!=="svelte-1iwwx7g"&&(V.textContent=aa),Ut=o(t),w=l(t,"H2",{class:!0});var ve=c(w);b=l(ve,"A",{id:!0,class:!0,href:!0});var ya=c(b);gt=l(ya,"SPAN",{});var xa=c(gt);xe(W.$$.fragment,xa),xa.forEach(e),ya.forEach(e),Ce=o(ve),pt=l(ve,"SPAN",{"data-svelte-h":!0}),r(pt)!=="svelte-1wp38it"&&(pt.textContent=sa),ve.forEach(e),Bt=o(t),Q=l(t,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-h4xllq"&&(Q.textContent=na),Ot=o(t),D=l(t,"IMG",{src:!0,alt:!0}),Vt=o(t),J=l(t,"P",{"data-svelte-h":!0}),r(J)!=="svelte-19pqeuc"&&(J.innerHTML=ia),Wt=o(t),K=l(t,"FIGURE",{"data-svelte-h":!0}),r(K)!=="svelte-ft3mq"&&(K.innerHTML=oa),Qt=o(t),y=l(t,"H2",{class:!0});var ge=c(y);M=l(ge,"A",{id:!0,class:!0,href:!0});var _a=c(M);dt=l(_a,"SPAN",{});var ba=c(dt);xe(X.$$.fragment,ba),ba.forEach(e),_a.forEach(e),ke=o(ge),ut=l(ge,"SPAN",{"data-svelte-h":!0}),r(ut)!=="svelte-1fg3dps"&&(ut.textContent=ra),ge.forEach(e),Dt=o(t),Y=l(t,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-1k21qix"&&(Y.innerHTML=pa),Jt=o(t),m=l(t,"P",{});var L=c(m);He=g(L,"The value of taking action "),Kt=xt(L,!1),Xt=g(L," in state "),Yt=xt(L,!1),Zt=g(L," under a policy "),te=xt(L,!1),ee=g(L," is:"),L.forEach(e),ae=o(t),Z=l(t,"IMG",{src:!0,alt:!0}),se=o(t),tt=l(t,"IMG",{src:!0,alt:!0}),ne=o(t),et=l(t,"P",{"data-svelte-h":!0}),r(et)!=="svelte-1n386nk"&&(et.textContent=ha),le=o(t),T=l(t,"UL",{});var de=c(T);ct=l(de,"LI",{});var Ae=c(ct);$e=g(Ae,"For the state-value function, we calculate "),ht=l(Ae,"STRONG",{});var Ge=c(ht);Pe=g(Ge,"the value of a state "),ie=xt(Ge,!1),Ge.forEach(e),Ae.forEach(e),Ee=o(de),mt=l(de,"LI",{});var je=c(mt);Se=g(je,"For the action-value function, we calculate "),at=l(je,"STRONG",{});var we=c(at);Ie=g(we,"the value of the state-action pair ( "),oe=xt(we,!1),re=g(we," ) hence the value of taking that action at that state."),we.forEach(e),je.forEach(e),de.forEach(e),pe=o(t),st=l(t,"FIGURE",{"data-svelte-h":!0}),r(st)!=="svelte-74fuwd"&&(st.innerHTML=ma),ue=o(t),nt=l(t,"P",{"data-svelte-h":!0}),r(nt)!=="svelte-b9olrp"&&(nt.innerHTML=fa),ce=o(t),lt=l(t,"P",{"data-svelte-h":!0}),r(lt)!=="svelte-1vktjwi"&&(lt.innerHTML=va),he=o(t),it=l(t,"P",{"data-svelte-h":!0}),r(it)!=="svelte-1edmeo9"&&(it.innerHTML=ga),me=o(t),wt=l(t,"P",{}),c(wt).forEach(e),this.h()},h(){u(h,"name","hf:doc:metadata"),u(h,"content",JSON.stringify(ja)),u(x,"id","two-types-value-based-methods"),u(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(x,"href","#two-types-value-based-methods"),u(d,"class","relative group"),ft($.src,Re="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/vbm-1.jpg")||u($,"src",Re),u($,"alt","Value Based Methods"),ft(A.src,Ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-approaches-2.jpg")||u(A,"src",Ve),u(A,"alt","Two RL approaches"),ft(B.src,ta="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/link-value-policy.jpg")||u(B,"src",ta),u(B,"alt","Link between value and policy"),u(b,"id","state-value-function"),u(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(b,"href","#state-value-function"),u(w,"class","relative group"),ft(D.src,la="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/state-value-function-1.jpg")||u(D,"src",la),u(D,"alt","State value function"),u(M,"id","action-value-function"),u(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(M,"href","#action-value-function"),u(y,"class","relative group"),Kt.a=Xt,Yt.a=Zt,te.a=ee,ft(Z.src,ua="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/action-state-value-function-1.jpg")||u(Z,"src",ua),u(Z,"alt","Action State value function"),ft(tt.src,ca="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/action-state-value-function-2.jpg")||u(tt,"src",ca),u(tt,"alt","Action State value function"),ie.a=null,oe.a=re},m(t,a){p(document.head,h),s(t,f,a),s(t,C,a),s(t,bt,a),s(t,d,a),p(d,x),p(x,vt),_e(k,vt,null),p(d,Le),p(d,rt),s(t,Mt,a),s(t,H,a),s(t,Tt,a),s(t,$,a),s(t,Lt,a),s(t,P,a),s(t,Ct,a),_e(_,t,a),s(t,kt,a),s(t,E,a),s(t,Ht,a),s(t,S,a),s(t,$t,a),s(t,I,a),s(t,Pt,a),s(t,A,a),s(t,Et,a),s(t,G,a),s(t,St,a),s(t,j,a),s(t,It,a),s(t,q,a),s(t,At,a),s(t,z,a),s(t,Gt,a),s(t,N,a),s(t,jt,a),s(t,R,a),s(t,qt,a),s(t,F,a),s(t,zt,a),s(t,U,a),s(t,Nt,a),s(t,B,a),s(t,Rt,a),s(t,O,a),s(t,Ft,a),s(t,V,a),s(t,Ut,a),s(t,w,a),p(w,b),p(b,gt),_e(W,gt,null),p(w,Ce),p(w,pt),s(t,Bt,a),s(t,Q,a),s(t,Ot,a),s(t,D,a),s(t,Vt,a),s(t,J,a),s(t,Wt,a),s(t,K,a),s(t,Qt,a),s(t,y,a),p(y,M),p(M,dt),_e(X,dt,null),p(y,ke),p(y,ut),s(t,Dt,a),s(t,Y,a),s(t,Jt,a),s(t,m,a),p(m,He),Kt.m(Ma,m),p(m,Xt),Yt.m(Ta,m),p(m,Zt),te.m(La,m),p(m,ee),s(t,ae,a),s(t,Z,a),s(t,se,a),s(t,tt,a),s(t,ne,a),s(t,et,a),s(t,le,a),s(t,T,a),p(T,ct),p(ct,$e),p(ct,ht),p(ht,Pe),ie.m(Ca,ht),p(T,Ee),p(T,mt),p(mt,Se),p(mt,at),p(at,Ie),oe.m(ka,at),p(at,re),s(t,pe,a),s(t,st,a),s(t,ue,a),s(t,nt,a),s(t,ce,a),s(t,lt,a),s(t,he,a),s(t,it,a),s(t,me,a),s(t,wt,a),fe=!0},p(t,[a]){const ot={};a&2&&(ot.$$scope={dirty:a,ctx:t}),_.$set(ot)},i(t){fe||(be(k.$$.fragment,t),be(_.$$.fragment,t),be(W.$$.fragment,t),be(X.$$.fragment,t),fe=!0)},o(t){Me(k.$$.fragment,t),Me(_.$$.fragment,t),Me(W.$$.fragment,t),Me(X.$$.fragment,t),fe=!1},d(t){t&&(e(f),e(C),e(bt),e(d),e(Mt),e(H),e(Tt),e($),e(Lt),e(P),e(Ct),e(kt),e(E),e(Ht),e(S),e($t),e(I),e(Pt),e(A),e(Et),e(G),e(St),e(j),e(It),e(q),e(At),e(z),e(Gt),e(N),e(jt),e(R),e(qt),e(F),e(zt),e(U),e(Nt),e(B),e(Rt),e(O),e(Ft),e(V),e(Ut),e(w),e(Bt),e(Q),e(Ot),e(D),e(Vt),e(J),e(Wt),e(K),e(Qt),e(y),e(Dt),e(Y),e(Jt),e(m),e(ae),e(Z),e(se),e(tt),e(ne),e(et),e(le),e(T),e(pe),e(st),e(ue),e(nt),e(ce),e(lt),e(he),e(it),e(me),e(wt)),e(h),Te(k),Te(_,t),Te(W),Te(X)}}}const ja={local:"two-types-value-based-methods",sections:[{local:"state-value-function",title:"The state-value function "},{local:"action-value-function",title:"The action-value function "}],title:"Two types of value-based methods "};function qa(_t){return $a(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ua extends Pa{constructor(h){super(),Ea(this,h,qa,Ga,Ha,{})}}export{Ua as component};
