import{s as ut,f as D,n as pt,o as ht}from"../chunks/scheduler.37c15a92.js";import{S as mt,i as gt,g as n,s as l,u as ft,A as vt,h as s,f as e,c as r,j as C,v as dt,y as p,k as o,o as $,a,w as _t,d as wt,t as yt,x as Lt}from"../chunks/index.b01106c0.js";import{I as xt}from"../chunks/IconCopyLink.77b762b4.js";function bt(K){let c,A,H,R,u,h,P,m,B,M,Q="What is RL? A short recap",E,g,X="In RL, we build an agent that can <strong>make smart decisions</strong>. For instance, an agent that <strong>learns to play a video game.</strong> Or a trading agent that <strong>learns to maximize its benefits</strong> by deciding on <strong>what stocks to buy and when to sell.</strong>",I,f,Y,q,v,Z="To make intelligent decisions, our agent will learn from the environment by <strong>interacting with it through trial and error</strong> and receiving rewards (positive or negative) <strong>as unique feedback.</strong>",S,d,tt="Its goal <strong>is to maximize its expected cumulative reward</strong> (because of the reward hypothesis).",j,_,et="<strong>The agent’s decision-making process is called the policy π:</strong> given a state, a policy will output an action or a probability distribution over actions. That is, given an observation of the environment, a policy will provide an action (or multiple probabilities for each action) that the agent should take.",z,w,it,G,y,at="<strong>Our goal is to find an optimal policy π* </strong>, aka., a policy that leads to the best expected cumulative reward.",N,L,nt="And to find this optimal policy (hence solving the RL problem), there <strong>are two main types of RL methods</strong>:",O,x,st="<li><em>Policy-based methods</em>: <strong>Train the policy directly</strong> to learn which action to take given a state.</li> <li><em>Value-based methods</em>: <strong>Train a value function</strong> to learn <strong>which state is more valuable</strong> and use this value function <strong>to take the action that leads to it.</strong></li>",U,b,lt,W,T,rt="And in this unit, <strong>we’ll dive deeper into the value-based methods.</strong>",F,k,J;return m=new xt({}),{c(){c=n("meta"),A=l(),H=n("p"),R=l(),u=n("h1"),h=n("a"),P=n("span"),ft(m.$$.fragment),B=l(),M=n("span"),M.textContent=Q,E=l(),g=n("p"),g.innerHTML=X,I=l(),f=n("img"),q=l(),v=n("p"),v.innerHTML=Z,S=l(),d=n("p"),d.innerHTML=tt,j=l(),_=n("p"),_.innerHTML=et,z=l(),w=n("img"),G=l(),y=n("p"),y.innerHTML=at,N=l(),L=n("p"),L.innerHTML=nt,O=l(),x=n("ul"),x.innerHTML=st,U=l(),b=n("img"),W=l(),T=n("p"),T.innerHTML=rt,F=l(),k=n("p"),this.h()},l(t){const i=vt("svelte-1phssyn",document.head);c=s(i,"META",{name:!0,content:!0}),i.forEach(e),A=r(t),H=s(t,"P",{}),C(H).forEach(e),R=r(t),u=s(t,"H1",{class:!0});var V=C(u);h=s(V,"A",{id:!0,class:!0,href:!0});var ot=C(h);P=s(ot,"SPAN",{});var ct=C(P);dt(m.$$.fragment,ct),ct.forEach(e),ot.forEach(e),B=r(V),M=s(V,"SPAN",{"data-svelte-h":!0}),p(M)!=="svelte-tlfuwu"&&(M.textContent=Q),V.forEach(e),E=r(t),g=s(t,"P",{"data-svelte-h":!0}),p(g)!=="svelte-4gdckx"&&(g.innerHTML=X),I=r(t),f=s(t,"IMG",{src:!0,alt:!0}),q=r(t),v=s(t,"P",{"data-svelte-h":!0}),p(v)!=="svelte-1wnqqel"&&(v.innerHTML=Z),S=r(t),d=s(t,"P",{"data-svelte-h":!0}),p(d)!=="svelte-1nx2sev"&&(d.innerHTML=tt),j=r(t),_=s(t,"P",{"data-svelte-h":!0}),p(_)!=="svelte-1he2m43"&&(_.innerHTML=et),z=r(t),w=s(t,"IMG",{src:!0,alt:!0}),G=r(t),y=s(t,"P",{"data-svelte-h":!0}),p(y)!=="svelte-9qzcpz"&&(y.innerHTML=at),N=r(t),L=s(t,"P",{"data-svelte-h":!0}),p(L)!=="svelte-1fm2b8x"&&(L.innerHTML=nt),O=r(t),x=s(t,"UL",{"data-svelte-h":!0}),p(x)!=="svelte-1x976fb"&&(x.innerHTML=st),U=r(t),b=s(t,"IMG",{src:!0,alt:!0}),W=r(t),T=s(t,"P",{"data-svelte-h":!0}),p(T)!=="svelte-1ywk1bx"&&(T.innerHTML=rt),F=r(t),k=s(t,"P",{}),C(k).forEach(e),this.h()},h(){o(c,"name","hf:doc:metadata"),o(c,"content",JSON.stringify(Tt)),o(h,"id","what-is-rl"),o(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(h,"href","#what-is-rl"),o(u,"class","relative group"),D(f.src,Y="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/rl-process.jpg")||o(f,"src",Y),o(f,"alt","RL process"),D(w.src,it="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/policy.jpg")||o(w,"src",it),o(w,"alt","Policy"),D(b.src,lt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-approaches.jpg")||o(b,"src",lt),o(b,"alt","Two RL approaches")},m(t,i){$(document.head,c),a(t,A,i),a(t,H,i),a(t,R,i),a(t,u,i),$(u,h),$(h,P),_t(m,P,null),$(u,B),$(u,M),a(t,E,i),a(t,g,i),a(t,I,i),a(t,f,i),a(t,q,i),a(t,v,i),a(t,S,i),a(t,d,i),a(t,j,i),a(t,_,i),a(t,z,i),a(t,w,i),a(t,G,i),a(t,y,i),a(t,N,i),a(t,L,i),a(t,O,i),a(t,x,i),a(t,U,i),a(t,b,i),a(t,W,i),a(t,T,i),a(t,F,i),a(t,k,i),J=!0},p:pt,i(t){J||(wt(m.$$.fragment,t),J=!0)},o(t){yt(m.$$.fragment,t),J=!1},d(t){t&&(e(A),e(H),e(R),e(u),e(E),e(g),e(I),e(f),e(q),e(v),e(S),e(d),e(j),e(_),e(z),e(w),e(G),e(y),e(N),e(L),e(O),e(x),e(U),e(b),e(W),e(T),e(F),e(k)),e(c),Lt(m)}}}const Tt={local:"what-is-rl",title:"What is RL? A short recap "};function Mt(K){return ht(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ct extends mt{constructor(c){super(),gt(this,c,Mt,bt,ut,{})}}export{Ct as component};
