import{s as Ue,f as G,n as Fe,o as Je}from"../chunks/scheduler.37c15a92.js";import{S as Oe,i as Ye,g as s,s as i,u as Ee,m as Ie,A as Ke,h as r,f as t,c as o,j as v,v as Se,y as p,n as qe,k as l,o as m,a as n,w as We,d as Ge,t as ze,x as Be}from"../chunks/index.b01106c0.js";import{I as Re}from"../chunks/IconCopyLink.77b762b4.js";function Ve(me){let u,z,I,B,c,f,S,d,ce,A,fe="The Deep Q-Network (DQN)",R,w,ge,U,_,ve="As input, we take a <strong>stack of 4 frames</strong> passed through the network as a state and output a <strong>vector of Q-values for each possible action at that state</strong>. Then, like with Q-Learning, we just need to use our epsilon-greedy policy to select which action to take.",F,y,de="When the Neural Network is initialized, <strong>the Q-value estimation is terrible</strong>. But during training, our Deep Q-Network agent will associate a situation with the appropriate action and <strong>learn to play the game well</strong>.",J,h,g,q,k,he,E,we="Preprocessing the input and temporal limitation",O,x,_e="We need to <strong>preprocess the input</strong>. It’s an essential step since we want to <strong>reduce the complexity of our state to reduce the computation time needed for training</strong>.",Y,T,ye=`To achieve this, we <strong>reduce the state space to 84x84 and grayscale it</strong>. We can do this since the colors in Atari environments don’t add important information.
This is a big improvement since we <strong>reduce our three color channels (RGB) to 1</strong>.`,K,L,ke=`We can also <strong>crop a part of the screen in some games</strong> if it does not contain important information.
Then we stack four frames together.`,V,C,xe,X,M,Te=`<strong>Why do we stack four frames together?</strong>
We stack frames together because it helps us <strong>handle the problem of temporal limitation</strong>. Let’s take an example with the game of Pong. When you see this frame:`,Z,P,Le,ee,H,Ce=`Can you tell me where the ball is going?
No, because one frame is not enough to have a sense of motion! But what if I add three more frames? <strong>Here you can see that the ball is going to the right</strong>.`,te,b,Me,ae,$,Pe="Then the stacked frames are processed by three convolutional layers. These layers <strong>allow us to capture and exploit spatial relationships in images</strong>. But also, because the frames are stacked together, <strong>we can exploit some temporal properties across those frames</strong>.",ne,N,He='If you don’t know what convolutional layers are, don’t worry. You can check out <a href="https://www.udacity.com/course/deep-learning-pytorch--ud188" rel="nofollow">Lesson 4 of this free Deep Learning Course by Udacity</a>',se,Q,be="Finally, we have a couple of fully connected layers that output a Q-value for each possible action at that state.",re,D,$e,ie,j,Ne="So, we see that Deep Q-Learning uses a neural network to approximate, given a state, the different Q-values for each possible action at that state. Now let’s study the Deep Q-Learning algorithm.",oe,W,le;return d=new Re({}),k=new Re({}),{c(){u=s("meta"),z=i(),I=s("p"),B=i(),c=s("h1"),f=s("a"),S=s("span"),Ee(d.$$.fragment),ce=i(),A=s("span"),A.textContent=fe,R=Ie(`


This is the architecture of our Deep Q-Learning network:
`),w=s("img"),U=i(),_=s("p"),_.innerHTML=ve,F=i(),y=s("p"),y.innerHTML=de,J=i(),h=s("h2"),g=s("a"),q=s("span"),Ee(k.$$.fragment),he=i(),E=s("span"),E.textContent=we,O=i(),x=s("p"),x.innerHTML=_e,Y=i(),T=s("p"),T.innerHTML=ye,K=i(),L=s("p"),L.innerHTML=ke,V=i(),C=s("img"),X=i(),M=s("p"),M.innerHTML=Te,Z=i(),P=s("img"),ee=i(),H=s("p"),H.innerHTML=Ce,te=i(),b=s("img"),ae=Ie(`
That’s why, to capture temporal information, we stack four frames together.
`),$=s("p"),$.innerHTML=Pe,ne=i(),N=s("p"),N.innerHTML=He,se=i(),Q=s("p"),Q.textContent=be,re=i(),D=s("img"),ie=i(),j=s("p"),j.textContent=Ne,oe=i(),W=s("p"),this.h()},l(e){const a=Ke("svelte-1phssyn",document.head);u=r(a,"META",{name:!0,content:!0}),a.forEach(t),z=o(e),I=r(e,"P",{}),v(I).forEach(t),B=o(e),c=r(e,"H1",{class:!0});var pe=v(c);f=r(pe,"A",{id:!0,class:!0,href:!0});var Qe=v(f);S=r(Qe,"SPAN",{});var De=v(S);Se(d.$$.fragment,De),De.forEach(t),Qe.forEach(t),ce=o(pe),A=r(pe,"SPAN",{"data-svelte-h":!0}),p(A)!=="svelte-92uxl2"&&(A.textContent=fe),pe.forEach(t),R=qe(e,`


This is the architecture of our Deep Q-Learning network:
`),w=r(e,"IMG",{src:!0,alt:!0}),U=o(e),_=r(e,"P",{"data-svelte-h":!0}),p(_)!=="svelte-1hypp4p"&&(_.innerHTML=ve),F=o(e),y=r(e,"P",{"data-svelte-h":!0}),p(y)!=="svelte-1k6czvr"&&(y.innerHTML=de),J=o(e),h=r(e,"H2",{class:!0});var ue=v(h);g=r(ue,"A",{id:!0,class:!0,href:!0});var je=v(g);q=r(je,"SPAN",{});var Ae=v(q);Se(k.$$.fragment,Ae),Ae.forEach(t),je.forEach(t),he=o(ue),E=r(ue,"SPAN",{"data-svelte-h":!0}),p(E)!=="svelte-9pjo47"&&(E.textContent=we),ue.forEach(t),O=o(e),x=r(e,"P",{"data-svelte-h":!0}),p(x)!=="svelte-1lyhjdo"&&(x.innerHTML=_e),Y=o(e),T=r(e,"P",{"data-svelte-h":!0}),p(T)!=="svelte-3unddj"&&(T.innerHTML=ye),K=o(e),L=r(e,"P",{"data-svelte-h":!0}),p(L)!=="svelte-12atbxn"&&(L.innerHTML=ke),V=o(e),C=r(e,"IMG",{src:!0,alt:!0}),X=o(e),M=r(e,"P",{"data-svelte-h":!0}),p(M)!=="svelte-1d5ylzm"&&(M.innerHTML=Te),Z=o(e),P=r(e,"IMG",{src:!0,alt:!0}),ee=o(e),H=r(e,"P",{"data-svelte-h":!0}),p(H)!=="svelte-1gpzepb"&&(H.innerHTML=Ce),te=o(e),b=r(e,"IMG",{src:!0,alt:!0}),ae=qe(e,`
That’s why, to capture temporal information, we stack four frames together.
`),$=r(e,"P",{"data-svelte-h":!0}),p($)!=="svelte-1qrirkm"&&($.innerHTML=Pe),ne=o(e),N=r(e,"P",{"data-svelte-h":!0}),p(N)!=="svelte-7233xh"&&(N.innerHTML=He),se=o(e),Q=r(e,"P",{"data-svelte-h":!0}),p(Q)!=="svelte-2hryy8"&&(Q.textContent=be),re=o(e),D=r(e,"IMG",{src:!0,alt:!0}),ie=o(e),j=r(e,"P",{"data-svelte-h":!0}),p(j)!=="svelte-2wm1wc"&&(j.textContent=Ne),oe=o(e),W=r(e,"P",{}),v(W).forEach(t),this.h()},h(){l(u,"name","hf:doc:metadata"),l(u,"content",JSON.stringify(Xe)),l(f,"id","deep-q-network"),l(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(f,"href","#deep-q-network"),l(c,"class","relative group"),G(w.src,ge="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/deep-q-network.jpg")||l(w,"src",ge),l(w,"alt","Deep Q Network"),l(g,"id","preprocessing"),l(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(g,"href","#preprocessing"),l(h,"class","relative group"),G(C.src,xe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/preprocessing.jpg")||l(C,"src",xe),l(C,"alt","Preprocessing"),G(P.src,Le="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/temporal-limitation.jpg")||l(P,"src",Le),l(P,"alt","Temporal Limitation"),G(b.src,Me="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/temporal-limitation-2.jpg")||l(b,"src",Me),l(b,"alt","Temporal Limitation"),G(D.src,$e="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/deep-q-network.jpg")||l(D,"src",$e),l(D,"alt","Deep Q Network")},m(e,a){m(document.head,u),n(e,z,a),n(e,I,a),n(e,B,a),n(e,c,a),m(c,f),m(f,S),We(d,S,null),m(c,ce),m(c,A),n(e,R,a),n(e,w,a),n(e,U,a),n(e,_,a),n(e,F,a),n(e,y,a),n(e,J,a),n(e,h,a),m(h,g),m(g,q),We(k,q,null),m(h,he),m(h,E),n(e,O,a),n(e,x,a),n(e,Y,a),n(e,T,a),n(e,K,a),n(e,L,a),n(e,V,a),n(e,C,a),n(e,X,a),n(e,M,a),n(e,Z,a),n(e,P,a),n(e,ee,a),n(e,H,a),n(e,te,a),n(e,b,a),n(e,ae,a),n(e,$,a),n(e,ne,a),n(e,N,a),n(e,se,a),n(e,Q,a),n(e,re,a),n(e,D,a),n(e,ie,a),n(e,j,a),n(e,oe,a),n(e,W,a),le=!0},p:Fe,i(e){le||(Ge(d.$$.fragment,e),Ge(k.$$.fragment,e),le=!0)},o(e){ze(d.$$.fragment,e),ze(k.$$.fragment,e),le=!1},d(e){e&&(t(z),t(I),t(B),t(c),t(R),t(w),t(U),t(_),t(F),t(y),t(J),t(h),t(O),t(x),t(Y),t(T),t(K),t(L),t(V),t(C),t(X),t(M),t(Z),t(P),t(ee),t(H),t(te),t(b),t(ae),t($),t(ne),t(N),t(se),t(Q),t(re),t(D),t(ie),t(j),t(oe),t(W)),t(u),Be(d),Be(k)}}}const Xe={local:"deep-q-network",sections:[{local:"preprocessing",title:"Preprocessing the input and temporal limitation "}],title:"The Deep Q-Network (DQN)  "};function Ze(me){return Je(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class nt extends Oe{constructor(u){super(),Ye(this,u,Ze,Ve,Ue,{})}}export{nt as component};
