import{s as $t,f as qt,n as Nt,o as Dt}from"../chunks/scheduler.37c15a92.js";import{S as Ft,i as Gt,g as n,s as l,u as jt,m as q,H as gt,A as Rt,h as i,f as s,c as p,j as H,v as Ut,y as r,n as E,B as ft,k as c,o,a,w as Bt,d as Ot,t as Jt,x as Wt}from"../chunks/index.b01106c0.js";import{I as Kt}from"../chunks/IconCopyLink.77b762b4.js";function Vt(dt){let h,N,I,D,u,g,S,v,ot,P,vt="From Q-Learning to Deep Q-Learning",F,w,wt="We learned that <strong>Q-Learning is an algorithm we use to train our Q-Function</strong>, an <strong>action-value function</strong> that determines the value of being at a particular state and taking a specific action at that state.",G,x,xt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-function.jpg" alt="Q-function"/>',j,_,_t="The <strong>Q comes from “the Quality” of that action at that state.</strong>",R,y,yt="Internally, our Q-function is encoded by <strong>a Q-table, a table where each cell corresponds to a state-action pair value.</strong> Think of this Q-table as <strong>the memory or cheat sheet of our Q-function.</strong>",U,b,bt=`The problem is that Q-Learning is a <em>tabular method</em>. This becomes a problem if the states and actions spaces <strong>are not small enough to be represented efficiently by arrays and tables</strong>. In other words: it is <strong>not scalable</strong>.
Q-Learning worked well with small state space environments like:`,B,L,Lt="<li>FrozenLake, we had 16 states.</li> <li>Taxi-v3, we had 500 states.</li>",O,M,Mt="But think of what we’re going to do today: we will train an agent to learn to play Space Invaders, a more complex game, using the frames as input.",J,m,ct,A,Qt='<a href="https://twitter.com/meln1k" rel="nofollow">Nikita Melkozerov mentioned</a>, Atari environments',ht,W,Et='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>25</mn><msup><mn>6</mn><mrow><mn>210</mn><mo>×</mo><mn>160</mn><mo>×</mo><mn>3</mn></mrow></msup><mo>=</mo><mn>25</mn><msup><mn>6</mn><mn>100800</mn></msup></mrow><annotation encoding="application/x-tex">256^{210 \\times 160 \\times 3} = 256^{100800}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8141em;"></span><span class="mord">25</span><span class="mord"><span class="mord">6</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8141em;"><span style="top:-3.063em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">210</span><span class="mbin mtight">×</span><span class="mord mtight">160</span><span class="mbin mtight">×</span><span class="mord mtight">3</span></span></span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.8141em;"></span><span class="mord">25</span><span class="mord"><span class="mord">6</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8141em;"><span style="top:-3.063em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">100800</span></span></span></span></span></span></span></span></span></span></span></span>',K,V,It='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><msup><mn>0</mn><mn>80</mn></msup></mrow><annotation encoding="application/x-tex">10^{80}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8141em;"></span><span class="mord">1</span><span class="mord"><span class="mord">0</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8141em;"><span style="top:-3.063em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">80</span></span></span></span></span></span></span></span></span></span></span></span>',X,Y,Q,kt="<li>A single frame in Atari is composed of an image of 210x160 pixels. Given that the images are in color (RGB), there are 3 channels. This is why the shape is (210, 160, 3). For each pixel, the value can go from 0 to 255.</li>",Z,k,Tt,tt,f,ut,st,St='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>Q</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q_{\\theta}(s,a)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal">Q</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',et,at,T,Ct="This neural network will approximate, given a state, the different Q-values for each possible action at that state. And that’s exactly what Deep Q-Learning does.",nt,C,zt,it,z,Ht="Now that we understand Deep Q-Learning, let’s dive deeper into the Deep Q-Network.",lt,$,pt;return v=new Kt({}),{c(){h=n("meta"),N=l(),I=n("p"),D=l(),u=n("h1"),g=n("a"),S=n("span"),jt(v.$$.fragment),ot=l(),P=n("span"),P.textContent=vt,F=l(),w=n("p"),w.innerHTML=wt,G=l(),x=n("figure"),x.innerHTML=xt,j=l(),_=n("p"),_.innerHTML=_t,R=l(),y=n("p"),y.innerHTML=yt,U=l(),b=n("p"),b.innerHTML=bt,B=l(),L=n("ul"),L.innerHTML=Lt,O=l(),M=n("p"),M.textContent=Mt,J=l(),m=n("p"),ct=q("As "),A=n("strong"),A.innerHTML=Qt,ht=q(" have an observation space with a shape of (210, 160, 3)*, containing values ranging from 0 to 255 so that gives us "),W=new gt(!1),K=q(" possible observations (for comparison, we have approximately "),V=new gt(!1),X=q(" atoms in the observable universe)."),Y=l(),Q=n("ul"),Q.innerHTML=kt,Z=l(),k=n("img"),tt=l(),f=n("p"),ut=q("Therefore, the state space is gigantic; due to this, creating and updating a Q-table for that environment would not be efficient. In this case, the best idea is to approximate the Q-values using a parametrized Q-function  "),st=new gt(!1),et=q("  ."),at=l(),T=n("p"),T.textContent=Ct,nt=l(),C=n("img"),it=l(),z=n("p"),z.textContent=Ht,lt=l(),$=n("p"),this.h()},l(t){const e=Rt("svelte-1phssyn",document.head);h=i(e,"META",{name:!0,content:!0}),e.forEach(s),N=p(t),I=i(t,"P",{}),H(I).forEach(s),D=p(t),u=i(t,"H1",{class:!0});var mt=H(u);g=i(mt,"A",{id:!0,class:!0,href:!0});var Pt=H(g);S=i(Pt,"SPAN",{});var At=H(S);Ut(v.$$.fragment,At),At.forEach(s),Pt.forEach(s),ot=p(mt),P=i(mt,"SPAN",{"data-svelte-h":!0}),r(P)!=="svelte-1or8182"&&(P.textContent=vt),mt.forEach(s),F=p(t),w=i(t,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1rjdaln"&&(w.innerHTML=wt),G=p(t),x=i(t,"FIGURE",{"data-svelte-h":!0}),r(x)!=="svelte-gz4b9g"&&(x.innerHTML=xt),j=p(t),_=i(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-148602q"&&(_.innerHTML=_t),R=p(t),y=i(t,"P",{"data-svelte-h":!0}),r(y)!=="svelte-gdw4y7"&&(y.innerHTML=yt),U=p(t),b=i(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-1ghk6ck"&&(b.innerHTML=bt),B=p(t),L=i(t,"UL",{"data-svelte-h":!0}),r(L)!=="svelte-1qtovsz"&&(L.innerHTML=Lt),O=p(t),M=i(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1ovrzpg"&&(M.textContent=Mt),J=p(t),m=i(t,"P",{});var d=H(m);ct=E(d,"As "),A=i(d,"STRONG",{"data-svelte-h":!0}),r(A)!=="svelte-10s0md3"&&(A.innerHTML=Qt),ht=E(d," have an observation space with a shape of (210, 160, 3)*, containing values ranging from 0 to 255 so that gives us "),W=ft(d,!1),K=E(d," possible observations (for comparison, we have approximately "),V=ft(d,!1),X=E(d," atoms in the observable universe)."),d.forEach(s),Y=p(t),Q=i(t,"UL",{"data-svelte-h":!0}),r(Q)!=="svelte-1cx174r"&&(Q.innerHTML=kt),Z=p(t),k=i(t,"IMG",{src:!0,alt:!0}),tt=p(t),f=i(t,"P",{});var rt=H(f);ut=E(rt,"Therefore, the state space is gigantic; due to this, creating and updating a Q-table for that environment would not be efficient. In this case, the best idea is to approximate the Q-values using a parametrized Q-function  "),st=ft(rt,!1),et=E(rt,"  ."),rt.forEach(s),at=p(t),T=i(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-1dwltuz"&&(T.textContent=Ct),nt=p(t),C=i(t,"IMG",{src:!0,alt:!0}),it=p(t),z=i(t,"P",{"data-svelte-h":!0}),r(z)!=="svelte-9k1cpu"&&(z.textContent=Ht),lt=p(t),$=i(t,"P",{}),H($).forEach(s),this.h()},h(){c(h,"name","hf:doc:metadata"),c(h,"content",JSON.stringify(Xt)),c(g,"id","from-q-to-dqn"),c(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(g,"href","#from-q-to-dqn"),c(u,"class","relative group"),W.a=K,V.a=X,qt(k.src,Tt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/atari.jpg")||c(k,"src",Tt),c(k,"alt","Atari State Space"),st.a=et,qt(C.src,zt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/deep.jpg")||c(C,"src",zt),c(C,"alt","Deep Q Learning")},m(t,e){o(document.head,h),a(t,N,e),a(t,I,e),a(t,D,e),a(t,u,e),o(u,g),o(g,S),Bt(v,S,null),o(u,ot),o(u,P),a(t,F,e),a(t,w,e),a(t,G,e),a(t,x,e),a(t,j,e),a(t,_,e),a(t,R,e),a(t,y,e),a(t,U,e),a(t,b,e),a(t,B,e),a(t,L,e),a(t,O,e),a(t,M,e),a(t,J,e),a(t,m,e),o(m,ct),o(m,A),o(m,ht),W.m(Et,m),o(m,K),V.m(It,m),o(m,X),a(t,Y,e),a(t,Q,e),a(t,Z,e),a(t,k,e),a(t,tt,e),a(t,f,e),o(f,ut),st.m(St,f),o(f,et),a(t,at,e),a(t,T,e),a(t,nt,e),a(t,C,e),a(t,it,e),a(t,z,e),a(t,lt,e),a(t,$,e),pt=!0},p:Nt,i(t){pt||(Ot(v.$$.fragment,t),pt=!0)},o(t){Jt(v.$$.fragment,t),pt=!1},d(t){t&&(s(N),s(I),s(D),s(u),s(F),s(w),s(G),s(x),s(j),s(_),s(R),s(y),s(U),s(b),s(B),s(L),s(O),s(M),s(J),s(m),s(Y),s(Q),s(Z),s(k),s(tt),s(f),s(at),s(T),s(nt),s(C),s(it),s(z),s(lt),s($)),s(h),Wt(v)}}}const Xt={local:"from-q-to-dqn",title:"From Q-Learning to Deep Q-Learning "};function Yt(dt){return Dt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class es extends Ft{constructor(h){super(),Gt(this,h,Yt,Vt,$t,{})}}export{es as component};
