import{s as oe,f as se,n as re,o as ue}from"../chunks/scheduler.37c15a92.js";import{S as ce,i as pe,g as i,s,u as me,A as he,h as l,f as t,c as o,j as H,v as fe,y as p,k as r,o as k,a,w as de,d as ve,t as ge,x as _e}from"../chunks/index.b01106c0.js";import{I as ye}from"../chunks/IconCopyLink.77b762b4.js";function we(O){let u,I,L,$,c,m,M,f,J,P,W="Introduction",E,d,Y,S,v,B="In the last unit, we learned about Deep Q-Learning. In this value-based deep reinforcement learning algorithm, we <strong>used a deep neural network to approximate the different Q-values for each possible action at a state.</strong>",j,g,K="Since the beginning of the course, we have only studied value-based methods, <strong>where we estimate a value function as an intermediate step towards finding an optimal policy.</strong>",q,_,V,A,y,X="In value-based methods, the policy <strong>(π) only exists because of the action value estimates since the policy is just a function</strong> (for instance, greedy-policy) that will select the action with the highest value given a state.",G,w,Z="With policy-based methods, we want to optimize the policy directly <strong>without having an intermediate step of learning a value function.</strong>",N,x,ee=`So today, <strong>we’ll learn about policy-based methods and study a subset of these methods called policy gradient</strong>. Then we’ll implement our first policy gradient algorithm called Monte Carlo <strong>Reinforce</strong> from scratch using PyTorch.
Then, we’ll test its robustness using the CartPole-v1 and PixelCopter environments.`,R,b,te="You’ll then be able to iterate and improve this implementation for more advanced environments.",z,h,ne='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/envs.gif" alt="Environments"/>',Q,C,ae="Let’s get started!",U,T,D;return f=new ye({}),{c(){u=i("meta"),I=s(),L=i("p"),$=s(),c=i("h1"),m=i("a"),M=i("span"),me(f.$$.fragment),J=s(),P=i("span"),P.textContent=W,E=s(),d=i("img"),S=s(),v=i("p"),v.innerHTML=B,j=s(),g=i("p"),g.innerHTML=K,q=s(),_=i("img"),A=s(),y=i("p"),y.innerHTML=X,G=s(),w=i("p"),w.innerHTML=Z,N=s(),x=i("p"),x.innerHTML=ee,R=s(),b=i("p"),b.textContent=te,z=s(),h=i("figure"),h.innerHTML=ne,Q=s(),C=i("p"),C.textContent=ae,U=s(),T=i("p"),this.h()},l(e){const n=he("svelte-1phssyn",document.head);u=l(n,"META",{name:!0,content:!0}),n.forEach(t),I=o(e),L=l(e,"P",{}),H(L).forEach(t),$=o(e),c=l(e,"H1",{class:!0});var F=H(c);m=l(F,"A",{id:!0,class:!0,href:!0});var ie=H(m);M=l(ie,"SPAN",{});var le=H(M);fe(f.$$.fragment,le),le.forEach(t),ie.forEach(t),J=o(F),P=l(F,"SPAN",{"data-svelte-h":!0}),p(P)!=="svelte-agc3q7"&&(P.textContent=W),F.forEach(t),E=o(e),d=l(e,"IMG",{src:!0,alt:!0}),S=o(e),v=l(e,"P",{"data-svelte-h":!0}),p(v)!=="svelte-j9zk2f"&&(v.innerHTML=B),j=o(e),g=l(e,"P",{"data-svelte-h":!0}),p(g)!=="svelte-2xpx7a"&&(g.innerHTML=K),q=o(e),_=l(e,"IMG",{src:!0,alt:!0}),A=o(e),y=l(e,"P",{"data-svelte-h":!0}),p(y)!=="svelte-10c158u"&&(y.innerHTML=X),G=o(e),w=l(e,"P",{"data-svelte-h":!0}),p(w)!=="svelte-1btggbm"&&(w.innerHTML=Z),N=o(e),x=l(e,"P",{"data-svelte-h":!0}),p(x)!=="svelte-4of5it"&&(x.innerHTML=ee),R=o(e),b=l(e,"P",{"data-svelte-h":!0}),p(b)!=="svelte-liqaak"&&(b.textContent=te),z=o(e),h=l(e,"FIGURE",{class:!0,"data-svelte-h":!0}),p(h)!=="svelte-1dadvfq"&&(h.innerHTML=ne),Q=o(e),C=l(e,"P",{"data-svelte-h":!0}),p(C)!=="svelte-4b3xjd"&&(C.textContent=ae),U=o(e),T=l(e,"P",{}),H(T).forEach(t),this.h()},h(){r(u,"name","hf:doc:metadata"),r(u,"content",JSON.stringify(xe)),r(m,"id","introduction"),r(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(m,"href","#introduction"),r(c,"class","relative group"),se(d.src,Y="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/thumbnail.png")||r(d,"src",Y),r(d,"alt","thumbnail"),se(_.src,V="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/link-value-policy.jpg")||r(_,"src",V),r(_,"alt","Link value policy"),r(h,"class","image table text-center m-0 w-full")},m(e,n){k(document.head,u),a(e,I,n),a(e,L,n),a(e,$,n),a(e,c,n),k(c,m),k(m,M),de(f,M,null),k(c,J),k(c,P),a(e,E,n),a(e,d,n),a(e,S,n),a(e,v,n),a(e,j,n),a(e,g,n),a(e,q,n),a(e,_,n),a(e,A,n),a(e,y,n),a(e,G,n),a(e,w,n),a(e,N,n),a(e,x,n),a(e,R,n),a(e,b,n),a(e,z,n),a(e,h,n),a(e,Q,n),a(e,C,n),a(e,U,n),a(e,T,n),D=!0},p:re,i(e){D||(ve(f.$$.fragment,e),D=!0)},o(e){ge(f.$$.fragment,e),D=!1},d(e){e&&(t(I),t(L),t($),t(c),t(E),t(d),t(S),t(v),t(j),t(g),t(q),t(_),t(A),t(y),t(G),t(w),t(N),t(x),t(R),t(b),t(z),t(h),t(Q),t(C),t(U),t(T)),t(u),_e(f)}}}const xe={local:"introduction",title:"Introduction "};function be(O){return ue(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Me extends ce{constructor(u){super(),pe(this,u,be,we,oe,{})}}export{Me as component};
