import{s as ki,f as Gt,n as Mi,o as Ci}from"../chunks/scheduler.37c15a92.js";import{S as Li,i as Pi,g as l,s as m,u as ra,m as r,H as u,A as Ti,h as i,f as a,c as p,j as h,v as oa,y as g,n as o,B as d,k as c,o as e,a as n,w as ha,d as ca,t as ga,x as ua}from"../chunks/index.b01106c0.js";import{I as da}from"../chunks/IconCopyLink.77b762b4.js";function zi(In){let z,za,va,Ea,E,S,fa,at,Xe,St,Rn="Diving deeper into policy-gradient methods",$a,$,A,wa,st,Ye,At,Gn="Getting the big picture",ja,k,Ze,Ha,ql='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex"> \\theta </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Ia,Jt,Sn="maximize the expected return",tn,Ra,et,An="The idea is that we have a <em>parameterized stochastic policy</em>. In our case, a neural network outputs a probability distribution over actions. The probability of taking each action is also called the <em>action preference</em>.",Ga,nt,Jn="If we take the example of CartPole-v1:",Sa,lt,Nn="<li>As input, we have a state.</li> <li>As output, we have a probability distribution over actions at that state.</li>",Aa,it,Un,Ja,mt,On=`Our goal with policy-gradient is to <strong>control the probability distribution of actions</strong> by tuning the policy such that <strong>good actions (that maximize the return) are sampled more frequently in the future.</strong>
Each time the agent interacts with the environment, we tweak the parameters such that good actions will be sampled more likely in the future.`,Na,pt,qn="But <strong>how are we going to optimize the weights using the expected return</strong>?",Ua,rt,Wn=`The idea is that we’re going to <strong>let the agent interact during an episode</strong>. And if we win the episode, we consider that each action taken was good and must be more sampled in the future
since they lead to win.`,Oa,J,an,qa,Wl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>a</mi><mi mathvariant="normal">∣</mi><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(a|s)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal">a</span><span class="mord">∣</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',Wa,Da,ot,Dn="The Policy-gradient algorithm (simplified) looks like this:",Fa,N,Fn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/pg_bigpicture.jpg" alt="Policy Gradient Big Picture"/>',Ba,ht,Bn="Now that we got the big picture, let’s dive deeper into policy-gradient methods.",Ka,j,U,ya,ct,sn,Nt,Kn="Diving deeper into policy-gradient methods",Qa,f,en,Va,Dl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">\\pi</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',Xa,Ya,Fl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Za,ts,Bl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">\\pi</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',as,Ut,Qn="outputs a probability distribution of actions",nn,ss,O,Vn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/stochastic_policy.png" alt="Policy"/>',es,y,ln,ns,Kl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><msub><mi>a</mi><mi>t</mi></msub><mi mathvariant="normal">∣</mi><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\pi_\\theta(a_t|s_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">∣</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ls,is,Ql='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">a_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ms,ps,Vl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">s_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',rs,os,H,Ot,Xn="But how do we know if our policy is good?",mn,hs,Xl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',cs,gs,I,q,xa,gt,pn,qt,Yn="The objective function",us,ut,Zn="The <em>objective function</em> gives us the <strong>performance of the agent</strong> given a trajectory (state action sequence without considering reward (contrary to an episode)), and it outputs the <em>expected cumulative reward</em>.",ds,dt,tl,vs,vt,al="Let’s give some more details on this formula:",fs,Wt,b,rn,Dt,sl="expected return",on,ws,Yl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>τ</mi><mo separator="true">;</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(\\tau;\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mpunct">;</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',ys,xs,Zl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',bs,_s,ft,el,ks,W,Ft,Ms,ti='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',Cs,hn,M,Ls,ai='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>τ</mi><mo separator="true">;</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(\\tau;\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mpunct">;</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Ps,Ts,si='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>τ</mi></mrow><annotation encoding="application/x-tex">\\tau</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span></span></span></span>',zs,Es,ei='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex"> \\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',$s,js,wt,nl,Hs,Bt,D,Is,ni='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Rs,Gs,li='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Ss,As,F,cn,Js,ii='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Ns,Us,yt,ll,Os,R,B,ba,xt,gn,Kt,il="Gradient Ascent and the Policy-gradient Theorem",qs,v,un,Ws,mi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Ds,Fs,pi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Bs,Qt,ml="gradient-ascent",dn,Vt,pl="gradient-descent",vn,Ks,ri='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Qs,Vs,bt,rl='(If you need a refresher on the difference between gradient descent and gradient ascent <a href="https://www.baeldung.com/cs/gradient-descent-vs-ascent" rel="nofollow">check this</a> and <a href="https://stats.stackexchange.com/questions/258721/gradient-ascent-vs-gradient-descent-in-logistic-regression" rel="nofollow">this</a>).',Xs,_t,ol="Our update step for gradient-ascent is:",Ys,Xt,Zs,oi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi><mo>←</mo><mi>θ</mi><mo>+</mo><mi>α</mi><mo>∗</mo><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\theta \\leftarrow \\theta + \\alpha *  \\nabla_\\theta J(\\theta) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">←</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7778em;vertical-align:-0.0833em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4653em;"></span><span class="mord mathnormal" style="margin-right:0.0037em;">α</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',te,C,fn,ae,hi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',se,ee,ci='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',ne,le,K,wn,ie,gi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',me,pe,kt,hl=`<li><p>We can’t calculate the true gradient of the objective function since it requires calculating the probability of each possible trajectory, which is computationally super expensive.
So we want to <strong>calculate a gradient estimation with a sample-based estimate (collect some trajectories)</strong>.</p></li> <li><p>We have another problem that I explain in the next optional section. To differentiate this objective function, we need to differentiate the state distribution, called the Markov Decision Process dynamics. This is attached to the environment. It gives us the probability of the environment going into the next state, given the current state and the action taken by the agent. The problem is that we can’t differentiate it because we might not know about it.</p></li>`,re,Mt,cl,oe,Ct,gl="Fortunately we’re going to use a solution called the Policy Gradient Theorem that will help us to reformulate the objective function into a differentiable function that does not involve the differentiation of the state distribution.",he,Lt,ul,ce,Pt,dl="If you want to understand how we derive this formula for approximating the gradient, check out the next (optional) section.",ge,G,Q,_a,Tt,yn,Yt,vl="The Reinforce algorithm (Monte Carlo Reinforce)",ue,L,xn,Zt,fl="uses an estimated return from an entire episode to update the policy parameter",bn,de,ui='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',ve,fe,zt,wl="In a loop:",we,P,ka,V,_n,ye,di='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub></mrow><annotation encoding="application/x-tex">\\pi_\\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',xe,be,vi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>τ</mi></mrow><annotation encoding="application/x-tex">\\tau</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span></span></span></span>',kn,Et,ta,Mn,_e,fi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mover accent="true"><mi>g</mi><mo>^</mo></mover><mo>=</mo><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\hat{g} = \\nabla_\\theta J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8889em;vertical-align:-0.1944em;"></span><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.2222em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Cn,$t,yl='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_one.png" alt="Policy Gradient"/>',Ln,Ma,aa,Pn,ke,wi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi><mo>←</mo><mi>θ</mi><mo>+</mo><mi>α</mi><mover accent="true"><mi>g</mi><mo>^</mo></mover></mrow><annotation encoding="application/x-tex">\\theta \\leftarrow \\theta + \\alpha \\hat{g}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">←</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7778em;vertical-align:-0.0833em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8889em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.0037em;">α</span><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.2222em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span></span></span></span>',Me,jt,xl="We can interpret this update as follows:",Ce,X,w,Le,yi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>l</mi><mi>o</mi><mi>g</mi><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><msub><mi>a</mi><mi>t</mi></msub><mi mathvariant="normal">∣</mi><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\nabla_\\theta log \\pi_\\theta(a_t|s_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal">o</span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">∣</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Pe,sa,bl="steepest increase of the (log) probability",Tn,ea,_l="how we should change the weights of policy",zn,Te,xi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">a_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ze,Ee,bi='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">s_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',$e,En,Ht,je,_i='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',He,na,kl="<li>If the return is high, it will <strong>push up the probabilities</strong> of the (state, action) combinations.</li> <li>Otherwise, if the return is low, it will <strong>push down the probabilities</strong> of the (state, action) combinations.</li>",Ie,It,Ml="We can also <strong>collect multiple episodes (trajectories)</strong> to estimate the gradient:",Re,Y,Cl='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_multiple.png" alt="Policy Gradient"/>',Ge,Ca,Se;return at=new da({}),st=new da({}),ct=new da({}),gt=new da({}),xt=new da({}),Tt=new da({}),{c(){z=l("meta"),za=m(),va=l("p"),Ea=m(),E=l("h1"),S=l("a"),fa=l("span"),ra(at.$$.fragment),Xe=m(),St=l("span"),St.textContent=Rn,$a=m(),$=l("h2"),A=l("a"),wa=l("span"),ra(st.$$.fragment),Ye=m(),At=l("span"),At.textContent=Gn,ja=m(),k=l("p"),Ze=r("We just learned that policy-gradient methods aim to find parameters "),Ha=new u(!1),Ia=r(" that "),Jt=l("strong"),Jt.textContent=Sn,tn=r("."),Ra=m(),et=l("p"),et.innerHTML=An,Ga=m(),nt=l("p"),nt.textContent=Jn,Sa=m(),lt=l("ul"),lt.innerHTML=Nn,Aa=m(),it=l("img"),Ja=m(),mt=l("p"),mt.innerHTML=On,Na=m(),pt=l("p"),pt.innerHTML=qn,Ua=m(),rt=l("p"),rt.innerHTML=Wn,Oa=m(),J=l("p"),an=r("So for each state-action pair, we want to increase the "),qa=new u(!1),Wa=r(": the probability of taking that action at that state. Or decrease if we lost."),Da=m(),ot=l("p"),ot.textContent=Dn,Fa=m(),N=l("figure"),N.innerHTML=Fn,Ba=m(),ht=l("p"),ht.textContent=Bn,Ka=m(),j=l("h2"),U=l("a"),ya=l("span"),ra(ct.$$.fragment),sn=m(),Nt=l("span"),Nt.textContent=Kn,Qa=m(),f=l("p"),en=r("We have our stochastic policy "),Va=new u(!1),Xa=r(" which has a parameter "),Ya=new u(!1),Za=r(". This "),ts=new u(!1),as=r(", given a state, "),Ut=l("strong"),Ut.textContent=Qn,nn=r("."),ss=m(),O=l("figure"),O.innerHTML=Vn,es=m(),y=l("p"),ln=r("Where "),ns=new u(!1),ls=r(" is the probability of the agent selecting action "),is=new u(!1),ms=r(" from state "),ps=new u(!1),rs=r(" given our policy."),os=m(),H=l("p"),Ot=l("strong"),Ot.textContent=Xn,mn=r(" We need to have a way to measure it. To know that, we define a score/objective function called "),hs=new u(!1),cs=r("."),gs=m(),I=l("h3"),q=l("a"),xa=l("span"),ra(gt.$$.fragment),pn=m(),qt=l("span"),qt.textContent=Yn,us=m(),ut=l("p"),ut.innerHTML=Zn,ds=m(),dt=l("img"),vs=m(),vt=l("p"),vt.textContent=al,fs=m(),Wt=l("ul"),b=l("li"),rn=r("The "),Dt=l("em"),Dt.textContent=sl,on=r(" (also called expected cumulative reward), is the weighted average (where the weights are given by "),ws=new u(!1),ys=r(" of all possible values that the return "),xs=new u(!1),bs=r(" can take)."),_s=m(),ft=l("img"),ks=m(),W=l("ul"),Ft=l("li"),Ms=new u(!1),Cs=r(" :  Return from an arbitrary trajectory. To take this quantity and use it to calculate the expected return, we need to multiply it by the probability of each possible trajectory."),hn=m(),M=l("li"),Ls=new u(!1),Ps=r(" : Probability of each possible trajectory "),Ts=new u(!1),zs=r(" (that probability depends on "),Es=new u(!1),$s=r(" since it defines the policy that it uses to select the actions of the trajectory which has an impact of the states visited)."),js=m(),wt=l("img"),Hs=m(),Bt=l("ul"),D=l("li"),Is=new u(!1),Rs=r(" : Expected return, we calculate it by summing for all trajectories, the probability of taking that trajectory given "),Gs=new u(!1),Ss=r(" multiplied by the return of this trajectory."),As=m(),F=l("p"),cn=r("Our objective then is to maximize the expected cumulative reward by finding the "),Js=new u(!1),Ns=r(" that will output the best action probability distributions:"),Us=m(),yt=l("img"),Os=m(),R=l("h2"),B=l("a"),ba=l("span"),ra(xt.$$.fragment),gn=m(),Kt=l("span"),Kt.textContent=il,qs=m(),v=l("p"),un=r("Policy-gradient is an optimization problem: we want to find the values of "),Ws=new u(!1),Ds=r(" that maximize our objective function "),Fs=new u(!1),Bs=r(", so we need to use "),Qt=l("strong"),Qt.textContent=ml,dn=r(". It’s the inverse of "),Vt=l("em"),Vt.textContent=pl,vn=r(" since it gives the direction of the steepest increase of "),Ks=new u(!1),Qs=r("."),Vs=m(),bt=l("p"),bt.innerHTML=rl,Xs=m(),_t=l("p"),_t.textContent=ol,Ys=m(),Xt=l("p"),Zs=new u(!1),te=m(),C=l("p"),fn=r("We can repeatedly apply this update in the hopes that "),ae=new u(!1),se=r(" converges to the value that maximizes "),ee=new u(!1),ne=r("."),le=m(),K=l("p"),wn=r("However, there are two problems with computing the derivative of "),ie=new u(!1),me=r(":"),pe=m(),kt=l("ol"),kt.innerHTML=hl,re=m(),Mt=l("img"),oe=m(),Ct=l("p"),Ct.textContent=gl,he=m(),Lt=l("img"),ce=m(),Pt=l("p"),Pt.textContent=dl,ge=m(),G=l("h2"),Q=l("a"),_a=l("span"),ra(Tt.$$.fragment),yn=m(),Yt=l("span"),Yt.textContent=vl,ue=m(),L=l("p"),xn=r("The Reinforce algorithm, also called Monte-Carlo policy-gradient, is a policy-gradient algorithm that "),Zt=l("strong"),Zt.textContent=fl,bn=m(),de=new u(!1),ve=r(":"),fe=m(),zt=l("p"),zt.textContent=wl,we=m(),P=l("ul"),ka=l("li"),V=l("p"),_n=r("Use the policy "),ye=new u(!1),xe=r("  to collect an episode "),be=new u(!1),kn=m(),Et=l("li"),ta=l("p"),Mn=r("Use the episode to estimate the gradient "),_e=new u(!1),Cn=m(),$t=l("figure"),$t.innerHTML=yl,Ln=m(),Ma=l("li"),aa=l("p"),Pn=r("Update the weights of the policy: "),ke=new u(!1),Me=m(),jt=l("p"),jt.textContent=xl,Ce=m(),X=l("ul"),w=l("li"),Le=new u(!1),Pe=r(" is the direction of "),sa=l("strong"),sa.textContent=bl,Tn=r(` of selecting action at from state st.
This tells us `),ea=l("strong"),ea.textContent=_l,zn=r(" if we want to increase/decrease the log probability of selecting action "),Te=new u(!1),ze=r(" at state "),Ee=new u(!1),$e=r("."),En=m(),Ht=l("li"),je=new u(!1),He=r(": is the scoring function:"),na=l("ul"),na.innerHTML=kl,Ie=m(),It=l("p"),It.innerHTML=Ml,Re=m(),Y=l("figure"),Y.innerHTML=Cl,Ge=m(),Ca=l("p"),this.h()},l(t){const s=Ti("svelte-1phssyn",document.head);z=i(s,"META",{name:!0,content:!0}),s.forEach(a),za=p(t),va=i(t,"P",{}),h(va).forEach(a),Ea=p(t),E=i(t,"H1",{class:!0});var Ae=h(E);S=i(Ae,"A",{id:!0,class:!0,href:!0});var Ll=h(S);fa=i(Ll,"SPAN",{});var Pl=h(fa);oa(at.$$.fragment,Pl),Pl.forEach(a),Ll.forEach(a),Xe=p(Ae),St=i(Ae,"SPAN",{"data-svelte-h":!0}),g(St)!=="svelte-rokens"&&(St.textContent=Rn),Ae.forEach(a),$a=p(t),$=i(t,"H2",{class:!0});var Je=h($);A=i(Je,"A",{id:!0,class:!0,href:!0});var Tl=h(A);wa=i(Tl,"SPAN",{});var zl=h(wa);oa(st.$$.fragment,zl),zl.forEach(a),Tl.forEach(a),Ye=p(Je),At=i(Je,"SPAN",{"data-svelte-h":!0}),g(At)!=="svelte-1isqvh0"&&(At.textContent=Gn),Je.forEach(a),ja=p(t),k=i(t,"P",{});var la=h(k);Ze=o(la,"We just learned that policy-gradient methods aim to find parameters "),Ha=d(la,!1),Ia=o(la," that "),Jt=i(la,"STRONG",{"data-svelte-h":!0}),g(Jt)!=="svelte-1vrdngf"&&(Jt.textContent=Sn),tn=o(la,"."),la.forEach(a),Ra=p(t),et=i(t,"P",{"data-svelte-h":!0}),g(et)!=="svelte-1ocflgo"&&(et.innerHTML=An),Ga=p(t),nt=i(t,"P",{"data-svelte-h":!0}),g(nt)!=="svelte-okfb72"&&(nt.textContent=Jn),Sa=p(t),lt=i(t,"UL",{"data-svelte-h":!0}),g(lt)!=="svelte-bs6s8l"&&(lt.innerHTML=Nn),Aa=p(t),it=i(t,"IMG",{src:!0,alt:!0}),Ja=p(t),mt=i(t,"P",{"data-svelte-h":!0}),g(mt)!=="svelte-1usf972"&&(mt.innerHTML=On),Na=p(t),pt=i(t,"P",{"data-svelte-h":!0}),g(pt)!=="svelte-y55wye"&&(pt.innerHTML=qn),Ua=p(t),rt=i(t,"P",{"data-svelte-h":!0}),g(rt)!=="svelte-1r32kyr"&&(rt.innerHTML=Wn),Oa=p(t),J=i(t,"P",{});var Ne=h(J);an=o(Ne,"So for each state-action pair, we want to increase the "),qa=d(Ne,!1),Wa=o(Ne,": the probability of taking that action at that state. Or decrease if we lost."),Ne.forEach(a),Da=p(t),ot=i(t,"P",{"data-svelte-h":!0}),g(ot)!=="svelte-368gi1"&&(ot.textContent=Dn),Fa=p(t),N=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(N)!=="svelte-r97oyl"&&(N.innerHTML=Fn),Ba=p(t),ht=i(t,"P",{"data-svelte-h":!0}),g(ht)!=="svelte-h48cfn"&&(ht.textContent=Bn),Ka=p(t),j=i(t,"H2",{class:!0});var Ue=h(j);U=i(Ue,"A",{id:!0,class:!0,href:!0});var El=h(U);ya=i(El,"SPAN",{});var $l=h(ya);oa(ct.$$.fragment,$l),$l.forEach(a),El.forEach(a),sn=p(Ue),Nt=i(Ue,"SPAN",{"data-svelte-h":!0}),g(Nt)!=="svelte-rokens"&&(Nt.textContent=Kn),Ue.forEach(a),Qa=p(t),f=i(t,"P",{});var T=h(f);en=o(T,"We have our stochastic policy "),Va=d(T,!1),Xa=o(T," which has a parameter "),Ya=d(T,!1),Za=o(T,". This "),ts=d(T,!1),as=o(T,", given a state, "),Ut=i(T,"STRONG",{"data-svelte-h":!0}),g(Ut)!=="svelte-hu1hfg"&&(Ut.textContent=Qn),nn=o(T,"."),T.forEach(a),ss=p(t),O=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(O)!=="svelte-1l2lqzr"&&(O.innerHTML=Vn),es=p(t),y=i(t,"P",{});var Z=h(y);ln=o(Z,"Where "),ns=d(Z,!1),ls=o(Z," is the probability of the agent selecting action "),is=d(Z,!1),ms=o(Z," from state "),ps=d(Z,!1),rs=o(Z," given our policy."),Z.forEach(a),os=p(t),H=i(t,"P",{});var La=h(H);Ot=i(La,"STRONG",{"data-svelte-h":!0}),g(Ot)!=="svelte-1i8sglg"&&(Ot.textContent=Xn),mn=o(La," We need to have a way to measure it. To know that, we define a score/objective function called "),hs=d(La,!1),cs=o(La,"."),La.forEach(a),gs=p(t),I=i(t,"H3",{class:!0});var Oe=h(I);q=i(Oe,"A",{id:!0,class:!0,href:!0});var jl=h(q);xa=i(jl,"SPAN",{});var Hl=h(xa);oa(gt.$$.fragment,Hl),Hl.forEach(a),jl.forEach(a),pn=p(Oe),qt=i(Oe,"SPAN",{"data-svelte-h":!0}),g(qt)!=="svelte-5wa9wd"&&(qt.textContent=Yn),Oe.forEach(a),us=p(t),ut=i(t,"P",{"data-svelte-h":!0}),g(ut)!=="svelte-1xlu0oc"&&(ut.innerHTML=Zn),ds=p(t),dt=i(t,"IMG",{src:!0,alt:!0}),vs=p(t),vt=i(t,"P",{"data-svelte-h":!0}),g(vt)!=="svelte-7h4zyq"&&(vt.textContent=al),fs=p(t),Wt=i(t,"UL",{});var Il=h(Wt);b=i(Il,"LI",{});var tt=h(b);rn=o(tt,"The "),Dt=i(tt,"EM",{"data-svelte-h":!0}),g(Dt)!=="svelte-zzl69g"&&(Dt.textContent=sl),on=o(tt," (also called expected cumulative reward), is the weighted average (where the weights are given by "),ws=d(tt,!1),ys=o(tt," of all possible values that the return "),xs=d(tt,!1),bs=o(tt," can take)."),tt.forEach(a),Il.forEach(a),_s=p(t),ft=i(t,"IMG",{src:!0,alt:!0}),ks=p(t),W=i(t,"UL",{});var qe=h(W);Ft=i(qe,"LI",{});var $n=h(Ft);Ms=d($n,!1),Cs=o($n," :  Return from an arbitrary trajectory. To take this quantity and use it to calculate the expected return, we need to multiply it by the probability of each possible trajectory."),$n.forEach(a),hn=p(qe),M=i(qe,"LI",{});var Rt=h(M);Ls=d(Rt,!1),Ps=o(Rt," : Probability of each possible trajectory "),Ts=d(Rt,!1),zs=o(Rt," (that probability depends on "),Es=d(Rt,!1),$s=o(Rt," since it defines the policy that it uses to select the actions of the trajectory which has an impact of the states visited)."),Rt.forEach(a),qe.forEach(a),js=p(t),wt=i(t,"IMG",{src:!0,alt:!0}),Hs=p(t),Bt=i(t,"UL",{});var Rl=h(Bt);D=i(Rl,"LI",{});var Pa=h(D);Is=d(Pa,!1),Rs=o(Pa," : Expected return, we calculate it by summing for all trajectories, the probability of taking that trajectory given "),Gs=d(Pa,!1),Ss=o(Pa," multiplied by the return of this trajectory."),Pa.forEach(a),Rl.forEach(a),As=p(t),F=i(t,"P",{});var We=h(F);cn=o(We,"Our objective then is to maximize the expected cumulative reward by finding the "),Js=d(We,!1),Ns=o(We," that will output the best action probability distributions:"),We.forEach(a),Us=p(t),yt=i(t,"IMG",{src:!0,alt:!0}),Os=p(t),R=i(t,"H2",{class:!0});var De=h(R);B=i(De,"A",{id:!0,class:!0,href:!0});var Gl=h(B);ba=i(Gl,"SPAN",{});var Sl=h(ba);oa(xt.$$.fragment,Sl),Sl.forEach(a),Gl.forEach(a),gn=p(De),Kt=i(De,"SPAN",{"data-svelte-h":!0}),g(Kt)!=="svelte-zlkvza"&&(Kt.textContent=il),De.forEach(a),qs=p(t),v=i(t,"P",{});var x=h(v);un=o(x,"Policy-gradient is an optimization problem: we want to find the values of "),Ws=d(x,!1),Ds=o(x," that maximize our objective function "),Fs=d(x,!1),Bs=o(x,", so we need to use "),Qt=i(x,"STRONG",{"data-svelte-h":!0}),g(Qt)!=="svelte-1m10mlp"&&(Qt.textContent=ml),dn=o(x,". It’s the inverse of "),Vt=i(x,"EM",{"data-svelte-h":!0}),g(Vt)!=="svelte-1h262ip"&&(Vt.textContent=pl),vn=o(x," since it gives the direction of the steepest increase of "),Ks=d(x,!1),Qs=o(x,"."),x.forEach(a),Vs=p(t),bt=i(t,"P",{"data-svelte-h":!0}),g(bt)!=="svelte-tm5v0z"&&(bt.innerHTML=rl),Xs=p(t),_t=i(t,"P",{"data-svelte-h":!0}),g(_t)!=="svelte-bg30bb"&&(_t.textContent=ol),Ys=p(t),Xt=i(t,"P",{});var Al=h(Xt);Zs=d(Al,!1),Al.forEach(a),te=p(t),C=i(t,"P",{});var ia=h(C);fn=o(ia,"We can repeatedly apply this update in the hopes that "),ae=d(ia,!1),se=o(ia," converges to the value that maximizes "),ee=d(ia,!1),ne=o(ia,"."),ia.forEach(a),le=p(t),K=i(t,"P",{});var Fe=h(K);wn=o(Fe,"However, there are two problems with computing the derivative of "),ie=d(Fe,!1),me=o(Fe,":"),Fe.forEach(a),pe=p(t),kt=i(t,"OL",{"data-svelte-h":!0}),g(kt)!=="svelte-1ccvper"&&(kt.innerHTML=hl),re=p(t),Mt=i(t,"IMG",{src:!0,alt:!0}),oe=p(t),Ct=i(t,"P",{"data-svelte-h":!0}),g(Ct)!=="svelte-mhy87w"&&(Ct.textContent=gl),he=p(t),Lt=i(t,"IMG",{src:!0,alt:!0}),ce=p(t),Pt=i(t,"P",{"data-svelte-h":!0}),g(Pt)!=="svelte-12htye5"&&(Pt.textContent=dl),ge=p(t),G=i(t,"H2",{class:!0});var Be=h(G);Q=i(Be,"A",{id:!0,class:!0,href:!0});var Jl=h(Q);_a=i(Jl,"SPAN",{});var Nl=h(_a);oa(Tt.$$.fragment,Nl),Nl.forEach(a),Jl.forEach(a),yn=p(Be),Yt=i(Be,"SPAN",{"data-svelte-h":!0}),g(Yt)!=="svelte-1p05r7a"&&(Yt.textContent=vl),Be.forEach(a),ue=p(t),L=i(t,"P",{});var ma=h(L);xn=o(ma,"The Reinforce algorithm, also called Monte-Carlo policy-gradient, is a policy-gradient algorithm that "),Zt=i(ma,"STRONG",{"data-svelte-h":!0}),g(Zt)!=="svelte-j30ps8"&&(Zt.textContent=fl),bn=p(ma),de=d(ma,!1),ve=o(ma,":"),ma.forEach(a),fe=p(t),zt=i(t,"P",{"data-svelte-h":!0}),g(zt)!=="svelte-zhyuac"&&(zt.textContent=wl),we=p(t),P=i(t,"UL",{});var pa=h(P);ka=i(pa,"LI",{});var Ul=h(ka);V=i(Ul,"P",{});var Ta=h(V);_n=o(Ta,"Use the policy "),ye=d(Ta,!1),xe=o(Ta,"  to collect an episode "),be=d(Ta,!1),Ta.forEach(a),Ul.forEach(a),kn=p(pa),Et=i(pa,"LI",{});var Ke=h(Et);ta=i(Ke,"P",{});var jn=h(ta);Mn=o(jn,"Use the episode to estimate the gradient "),_e=d(jn,!1),jn.forEach(a),Cn=p(Ke),$t=i(Ke,"FIGURE",{class:!0,"data-svelte-h":!0}),g($t)!=="svelte-1qgmq47"&&($t.innerHTML=yl),Ke.forEach(a),Ln=p(pa),Ma=i(pa,"LI",{});var Ol=h(Ma);aa=i(Ol,"P",{});var Hn=h(aa);Pn=o(Hn,"Update the weights of the policy: "),ke=d(Hn,!1),Hn.forEach(a),Ol.forEach(a),pa.forEach(a),Me=p(t),jt=i(t,"P",{"data-svelte-h":!0}),g(jt)!=="svelte-1ubiwhq"&&(jt.textContent=xl),Ce=p(t),X=i(t,"UL",{});var Qe=h(X);w=i(Qe,"LI",{});var _=h(w);Le=d(_,!1),Pe=o(_," is the direction of "),sa=i(_,"STRONG",{"data-svelte-h":!0}),g(sa)!=="svelte-1od0czd"&&(sa.textContent=bl),Tn=o(_,` of selecting action at from state st.
This tells us `),ea=i(_,"STRONG",{"data-svelte-h":!0}),g(ea)!=="svelte-v2e0ag"&&(ea.textContent=_l),zn=o(_," if we want to increase/decrease the log probability of selecting action "),Te=d(_,!1),ze=o(_," at state "),Ee=d(_,!1),$e=o(_,"."),_.forEach(a),En=p(Qe),Ht=i(Qe,"LI",{});var Ve=h(Ht);je=d(Ve,!1),He=o(Ve,": is the scoring function:"),na=i(Ve,"UL",{"data-svelte-h":!0}),g(na)!=="svelte-p5xd27"&&(na.innerHTML=kl),Ve.forEach(a),Qe.forEach(a),Ie=p(t),It=i(t,"P",{"data-svelte-h":!0}),g(It)!=="svelte-22wa60"&&(It.innerHTML=Ml),Re=p(t),Y=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(Y)!=="svelte-j15w63"&&(Y.innerHTML=Cl),Ge=p(t),Ca=i(t,"P",{}),h(Ca).forEach(a),this.h()},h(){c(z,"name","hf:doc:metadata"),c(z,"content",JSON.stringify(Ei)),c(S,"id","diving-deeper-into-policygradient-methods"),c(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(S,"href","#diving-deeper-into-policygradient-methods"),c(E,"class","relative group"),c(A,"id","getting-the-big-picture"),c(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(A,"href","#getting-the-big-picture"),c($,"class","relative group"),Ha.a=Ia,Gt(it.src,Un="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_based.png")||c(it,"src",Un),c(it,"alt","Policy based"),qa.a=Wa,c(N,"class","image table text-center m-0 w-full"),c(U,"id","diving-deeper-into-policygradient-methods"),c(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(U,"href","#diving-deeper-into-policygradient-methods"),c(j,"class","relative group"),Va.a=Xa,Ya.a=Za,ts.a=as,c(O,"class","image table text-center m-0 w-full"),ns.a=ls,is.a=ms,ps.a=rs,hs.a=cs,c(q,"id","the-objective-function"),c(q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(q,"href","#the-objective-function"),c(I,"class","relative group"),Gt(dt.src,tl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/objective.jpg")||c(dt,"src",tl),c(dt,"alt","Return"),ws.a=ys,xs.a=bs,Gt(ft.src,el="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/expected_reward.png")||c(ft,"src",el),c(ft,"alt","Return"),Ms.a=Cs,Ls.a=Ps,Ts.a=zs,Es.a=$s,Gt(wt.src,nl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/probability.png")||c(wt,"src",nl),c(wt,"alt","Probability"),Is.a=Rs,Gs.a=Ss,Js.a=Ns,Gt(yt.src,ll="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/max_objective.png")||c(yt,"src",ll),c(yt,"alt","Max objective"),c(B,"id","gradient-ascent-and-the-policygradient-theorem"),c(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(B,"href","#gradient-ascent-and-the-policygradient-theorem"),c(R,"class","relative group"),Ws.a=Ds,Fs.a=Bs,Ks.a=Qs,Zs.a=null,ae.a=se,ee.a=ne,ie.a=me,Gt(Mt.src,cl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/probability.png")||c(Mt,"src",cl),c(Mt,"alt","Probability"),Gt(Lt.src,ul="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_theorem.png")||c(Lt,"src",ul),c(Lt,"alt","Policy Gradient"),c(Q,"id","the-reinforce-algorithm-monte-carlo-reinforce"),c(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Q,"href","#the-reinforce-algorithm-monte-carlo-reinforce"),c(G,"class","relative group"),de.a=ve,ye.a=xe,be.a=null,_e.a=null,c($t,"class","image table text-center m-0 w-full"),ke.a=null,Le.a=Pe,Te.a=ze,Ee.a=$e,je.a=He,c(Y,"class","image table text-center m-0 w-full")},m(t,s){e(document.head,z),n(t,za,s),n(t,va,s),n(t,Ea,s),n(t,E,s),e(E,S),e(S,fa),ha(at,fa,null),e(E,Xe),e(E,St),n(t,$a,s),n(t,$,s),e($,A),e(A,wa),ha(st,wa,null),e($,Ye),e($,At),n(t,ja,s),n(t,k,s),e(k,Ze),Ha.m(ql,k),e(k,Ia),e(k,Jt),e(k,tn),n(t,Ra,s),n(t,et,s),n(t,Ga,s),n(t,nt,s),n(t,Sa,s),n(t,lt,s),n(t,Aa,s),n(t,it,s),n(t,Ja,s),n(t,mt,s),n(t,Na,s),n(t,pt,s),n(t,Ua,s),n(t,rt,s),n(t,Oa,s),n(t,J,s),e(J,an),qa.m(Wl,J),e(J,Wa),n(t,Da,s),n(t,ot,s),n(t,Fa,s),n(t,N,s),n(t,Ba,s),n(t,ht,s),n(t,Ka,s),n(t,j,s),e(j,U),e(U,ya),ha(ct,ya,null),e(j,sn),e(j,Nt),n(t,Qa,s),n(t,f,s),e(f,en),Va.m(Dl,f),e(f,Xa),Ya.m(Fl,f),e(f,Za),ts.m(Bl,f),e(f,as),e(f,Ut),e(f,nn),n(t,ss,s),n(t,O,s),n(t,es,s),n(t,y,s),e(y,ln),ns.m(Kl,y),e(y,ls),is.m(Ql,y),e(y,ms),ps.m(Vl,y),e(y,rs),n(t,os,s),n(t,H,s),e(H,Ot),e(H,mn),hs.m(Xl,H),e(H,cs),n(t,gs,s),n(t,I,s),e(I,q),e(q,xa),ha(gt,xa,null),e(I,pn),e(I,qt),n(t,us,s),n(t,ut,s),n(t,ds,s),n(t,dt,s),n(t,vs,s),n(t,vt,s),n(t,fs,s),n(t,Wt,s),e(Wt,b),e(b,rn),e(b,Dt),e(b,on),ws.m(Yl,b),e(b,ys),xs.m(Zl,b),e(b,bs),n(t,_s,s),n(t,ft,s),n(t,ks,s),n(t,W,s),e(W,Ft),Ms.m(ti,Ft),e(Ft,Cs),e(W,hn),e(W,M),Ls.m(ai,M),e(M,Ps),Ts.m(si,M),e(M,zs),Es.m(ei,M),e(M,$s),n(t,js,s),n(t,wt,s),n(t,Hs,s),n(t,Bt,s),e(Bt,D),Is.m(ni,D),e(D,Rs),Gs.m(li,D),e(D,Ss),n(t,As,s),n(t,F,s),e(F,cn),Js.m(ii,F),e(F,Ns),n(t,Us,s),n(t,yt,s),n(t,Os,s),n(t,R,s),e(R,B),e(B,ba),ha(xt,ba,null),e(R,gn),e(R,Kt),n(t,qs,s),n(t,v,s),e(v,un),Ws.m(mi,v),e(v,Ds),Fs.m(pi,v),e(v,Bs),e(v,Qt),e(v,dn),e(v,Vt),e(v,vn),Ks.m(ri,v),e(v,Qs),n(t,Vs,s),n(t,bt,s),n(t,Xs,s),n(t,_t,s),n(t,Ys,s),n(t,Xt,s),Zs.m(oi,Xt),n(t,te,s),n(t,C,s),e(C,fn),ae.m(hi,C),e(C,se),ee.m(ci,C),e(C,ne),n(t,le,s),n(t,K,s),e(K,wn),ie.m(gi,K),e(K,me),n(t,pe,s),n(t,kt,s),n(t,re,s),n(t,Mt,s),n(t,oe,s),n(t,Ct,s),n(t,he,s),n(t,Lt,s),n(t,ce,s),n(t,Pt,s),n(t,ge,s),n(t,G,s),e(G,Q),e(Q,_a),ha(Tt,_a,null),e(G,yn),e(G,Yt),n(t,ue,s),n(t,L,s),e(L,xn),e(L,Zt),e(L,bn),de.m(ui,L),e(L,ve),n(t,fe,s),n(t,zt,s),n(t,we,s),n(t,P,s),e(P,ka),e(ka,V),e(V,_n),ye.m(di,V),e(V,xe),be.m(vi,V),e(P,kn),e(P,Et),e(Et,ta),e(ta,Mn),_e.m(fi,ta),e(Et,Cn),e(Et,$t),e(P,Ln),e(P,Ma),e(Ma,aa),e(aa,Pn),ke.m(wi,aa),n(t,Me,s),n(t,jt,s),n(t,Ce,s),n(t,X,s),e(X,w),Le.m(yi,w),e(w,Pe),e(w,sa),e(w,Tn),e(w,ea),e(w,zn),Te.m(xi,w),e(w,ze),Ee.m(bi,w),e(w,$e),e(X,En),e(X,Ht),je.m(_i,Ht),e(Ht,He),e(Ht,na),n(t,Ie,s),n(t,It,s),n(t,Re,s),n(t,Y,s),n(t,Ge,s),n(t,Ca,s),Se=!0},p:Mi,i(t){Se||(ca(at.$$.fragment,t),ca(st.$$.fragment,t),ca(ct.$$.fragment,t),ca(gt.$$.fragment,t),ca(xt.$$.fragment,t),ca(Tt.$$.fragment,t),Se=!0)},o(t){ga(at.$$.fragment,t),ga(st.$$.fragment,t),ga(ct.$$.fragment,t),ga(gt.$$.fragment,t),ga(xt.$$.fragment,t),ga(Tt.$$.fragment,t),Se=!1},d(t){t&&(a(za),a(va),a(Ea),a(E),a($a),a($),a(ja),a(k),a(Ra),a(et),a(Ga),a(nt),a(Sa),a(lt),a(Aa),a(it),a(Ja),a(mt),a(Na),a(pt),a(Ua),a(rt),a(Oa),a(J),a(Da),a(ot),a(Fa),a(N),a(Ba),a(ht),a(Ka),a(j),a(Qa),a(f),a(ss),a(O),a(es),a(y),a(os),a(H),a(gs),a(I),a(us),a(ut),a(ds),a(dt),a(vs),a(vt),a(fs),a(Wt),a(_s),a(ft),a(ks),a(W),a(js),a(wt),a(Hs),a(Bt),a(As),a(F),a(Us),a(yt),a(Os),a(R),a(qs),a(v),a(Vs),a(bt),a(Xs),a(_t),a(Ys),a(Xt),a(te),a(C),a(le),a(K),a(pe),a(kt),a(re),a(Mt),a(oe),a(Ct),a(he),a(Lt),a(ce),a(Pt),a(ge),a(G),a(ue),a(L),a(fe),a(zt),a(we),a(P),a(Me),a(jt),a(Ce),a(X),a(Ie),a(It),a(Re),a(Y),a(Ge),a(Ca)),a(z),ua(at),ua(st),ua(ct),ua(gt),ua(xt),ua(Tt)}}}const Ei={local:"diving-deeper-into-policygradient-methods",sections:[{local:"getting-the-big-picture",title:"Getting the big picture"},{local:"diving-deeper-into-policygradient-methods",sections:[{local:"the-objective-function",title:"The objective function"}],title:"Diving deeper into policy-gradient methods"},{local:"gradient-ascent-and-the-policygradient-theorem",title:"Gradient Ascent and the Policy-gradient Theorem"},{local:"the-reinforce-algorithm-monte-carlo-reinforce",title:"The Reinforce algorithm (Monte Carlo Reinforce)"}],title:"Diving deeper into policy-gradient methods"};function $i(In){return Ci(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ri extends Li{constructor(z){super(),Pi(this,z,$i,zi,ki,{})}}export{Ri as component};
