import{s as Tn,f as ee,n as Pn,o as An}from"../chunks/scheduler.37c15a92.js";import{S as Mn,i as Sn,g as n,s as a,u as p,m as En,A as In,h as i,f as t,c as r,j as c,v as f,y as u,n as jn,k as s,o as h,a as o,w as g,d as v,t as m,x as d}from"../chunks/index.b01106c0.js";import{I as w}from"../chunks/IconCopyLink.77b762b4.js";function Dn(Ql){let y,Ct,at,$t,x,E,rt,te,Rl,Ze,Xl="Welcome to the 🤗 Deep Reinforcement Learning Course",bt,I,eo,Lt,le,to="Welcome to the most fascinating topic in Artificial Intelligence: <strong>Deep Reinforcement Learning</strong>.",kt,oe,lo="This course will <strong>teach you about Deep Reinforcement Learning from beginner to expert</strong>. It’s completely free and open-source!",Ht,ne,oo="In this introduction unit you’ll:",Tt,ie,no="<li>Learn more about the <strong>course content</strong>.</li> <li><strong>Define the path</strong> you’re going to take (either self-audit or certification process).</li> <li>Learn more about the <strong>AI vs. AI challenges</strong> you’re going to participate in.</li> <li>Learn more <strong>about us</strong>.</li> <li><strong>Create your Hugging Face account</strong> (it’s free).</li> <li><strong>Sign-up to our Discord server</strong>, the place where you can chat with your classmates and us (the Hugging Face team).</li>",Pt,se,io="Let’s get started!",At,_,j,ht,ae,ql,Je,so="What to expect?",Mt,re,ao="In this course, you will:",St,he,ro='<li>📖 Study Deep Reinforcement Learning in <strong>theory and practice.</strong></li> <li>🧑‍💻 Learn to <strong>use famous Deep RL libraries</strong> such as <a href="https://stable-baselines3.readthedocs.io/en/master/" rel="nofollow">Stable Baselines3</a>, <a href="https://github.com/DLR-RM/rl-baselines3-zoo" rel="nofollow">RL Baselines3 Zoo</a>, <a href="https://samplefactory.dev/" rel="nofollow">Sample Factory</a> and <a href="https://github.com/vwxyzjn/cleanrl" rel="nofollow">CleanRL</a>.</li> <li>🤖 <strong>Train agents in unique environments</strong> such as <a href="https://huggingface.co/spaces/ThomasSimonini/SnowballFight" rel="nofollow">SnowballFight</a>, <a href="https://huggingface.co/spaces/ThomasSimonini/Huggy" rel="nofollow">Huggy the Doggo 🐶</a>, <a href="https://vizdoom.cs.put.edu.pl/" rel="nofollow">VizDoom (Doom)</a> and classical ones such as <a href="https://gymnasium.farama.org/environments/atari/space_invaders/" rel="nofollow">Space Invaders</a>, <a href="https://pybullet.org/wordpress/" rel="nofollow">PyBullet</a> and more.</li> <li>💾 Share your <strong>trained agents with one line of code to the Hub</strong> and also download powerful agents from the community.</li> <li>🏆 Participate in challenges where you will <strong>evaluate your agents against other teams. You’ll also get to play against the agents you’ll train.</strong></li> <li>🎓 <strong>Earn a certificate of completion</strong> by completing 80% of the assignments.</li>',Et,ue,ho="And more!",It,ce,uo="At the end of this course, <strong>you’ll get a solid foundation from the basics to the SOTA (state-of-the-art) of methods</strong>.",jt,pe,co='Don’t forget to <strong><a href="http://eepurl.com/ic5ZUD">sign up to the course</a></strong> (we are collecting your email to be able to <strong>send you the links when each Unit is published and give you information about the challenges and updates).</strong>',Dt,fe,po='Sign up  👉 <a href="http://eepurl.com/ic5ZUD">here</a>',Nt,C,D,ut,ge,Ul,Ve,fo="What does the course look like?",Wt,ve,go="The course is composed of:",Rt,me,vo='<li><p><em>A theory part</em>: where you learn a <strong>concept in theory</strong>.</p></li> <li><p><em>A hands-on</em>: where you’ll learn <strong>to use famous Deep RL libraries</strong> to train your agents in unique environments. These hands-on will be <strong>Google Colab notebooks with companion tutorial videos</strong> if you prefer learning with video format!</p></li> <li><p><em>Challenges</em>: you’ll get to put your agent to compete against other agents in different challenges. There will also be <a href="https://huggingface.co/spaces/huggingface-projects/Deep-Reinforcement-Learning-Leaderboard" rel="nofollow">a leaderboard</a> for you to compare the agents’ performance.</p></li>',qt,$,N,ct,de,Gl,Ke,mo="What's the syllabus?",Ut,we,wo="This is the course’s syllabus:",Gt,W,yo,zt,R,xo,Ft,b,q,pt,ye,zl,Qe,_o="Two paths: choose your own adventure",Ot,U,Co,Bt,xe,$o="You can choose to follow this course either:",Yt,_e,bo="<li><em>To get a certificate of completion</em>: you need to complete 80% of the assignments.</li> <li><em>To get a certificate of honors</em>: you need to complete 100% of the assignments.</li> <li><em>As a simple audit</em>: you can participate in all challenges and do assignments if you want.</li>",Zt,Ce,Lo=`There’s <strong>no deadlines, the course is self-paced</strong>.
Both paths <strong>are completely free</strong>.
Whatever path you choose, we advise you <strong>to follow the recommended pace to enjoy the course and challenges with your fellow classmates.</strong>`,Jt,$e,ko="You don’t need to tell us which path you choose. <strong>If you get more than 80% of the assignments done, you’ll get a certificate.</strong>",Vt,L,G,ft,be,Fl,Xe,Ho="The Certification Process",Kt,Le,To="The certification process is <strong>completely free</strong>:",Qt,ke,Po="<li><em>To get a certificate of completion</em>: you need to complete 80% of the assignments.</li> <li><em>To get a certificate of honors</em>: you need to complete 100% of the assignments.</li>",Xt,He,Ao="Again, there’s <strong>no deadline</strong> since the course is self paced. But our advice <strong>is to follow the recommended pace section</strong>.",el,z,Mo,tl,k,F,gt,Te,Ol,et,So="How to get most of the course?",ll,Pe,Eo="To get most of the course, we have some advice:",ol,Ae,Io='<li><a href="https://discord.gg/ydHrjt3WP5">Join study groups in Discord </a>: studying in groups is always easier. To do that, you need to join our discord server. If you&#39;re new to Discord, no worries! We have some tools that will help you learn about it.</li> <li><strong>Do the quizzes and assignments</strong>: the best way to learn is to do and test yourself.</li> <li><strong>Define a schedule to stay in sync</strong>: you can use our recommended pace schedule below or create yours.</li>',nl,O,jo,il,H,B,vt,Me,Bl,tt,Do="What tools do I need?",sl,Se,No="You need only 3 things:",al,Ee,Wo='<li><em>A computer</em> with an internet connection.</li> <li><em>Google Colab (free version)</em>: most of our hands-on will use Google Colab, the <strong>free version is enough.</strong></li> <li>A <em>Hugging Face Account</em>: to push and load models. If you don’t have an account yet, you can create one <strong><a href="https://hf.co/join" rel="nofollow">here</a></strong> (it’s free).</li>',rl,Y,Ro,hl,T,Z,mt,Ie,Yl,lt,qo="What is the recommended pace?",ul,je,Uo="Each chapter in this course is designed <strong>to be completed in 1 week, with approximately 3-4 hours of work per week</strong>. However, you can take as much time as necessary to complete the course. If you want to dive into a topic more in-depth, we’ll provide additional resources to help you achieve that.",cl,P,J,dt,De,Zl,ot,Go="Who are we",pl,Ne,zo='<li><a href="https://twitter.com/ThomasSimonini">Thomas Simonini</a> is a Developer Advocate at Hugging Face 🤗 specializing in Deep Reinforcement Learning. He founded the Deep Reinforcement Learning Course in 2018, which became one of the most used courses in Deep RL.</li>',fl,We,Fo="About the team:",gl,Re,Oo='<li><a href="https://twitter.com/osanseviero">Omar Sanseviero</a> is a Machine Learning Engineer at Hugging Face where he works in the intersection of ML, Community and Open Source. Previously, Omar worked as a Software Engineer at Google in the teams of Assistant and TensorFlow Graphics. He is from Peru and likes llamas 🦙.</li> <li><a href="https://twitter.com/RisingSayak">Sayak Paul</a> is a Developer Advocate Engineer at Hugging Face. He&#39;s interested in the area of representation learning (self-supervision, semi-supervision, model robustness). And he loves watching crime and action thrillers 🔪.</li>',vl,A,V,wt,qe,Jl,nt,Bo="What are the challenges in this course?",ml,Ue,Yo="In this new version of the course, you have two types of challenges:",dl,Ge,Zo='<li><a href="https://huggingface.co/spaces/huggingface-projects/Deep-Reinforcement-Learning-Leaderboard" rel="nofollow">A leaderboard</a> to compare your agent’s performance to other classmates’.</li> <li><a href="https://huggingface.co/learn/deep-rl-course/unit7/introduction?fw=pt" rel="nofollow">AI vs. AI challenges</a> where you can train your agent and compete against other classmates’ agents.</li>',wl,K,Jo,yl,M,Q,yt,ze,Vl,it,Vo="I found a bug, or I want to improve the course",xl,Fe,Ko="Contributions are welcomed 🤗",_l,Oe,Qo='<li>If you <em>found a bug 🐛 in a notebook</em>, please <a href="https://github.com/huggingface/deep-rl-class/issues">open an issue</a> and <strong>describe the problem</strong>.</li> <li>If you <em>want to improve the course</em>, you can <a href="https://github.com/huggingface/deep-rl-class/pulls">open a Pull Request.</a></li>',Cl,S,X,xt,Be,Kl,st,Xo="I still have questions",$l,Ye,en='Please ask your question in our <a href="https://discord.gg/ydHrjt3WP5">discord server #rl-discussions.</a>',bl,_t,Ll;return te=new w({}),ae=new w({}),ge=new w({}),de=new w({}),ye=new w({}),be=new w({}),Te=new w({}),Me=new w({}),Ie=new w({}),De=new w({}),qe=new w({}),ze=new w({}),Be=new w({}),{c(){y=n("meta"),Ct=a(),at=n("p"),$t=a(),x=n("h1"),E=n("a"),rt=n("span"),p(te.$$.fragment),Rl=a(),Ze=n("span"),Ze.textContent=Xl,bt=a(),I=n("img"),Lt=a(),le=n("p"),le.innerHTML=to,kt=a(),oe=n("p"),oe.innerHTML=lo,Ht=a(),ne=n("p"),ne.textContent=oo,Tt=a(),ie=n("ul"),ie.innerHTML=no,Pt=a(),se=n("p"),se.textContent=io,At=a(),_=n("h2"),j=n("a"),ht=n("span"),p(ae.$$.fragment),ql=a(),Je=n("span"),Je.textContent=so,Mt=a(),re=n("p"),re.textContent=ao,St=a(),he=n("ul"),he.innerHTML=ro,Et=a(),ue=n("p"),ue.textContent=ho,It=a(),ce=n("p"),ce.innerHTML=uo,jt=a(),pe=n("p"),pe.innerHTML=co,Dt=a(),fe=n("p"),fe.innerHTML=po,Nt=a(),C=n("h2"),D=n("a"),ut=n("span"),p(ge.$$.fragment),Ul=a(),Ve=n("span"),Ve.textContent=fo,Wt=a(),ve=n("p"),ve.textContent=go,Rt=a(),me=n("ul"),me.innerHTML=vo,qt=a(),$=n("h2"),N=n("a"),ct=n("span"),p(de.$$.fragment),Gl=a(),Ke=n("span"),Ke.textContent=mo,Ut=a(),we=n("p"),we.textContent=wo,Gt=a(),W=n("img"),zt=a(),R=n("img"),Ft=a(),b=n("h2"),q=n("a"),pt=n("span"),p(ye.$$.fragment),zl=a(),Qe=n("span"),Qe.textContent=_o,Ot=a(),U=n("img"),Bt=a(),xe=n("p"),xe.textContent=$o,Yt=a(),_e=n("ul"),_e.innerHTML=bo,Zt=a(),Ce=n("p"),Ce.innerHTML=Lo,Jt=a(),$e=n("p"),$e.innerHTML=ko,Vt=a(),L=n("h2"),G=n("a"),ft=n("span"),p(be.$$.fragment),Fl=a(),Xe=n("span"),Xe.textContent=Ho,Kt=a(),Le=n("p"),Le.innerHTML=To,Qt=a(),ke=n("ul"),ke.innerHTML=Po,Xt=a(),He=n("p"),He.innerHTML=Ao,el=a(),z=n("img"),tl=a(),k=n("h2"),F=n("a"),gt=n("span"),p(Te.$$.fragment),Ol=a(),et=n("span"),et.textContent=So,ll=a(),Pe=n("p"),Pe.textContent=Eo,ol=a(),Ae=n("ol"),Ae.innerHTML=Io,nl=a(),O=n("img"),il=a(),H=n("h2"),B=n("a"),vt=n("span"),p(Me.$$.fragment),Bl=a(),tt=n("span"),tt.textContent=Do,sl=a(),Se=n("p"),Se.textContent=No,al=a(),Ee=n("ul"),Ee.innerHTML=Wo,rl=a(),Y=n("img"),hl=a(),T=n("h2"),Z=n("a"),mt=n("span"),p(Ie.$$.fragment),Yl=a(),lt=n("span"),lt.textContent=qo,ul=a(),je=n("p"),je.innerHTML=Uo,cl=a(),P=n("h2"),J=n("a"),dt=n("span"),p(De.$$.fragment),Zl=a(),ot=n("span"),ot.textContent=Go,pl=En(`


About the author:
`),Ne=n("ul"),Ne.innerHTML=zo,fl=a(),We=n("p"),We.textContent=Fo,gl=a(),Re=n("ul"),Re.innerHTML=Oo,vl=a(),A=n("h2"),V=n("a"),wt=n("span"),p(qe.$$.fragment),Jl=a(),nt=n("span"),nt.textContent=Bo,ml=a(),Ue=n("p"),Ue.textContent=Yo,dl=a(),Ge=n("ul"),Ge.innerHTML=Zo,wl=a(),K=n("img"),yl=a(),M=n("h2"),Q=n("a"),yt=n("span"),p(ze.$$.fragment),Vl=a(),it=n("span"),it.textContent=Vo,xl=a(),Fe=n("p"),Fe.textContent=Ko,_l=a(),Oe=n("ul"),Oe.innerHTML=Qo,Cl=a(),S=n("h2"),X=n("a"),xt=n("span"),p(Be.$$.fragment),Kl=a(),st=n("span"),st.textContent=Xo,$l=a(),Ye=n("p"),Ye.innerHTML=en,bl=a(),_t=n("p"),this.h()},l(e){const l=In("svelte-1phssyn",document.head);y=i(l,"META",{name:!0,content:!0}),l.forEach(t),Ct=r(e),at=i(e,"P",{}),c(at).forEach(t),$t=r(e),x=i(e,"H1",{class:!0});var kl=c(x);E=i(kl,"A",{id:!0,class:!0,href:!0});var tn=c(E);rt=i(tn,"SPAN",{});var ln=c(rt);f(te.$$.fragment,ln),ln.forEach(t),tn.forEach(t),Rl=r(kl),Ze=i(kl,"SPAN",{"data-svelte-h":!0}),u(Ze)!=="svelte-1lkxj2y"&&(Ze.textContent=Xl),kl.forEach(t),bt=r(e),I=i(e,"IMG",{src:!0,alt:!0,width:!0}),Lt=r(e),le=i(e,"P",{"data-svelte-h":!0}),u(le)!=="svelte-lar89z"&&(le.innerHTML=to),kt=r(e),oe=i(e,"P",{"data-svelte-h":!0}),u(oe)!=="svelte-9h5dhu"&&(oe.innerHTML=lo),Ht=r(e),ne=i(e,"P",{"data-svelte-h":!0}),u(ne)!=="svelte-q5r4ab"&&(ne.textContent=oo),Tt=r(e),ie=i(e,"UL",{"data-svelte-h":!0}),u(ie)!=="svelte-iulplw"&&(ie.innerHTML=no),Pt=r(e),se=i(e,"P",{"data-svelte-h":!0}),u(se)!=="svelte-4b3xjd"&&(se.textContent=io),At=r(e),_=i(e,"H2",{class:!0});var Hl=c(_);j=i(Hl,"A",{id:!0,class:!0,href:!0});var on=c(j);ht=i(on,"SPAN",{});var nn=c(ht);f(ae.$$.fragment,nn),nn.forEach(t),on.forEach(t),ql=r(Hl),Je=i(Hl,"SPAN",{"data-svelte-h":!0}),u(Je)!=="svelte-9yd7pg"&&(Je.textContent=so),Hl.forEach(t),Mt=r(e),re=i(e,"P",{"data-svelte-h":!0}),u(re)!=="svelte-f2qxb3"&&(re.textContent=ao),St=r(e),he=i(e,"UL",{"data-svelte-h":!0}),u(he)!=="svelte-kd6znf"&&(he.innerHTML=ro),Et=r(e),ue=i(e,"P",{"data-svelte-h":!0}),u(ue)!=="svelte-t67g99"&&(ue.textContent=ho),It=r(e),ce=i(e,"P",{"data-svelte-h":!0}),u(ce)!=="svelte-1xij83d"&&(ce.innerHTML=uo),jt=r(e),pe=i(e,"P",{"data-svelte-h":!0}),u(pe)!=="svelte-i91mrq"&&(pe.innerHTML=co),Dt=r(e),fe=i(e,"P",{"data-svelte-h":!0}),u(fe)!=="svelte-a79ye4"&&(fe.innerHTML=po),Nt=r(e),C=i(e,"H2",{class:!0});var Tl=c(C);D=i(Tl,"A",{id:!0,class:!0,href:!0});var sn=c(D);ut=i(sn,"SPAN",{});var an=c(ut);f(ge.$$.fragment,an),an.forEach(t),sn.forEach(t),Ul=r(Tl),Ve=i(Tl,"SPAN",{"data-svelte-h":!0}),u(Ve)!=="svelte-1vrta85"&&(Ve.textContent=fo),Tl.forEach(t),Wt=r(e),ve=i(e,"P",{"data-svelte-h":!0}),u(ve)!=="svelte-1ee6w8b"&&(ve.textContent=go),Rt=r(e),me=i(e,"UL",{"data-svelte-h":!0}),u(me)!=="svelte-1ju8ahi"&&(me.innerHTML=vo),qt=r(e),$=i(e,"H2",{class:!0});var Pl=c($);N=i(Pl,"A",{id:!0,class:!0,href:!0});var rn=c(N);ct=i(rn,"SPAN",{});var hn=c(ct);f(de.$$.fragment,hn),hn.forEach(t),rn.forEach(t),Gl=r(Pl),Ke=i(Pl,"SPAN",{"data-svelte-h":!0}),u(Ke)!=="svelte-1ntycka"&&(Ke.textContent=mo),Pl.forEach(t),Ut=r(e),we=i(e,"P",{"data-svelte-h":!0}),u(we)!=="svelte-oyiyj9"&&(we.textContent=wo),Gt=r(e),W=i(e,"IMG",{src:!0,alt:!0,width:!0}),zt=r(e),R=i(e,"IMG",{src:!0,alt:!0,width:!0}),Ft=r(e),b=i(e,"H2",{class:!0});var Al=c(b);q=i(Al,"A",{id:!0,class:!0,href:!0});var un=c(q);pt=i(un,"SPAN",{});var cn=c(pt);f(ye.$$.fragment,cn),cn.forEach(t),un.forEach(t),zl=r(Al),Qe=i(Al,"SPAN",{"data-svelte-h":!0}),u(Qe)!=="svelte-55kfej"&&(Qe.textContent=_o),Al.forEach(t),Ot=r(e),U=i(e,"IMG",{src:!0,alt:!0,width:!0}),Bt=r(e),xe=i(e,"P",{"data-svelte-h":!0}),u(xe)!=="svelte-1ygf71c"&&(xe.textContent=$o),Yt=r(e),_e=i(e,"UL",{"data-svelte-h":!0}),u(_e)!=="svelte-186gjk5"&&(_e.innerHTML=bo),Zt=r(e),Ce=i(e,"P",{"data-svelte-h":!0}),u(Ce)!=="svelte-1tfwr9k"&&(Ce.innerHTML=Lo),Jt=r(e),$e=i(e,"P",{"data-svelte-h":!0}),u($e)!=="svelte-qy3r5p"&&($e.innerHTML=ko),Vt=r(e),L=i(e,"H2",{class:!0});var Ml=c(L);G=i(Ml,"A",{id:!0,class:!0,href:!0});var pn=c(G);ft=i(pn,"SPAN",{});var fn=c(ft);f(be.$$.fragment,fn),fn.forEach(t),pn.forEach(t),Fl=r(Ml),Xe=i(Ml,"SPAN",{"data-svelte-h":!0}),u(Xe)!=="svelte-jkkv2x"&&(Xe.textContent=Ho),Ml.forEach(t),Kt=r(e),Le=i(e,"P",{"data-svelte-h":!0}),u(Le)!=="svelte-1ybbpoz"&&(Le.innerHTML=To),Qt=r(e),ke=i(e,"UL",{"data-svelte-h":!0}),u(ke)!=="svelte-eoc7ia"&&(ke.innerHTML=Po),Xt=r(e),He=i(e,"P",{"data-svelte-h":!0}),u(He)!=="svelte-13oa6ep"&&(He.innerHTML=Ao),el=r(e),z=i(e,"IMG",{src:!0,alt:!0,width:!0}),tl=r(e),k=i(e,"H2",{class:!0});var Sl=c(k);F=i(Sl,"A",{id:!0,class:!0,href:!0});var gn=c(F);gt=i(gn,"SPAN",{});var vn=c(gt);f(Te.$$.fragment,vn),vn.forEach(t),gn.forEach(t),Ol=r(Sl),et=i(Sl,"SPAN",{"data-svelte-h":!0}),u(et)!=="svelte-1dskk5"&&(et.textContent=So),Sl.forEach(t),ll=r(e),Pe=i(e,"P",{"data-svelte-h":!0}),u(Pe)!=="svelte-180fzyv"&&(Pe.textContent=Eo),ol=r(e),Ae=i(e,"OL",{"data-svelte-h":!0}),u(Ae)!=="svelte-128p29f"&&(Ae.innerHTML=Io),nl=r(e),O=i(e,"IMG",{src:!0,alt:!0,width:!0}),il=r(e),H=i(e,"H2",{class:!0});var El=c(H);B=i(El,"A",{id:!0,class:!0,href:!0});var mn=c(B);vt=i(mn,"SPAN",{});var dn=c(vt);f(Me.$$.fragment,dn),dn.forEach(t),mn.forEach(t),Bl=r(El),tt=i(El,"SPAN",{"data-svelte-h":!0}),u(tt)!=="svelte-10jvi4x"&&(tt.textContent=Do),El.forEach(t),sl=r(e),Se=i(e,"P",{"data-svelte-h":!0}),u(Se)!=="svelte-loeab5"&&(Se.textContent=No),al=r(e),Ee=i(e,"UL",{"data-svelte-h":!0}),u(Ee)!=="svelte-7fy04p"&&(Ee.innerHTML=Wo),rl=r(e),Y=i(e,"IMG",{src:!0,alt:!0,width:!0}),hl=r(e),T=i(e,"H2",{class:!0});var Il=c(T);Z=i(Il,"A",{id:!0,class:!0,href:!0});var wn=c(Z);mt=i(wn,"SPAN",{});var yn=c(mt);f(Ie.$$.fragment,yn),yn.forEach(t),wn.forEach(t),Yl=r(Il),lt=i(Il,"SPAN",{"data-svelte-h":!0}),u(lt)!=="svelte-x1n65b"&&(lt.textContent=qo),Il.forEach(t),ul=r(e),je=i(e,"P",{"data-svelte-h":!0}),u(je)!=="svelte-4wknxl"&&(je.innerHTML=Uo),cl=r(e),P=i(e,"H2",{class:!0});var jl=c(P);J=i(jl,"A",{id:!0,class:!0,href:!0});var xn=c(J);dt=i(xn,"SPAN",{});var _n=c(dt);f(De.$$.fragment,_n),_n.forEach(t),xn.forEach(t),Zl=r(jl),ot=i(jl,"SPAN",{"data-svelte-h":!0}),u(ot)!=="svelte-rqp3ax"&&(ot.textContent=Go),jl.forEach(t),pl=jn(e,`


About the author:
`),Ne=i(e,"UL",{"data-svelte-h":!0}),u(Ne)!=="svelte-11w7f8o"&&(Ne.innerHTML=zo),fl=r(e),We=i(e,"P",{"data-svelte-h":!0}),u(We)!=="svelte-gd9a5j"&&(We.textContent=Fo),gl=r(e),Re=i(e,"UL",{"data-svelte-h":!0}),u(Re)!=="svelte-t69p07"&&(Re.innerHTML=Oo),vl=r(e),A=i(e,"H2",{class:!0});var Dl=c(A);V=i(Dl,"A",{id:!0,class:!0,href:!0});var Cn=c(V);wt=i(Cn,"SPAN",{});var $n=c(wt);f(qe.$$.fragment,$n),$n.forEach(t),Cn.forEach(t),Jl=r(Dl),nt=i(Dl,"SPAN",{"data-svelte-h":!0}),u(nt)!=="svelte-1jngmw5"&&(nt.textContent=Bo),Dl.forEach(t),ml=r(e),Ue=i(e,"P",{"data-svelte-h":!0}),u(Ue)!=="svelte-11dnki3"&&(Ue.textContent=Yo),dl=r(e),Ge=i(e,"UL",{"data-svelte-h":!0}),u(Ge)!=="svelte-m7zuak"&&(Ge.innerHTML=Zo),wl=r(e),K=i(e,"IMG",{src:!0,alt:!0,width:!0}),yl=r(e),M=i(e,"H2",{class:!0});var Nl=c(M);Q=i(Nl,"A",{id:!0,class:!0,href:!0});var bn=c(Q);yt=i(bn,"SPAN",{});var Ln=c(yt);f(ze.$$.fragment,Ln),Ln.forEach(t),bn.forEach(t),Vl=r(Nl),it=i(Nl,"SPAN",{"data-svelte-h":!0}),u(it)!=="svelte-7ceh84"&&(it.textContent=Vo),Nl.forEach(t),xl=r(e),Fe=i(e,"P",{"data-svelte-h":!0}),u(Fe)!=="svelte-uwe8dy"&&(Fe.textContent=Ko),_l=r(e),Oe=i(e,"UL",{"data-svelte-h":!0}),u(Oe)!=="svelte-l3k1ly"&&(Oe.innerHTML=Qo),Cl=r(e),S=i(e,"H2",{class:!0});var Wl=c(S);X=i(Wl,"A",{id:!0,class:!0,href:!0});var kn=c(X);xt=i(kn,"SPAN",{});var Hn=c(xt);f(Be.$$.fragment,Hn),Hn.forEach(t),kn.forEach(t),Kl=r(Wl),st=i(Wl,"SPAN",{"data-svelte-h":!0}),u(st)!=="svelte-udplcv"&&(st.textContent=Xo),Wl.forEach(t),$l=r(e),Ye=i(e,"P",{"data-svelte-h":!0}),u(Ye)!=="svelte-gxcyvw"&&(Ye.innerHTML=en),bl=r(e),_t=i(e,"P",{}),c(_t).forEach(t),this.h()},h(){s(y,"name","hf:doc:metadata"),s(y,"content",JSON.stringify(Nn)),s(E,"id","introduction"),s(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(E,"href","#introduction"),s(x,"class","relative group"),ee(I.src,eo="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/thumbnail.jpg")||s(I,"src",eo),s(I,"alt","Deep RL Course thumbnail"),s(I,"width","100%"),s(j,"id","expect"),s(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(j,"href","#expect"),s(_,"class","relative group"),s(D,"id","course-look-like"),s(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(D,"href","#course-look-like"),s(C,"class","relative group"),s(N,"id","syllabus"),s(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(N,"href","#syllabus"),s($,"class","relative group"),ee(W.src,yo="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/syllabus1.jpg")||s(W,"src",yo),s(W,"alt","Syllabus Part 1"),s(W,"width","100%"),ee(R.src,xo="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/syllabus2.jpg")||s(R,"src",xo),s(R,"alt","Syllabus Part 2"),s(R,"width","100%"),s(q,"id","two-paths"),s(q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(q,"href","#two-paths"),s(b,"class","relative group"),ee(U.src,Co="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/two-paths.jpg")||s(U,"src",Co),s(U,"alt","Two paths"),s(U,"width","100%"),s(G,"id","certification-process"),s(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(G,"href","#certification-process"),s(L,"class","relative group"),ee(z.src,Mo="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/certification.jpg")||s(z,"src",Mo),s(z,"alt","Course certification"),s(z,"width","100%"),s(F,"id","advice"),s(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(F,"href","#advice"),s(k,"class","relative group"),ee(O.src,jo="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/advice.jpg")||s(O,"src",jo),s(O,"alt","Course advice"),s(O,"width","100%"),s(B,"id","tools"),s(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(B,"href","#tools"),s(H,"class","relative group"),ee(Y.src,Ro="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/tools.jpg")||s(Y,"src",Ro),s(Y,"alt","Course tools needed"),s(Y,"width","100%"),s(Z,"id","recommended-pace"),s(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(Z,"href","#recommended-pace"),s(T,"class","relative group"),s(J,"id","who-are-we"),s(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(J,"href","#who-are-we"),s(P,"class","relative group"),s(V,"id","challenges"),s(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(V,"href","#challenges"),s(A,"class","relative group"),ee(K.src,Jo="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/challenges.jpg")||s(K,"src",Jo),s(K,"alt","Challenges"),s(K,"width","100%"),s(Q,"id","contribute"),s(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(Q,"href","#contribute"),s(M,"class","relative group"),s(X,"id","questions"),s(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(X,"href","#questions"),s(S,"class","relative group")},m(e,l){h(document.head,y),o(e,Ct,l),o(e,at,l),o(e,$t,l),o(e,x,l),h(x,E),h(E,rt),g(te,rt,null),h(x,Rl),h(x,Ze),o(e,bt,l),o(e,I,l),o(e,Lt,l),o(e,le,l),o(e,kt,l),o(e,oe,l),o(e,Ht,l),o(e,ne,l),o(e,Tt,l),o(e,ie,l),o(e,Pt,l),o(e,se,l),o(e,At,l),o(e,_,l),h(_,j),h(j,ht),g(ae,ht,null),h(_,ql),h(_,Je),o(e,Mt,l),o(e,re,l),o(e,St,l),o(e,he,l),o(e,Et,l),o(e,ue,l),o(e,It,l),o(e,ce,l),o(e,jt,l),o(e,pe,l),o(e,Dt,l),o(e,fe,l),o(e,Nt,l),o(e,C,l),h(C,D),h(D,ut),g(ge,ut,null),h(C,Ul),h(C,Ve),o(e,Wt,l),o(e,ve,l),o(e,Rt,l),o(e,me,l),o(e,qt,l),o(e,$,l),h($,N),h(N,ct),g(de,ct,null),h($,Gl),h($,Ke),o(e,Ut,l),o(e,we,l),o(e,Gt,l),o(e,W,l),o(e,zt,l),o(e,R,l),o(e,Ft,l),o(e,b,l),h(b,q),h(q,pt),g(ye,pt,null),h(b,zl),h(b,Qe),o(e,Ot,l),o(e,U,l),o(e,Bt,l),o(e,xe,l),o(e,Yt,l),o(e,_e,l),o(e,Zt,l),o(e,Ce,l),o(e,Jt,l),o(e,$e,l),o(e,Vt,l),o(e,L,l),h(L,G),h(G,ft),g(be,ft,null),h(L,Fl),h(L,Xe),o(e,Kt,l),o(e,Le,l),o(e,Qt,l),o(e,ke,l),o(e,Xt,l),o(e,He,l),o(e,el,l),o(e,z,l),o(e,tl,l),o(e,k,l),h(k,F),h(F,gt),g(Te,gt,null),h(k,Ol),h(k,et),o(e,ll,l),o(e,Pe,l),o(e,ol,l),o(e,Ae,l),o(e,nl,l),o(e,O,l),o(e,il,l),o(e,H,l),h(H,B),h(B,vt),g(Me,vt,null),h(H,Bl),h(H,tt),o(e,sl,l),o(e,Se,l),o(e,al,l),o(e,Ee,l),o(e,rl,l),o(e,Y,l),o(e,hl,l),o(e,T,l),h(T,Z),h(Z,mt),g(Ie,mt,null),h(T,Yl),h(T,lt),o(e,ul,l),o(e,je,l),o(e,cl,l),o(e,P,l),h(P,J),h(J,dt),g(De,dt,null),h(P,Zl),h(P,ot),o(e,pl,l),o(e,Ne,l),o(e,fl,l),o(e,We,l),o(e,gl,l),o(e,Re,l),o(e,vl,l),o(e,A,l),h(A,V),h(V,wt),g(qe,wt,null),h(A,Jl),h(A,nt),o(e,ml,l),o(e,Ue,l),o(e,dl,l),o(e,Ge,l),o(e,wl,l),o(e,K,l),o(e,yl,l),o(e,M,l),h(M,Q),h(Q,yt),g(ze,yt,null),h(M,Vl),h(M,it),o(e,xl,l),o(e,Fe,l),o(e,_l,l),o(e,Oe,l),o(e,Cl,l),o(e,S,l),h(S,X),h(X,xt),g(Be,xt,null),h(S,Kl),h(S,st),o(e,$l,l),o(e,Ye,l),o(e,bl,l),o(e,_t,l),Ll=!0},p:Pn,i(e){Ll||(v(te.$$.fragment,e),v(ae.$$.fragment,e),v(ge.$$.fragment,e),v(de.$$.fragment,e),v(ye.$$.fragment,e),v(be.$$.fragment,e),v(Te.$$.fragment,e),v(Me.$$.fragment,e),v(Ie.$$.fragment,e),v(De.$$.fragment,e),v(qe.$$.fragment,e),v(ze.$$.fragment,e),v(Be.$$.fragment,e),Ll=!0)},o(e){m(te.$$.fragment,e),m(ae.$$.fragment,e),m(ge.$$.fragment,e),m(de.$$.fragment,e),m(ye.$$.fragment,e),m(be.$$.fragment,e),m(Te.$$.fragment,e),m(Me.$$.fragment,e),m(Ie.$$.fragment,e),m(De.$$.fragment,e),m(qe.$$.fragment,e),m(ze.$$.fragment,e),m(Be.$$.fragment,e),Ll=!1},d(e){e&&(t(Ct),t(at),t($t),t(x),t(bt),t(I),t(Lt),t(le),t(kt),t(oe),t(Ht),t(ne),t(Tt),t(ie),t(Pt),t(se),t(At),t(_),t(Mt),t(re),t(St),t(he),t(Et),t(ue),t(It),t(ce),t(jt),t(pe),t(Dt),t(fe),t(Nt),t(C),t(Wt),t(ve),t(Rt),t(me),t(qt),t($),t(Ut),t(we),t(Gt),t(W),t(zt),t(R),t(Ft),t(b),t(Ot),t(U),t(Bt),t(xe),t(Yt),t(_e),t(Zt),t(Ce),t(Jt),t($e),t(Vt),t(L),t(Kt),t(Le),t(Qt),t(ke),t(Xt),t(He),t(el),t(z),t(tl),t(k),t(ll),t(Pe),t(ol),t(Ae),t(nl),t(O),t(il),t(H),t(sl),t(Se),t(al),t(Ee),t(rl),t(Y),t(hl),t(T),t(ul),t(je),t(cl),t(P),t(pl),t(Ne),t(fl),t(We),t(gl),t(Re),t(vl),t(A),t(ml),t(Ue),t(dl),t(Ge),t(wl),t(K),t(yl),t(M),t(xl),t(Fe),t(_l),t(Oe),t(Cl),t(S),t($l),t(Ye),t(bl),t(_t)),t(y),d(te),d(ae),d(ge),d(de),d(ye),d(be),d(Te),d(Me),d(Ie),d(De),d(qe),d(ze),d(Be)}}}const Nn={local:"introduction",sections:[{local:"expect",title:"What to expect? "},{local:"course-look-like",title:"What does the course look like? "},{local:"syllabus",title:"What's the syllabus? "},{local:"two-paths",title:"Two paths: choose your own adventure "},{local:"certification-process",title:"The Certification Process "},{local:"advice",title:"How to get most of the course? "},{local:"tools",title:"What tools do I need? "},{local:"recommended-pace",title:"What is the recommended pace? "},{local:"who-are-we",title:"Who are we "},{local:"challenges",title:"What are the challenges in this course? "},{local:"contribute",title:"I found a bug, or I want to improve the course "},{local:"questions",title:"I still have questions "}],title:"Welcome to the 🤗 Deep Reinforcement Learning Course "};function Wn(Ql){return An(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Gn extends Mn{constructor(y){super(),Sn(this,y,Wn,Dn,Tn,{})}}export{Gn as component};
