import{s as mt,f as ct,n as pt,o as ft}from"../chunks/scheduler.37c15a92.js";import{S as dt,i as vt,g as o,s as a,u as yt,A as wt,h as s,f as e,c as l,j as P,v as _t,y as r,k as u,o as k,a as i,w as xt,d as Lt,t as Mt,x as Tt}from"../chunks/index.b01106c0.js";import{I as bt}from"../chunks/IconCopyLink.77b762b4.js";function Ct(W){let g,E,H,I,h,c,U,m,V,C,X="An Introduction to Unity ML-Agents",$,p,Y,S,f,Z=`One of the challenges in Reinforcement Learning is <strong>creating environments</strong>. Fortunately for us, we can use game engines to do so.
These engines, such as <a href="https://unity.com/" rel="nofollow">Unity</a>, <a href="https://godotengine.org/" rel="nofollow">Godot</a> or <a href="https://www.unrealengine.com/" rel="nofollow">Unreal Engine</a>, are programs made to create video games. They are perfectly suited
for creating environments: they provide physics systems, 2D/3D rendering, and more.`,G,d,tt='One of them, <a href="https://unity.com/" rel="nofollow">Unity</a>, created the <a href="https://github.com/Unity-Technologies/ml-agents" rel="nofollow">Unity ML-Agents Toolkit</a>, a plugin based on the game engine Unity that allows us <strong>to use the Unity Game Engine as an environment builder to train agents</strong>. In the first bonus unit, this is what we used to train Huggy to catch a stick!',j,v,et='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/example-envs.png" alt="MLAgents environments"/> <figcaption>Source: <a href="https://github.com/Unity-Technologies/ml-agents">ML-Agents documentation</a></figcaption>',q,y,nt="Unity ML-Agents Toolkit provides many exceptional pre-made environments, from playing football (soccer), learning to walk, and jumping over big walls.",z,w,it="In this Unit, we’ll learn to use ML-Agents, but <strong>don’t worry if you don’t know how to use the Unity Game Engine</strong>: you don’t need to use it to train your agents.",D,_,ot="So, today, we’re going to train two agents:",F,x,st="<li>The first one will learn to <strong>shoot snowballs onto a spawning target</strong>.</li> <li>The second needs to <strong>press a button to spawn a pyramid, then navigate to the pyramid, knock it over, and move to the gold brick at the top</strong>. To do that, it will need to explore its environment, which will be done using a technique called curiosity.</li>",N,L,at,O,M,lt="Then, after training, <strong>you’ll push the trained agents to the Hugging Face Hub</strong>, and you’ll be able to <strong>visualize them playing directly on your browser without having to use the Unity Editor</strong>.",R,T,rt="Doing this Unit will <strong>prepare you for the next challenge: AI vs. AI where you will train agents in multi-agents environments and compete against your classmates’ agents</strong>.",J,b,ut="Sound exciting? Let’s get started!",B,A,K;return m=new bt({}),{c(){g=o("meta"),E=a(),H=o("p"),I=a(),h=o("h1"),c=o("a"),U=o("span"),yt(m.$$.fragment),V=a(),C=o("span"),C.textContent=X,$=a(),p=o("img"),S=a(),f=o("p"),f.innerHTML=Z,G=a(),d=o("p"),d.innerHTML=tt,j=a(),v=o("figure"),v.innerHTML=et,q=a(),y=o("p"),y.textContent=nt,z=a(),w=o("p"),w.innerHTML=it,D=a(),_=o("p"),_.textContent=ot,F=a(),x=o("ul"),x.innerHTML=st,N=a(),L=o("img"),O=a(),M=o("p"),M.innerHTML=lt,R=a(),T=o("p"),T.innerHTML=rt,J=a(),b=o("p"),b.textContent=ut,B=a(),A=o("p"),this.h()},l(t){const n=wt("svelte-1phssyn",document.head);g=s(n,"META",{name:!0,content:!0}),n.forEach(e),E=l(t),H=s(t,"P",{}),P(H).forEach(e),I=l(t),h=s(t,"H1",{class:!0});var Q=P(h);c=s(Q,"A",{id:!0,class:!0,href:!0});var gt=P(c);U=s(gt,"SPAN",{});var ht=P(U);_t(m.$$.fragment,ht),ht.forEach(e),gt.forEach(e),V=l(Q),C=s(Q,"SPAN",{"data-svelte-h":!0}),r(C)!=="svelte-1tf0i8g"&&(C.textContent=X),Q.forEach(e),$=l(t),p=s(t,"IMG",{src:!0,alt:!0}),S=l(t),f=s(t,"P",{"data-svelte-h":!0}),r(f)!=="svelte-1vcgfrn"&&(f.innerHTML=Z),G=l(t),d=s(t,"P",{"data-svelte-h":!0}),r(d)!=="svelte-eyae6a"&&(d.innerHTML=tt),j=l(t),v=s(t,"FIGURE",{"data-svelte-h":!0}),r(v)!=="svelte-14xtn5a"&&(v.innerHTML=et),q=l(t),y=s(t,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1d33h02"&&(y.textContent=nt),z=l(t),w=s(t,"P",{"data-svelte-h":!0}),r(w)!=="svelte-w4zwn2"&&(w.innerHTML=it),D=l(t),_=s(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-2xi7mi"&&(_.textContent=ot),F=l(t),x=s(t,"UL",{"data-svelte-h":!0}),r(x)!=="svelte-15sbbs0"&&(x.innerHTML=st),N=l(t),L=s(t,"IMG",{src:!0,alt:!0}),O=l(t),M=s(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-14hc6j"&&(M.innerHTML=lt),R=l(t),T=s(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-11di5c1"&&(T.innerHTML=rt),J=l(t),b=s(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-1lrk2z4"&&(b.textContent=ut),B=l(t),A=s(t,"P",{}),P(A).forEach(e),this.h()},h(){u(g,"name","hf:doc:metadata"),u(g,"content",JSON.stringify(Ht)),u(c,"id","introduction-to-ml-agents"),u(c,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(c,"href","#introduction-to-ml-agents"),u(h,"class","relative group"),ct(p.src,Y="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/thumbnail.png")||u(p,"src",Y),u(p,"alt","thumbnail"),ct(L.src,at="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/envs.png")||u(L,"src",at),u(L,"alt","Environments")},m(t,n){k(document.head,g),i(t,E,n),i(t,H,n),i(t,I,n),i(t,h,n),k(h,c),k(c,U),xt(m,U,null),k(h,V),k(h,C),i(t,$,n),i(t,p,n),i(t,S,n),i(t,f,n),i(t,G,n),i(t,d,n),i(t,j,n),i(t,v,n),i(t,q,n),i(t,y,n),i(t,z,n),i(t,w,n),i(t,D,n),i(t,_,n),i(t,F,n),i(t,x,n),i(t,N,n),i(t,L,n),i(t,O,n),i(t,M,n),i(t,R,n),i(t,T,n),i(t,J,n),i(t,b,n),i(t,B,n),i(t,A,n),K=!0},p:pt,i(t){K||(Lt(m.$$.fragment,t),K=!0)},o(t){Mt(m.$$.fragment,t),K=!1},d(t){t&&(e(E),e(H),e(I),e(h),e($),e(p),e(S),e(f),e(G),e(d),e(j),e(v),e(q),e(y),e(z),e(w),e(D),e(_),e(F),e(x),e(N),e(L),e(O),e(M),e(R),e(T),e(J),e(b),e(B),e(A)),e(g),Tt(m)}}}const Ht={local:"introduction-to-ml-agents",title:"An Introduction to Unity ML-Agents "};function Ut(W){return ft(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Et extends dt{constructor(g){super(),vt(this,g,Ut,Ct,mt,{})}}export{Et as component};
