import{s as It,f as Z,n as Gt,o as Nt}from"../chunks/scheduler.37c15a92.js";import{S as Rt,i as jt,g as s,s as r,u as re,A as qt,h as i,f as t,c as o,j as c,v as oe,y as u,k as l,o as h,a as n,w as he,d as ue,t as ce,x as ge}from"../chunks/index.b01106c0.js";import{I as pe}from"../chunks/IconCopyLink.77b762b4.js";function Ut(Ye){let g,fe,ee,me,p,w,te,C,Ke,D,Ze="The SnowballTarget Environment",ve,$,et,de,T,tt='SnowballTarget is an environment we created at Hugging Face using assets from <a href="https://kaylousberg.com/" rel="nofollow">Kay Lousberg</a>. We have an optional section at the end of this Unit <strong>if you want to learn to use Unity and create your environments</strong>.',we,f,_,ae,k,De,Q,at="The agent's Goal",_e,P,nt="The first agent you’re going to train is called Julien the bear 🐻. Julien is trained <strong>to hit targets with snowballs</strong>.",be,M,st="The Goal in this environment is that Julien <strong>hits as many targets as possible in the limited time</strong> (1000 timesteps). It will need <strong>to place itself correctly in relation to the target and shoot</strong>to do that.",ye,H,it="In addition, to avoid “snowball spamming” (aka shooting a snowball every timestep), <strong>Julien has a “cool off” system</strong> (it needs to wait 0.5 seconds after a shoot to be able to shoot again).",xe,E,lt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/cooloffsystem.gif" alt="Cool Off System"/> <figcaption>The agent needs to wait 0.5s before being able to shoot a snowball again</figcaption>',Ce,m,b,ne,L,Qe,V,rt="The reward function and the reward engineering problem",$e,S,ot="The reward function is simple. <strong>The environment gives a +1 reward every time the agent’s snowball hits a target</strong>. Because the agent’s Goal is to maximize the expected cumulative reward, <strong>it will try to hit as many targets as possible</strong>.",Te,A,ht,ke,I,ut=`We could have a more complex reward function (with a penalty to push the agent to go faster, for example). But when you design an environment, you need to avoid the <em>reward engineering problem</em>, which is having a too complex reward function to force your agent to behave as you want it to do.
Why? Because by doing that, <strong>you might miss interesting strategies that the agent will find with a simpler reward function</strong>.`,Pe,G,ct="In terms of code, it looks like this:",Me,N,gt,He,v,y,se,R,Ve,X,pt="The observation space",Ee,j,ft="Regarding observations, we don’t use normal vision (frame), but <strong>we use raycasts</strong>.",Le,q,mt="Think of raycasts as lasers that will detect if they pass through an object.",Se,U,vt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/raycasts.png" alt="Raycasts"/> <figcaption>Source: <a href="https://github.com/Unity-Technologies/ml-agents">ML-Agents documentation</a></figcaption>',Ae,J,dt="In this environment, our agent has multiple set of raycasts:",Ie,z,wt,Ge,B,_t="In addition to raycasts, the agent gets a “can I shoot” bool as observation.",Ne,F,bt,Re,d,x,ie,O,Xe,Y,yt="The action space",je,W,xt="The action space is discrete:",qe,K,Ct,Ue,le,Je;return C=new pe({}),k=new pe({}),L=new pe({}),R=new pe({}),O=new pe({}),{c(){g=s("meta"),fe=r(),ee=s("p"),me=r(),p=s("h1"),w=s("a"),te=s("span"),re(C.$$.fragment),Ke=r(),D=s("span"),D.textContent=Ze,ve=r(),$=s("img"),de=r(),T=s("p"),T.innerHTML=tt,we=r(),f=s("h2"),_=s("a"),ae=s("span"),re(k.$$.fragment),De=r(),Q=s("span"),Q.textContent=at,_e=r(),P=s("p"),P.innerHTML=nt,be=r(),M=s("p"),M.innerHTML=st,ye=r(),H=s("p"),H.innerHTML=it,xe=r(),E=s("figure"),E.innerHTML=lt,Ce=r(),m=s("h2"),b=s("a"),ne=s("span"),re(L.$$.fragment),Qe=r(),V=s("span"),V.textContent=rt,$e=r(),S=s("p"),S.innerHTML=ot,Te=r(),A=s("img"),ke=r(),I=s("p"),I.innerHTML=ut,Pe=r(),G=s("p"),G.textContent=ct,Me=r(),N=s("img"),He=r(),v=s("h2"),y=s("a"),se=s("span"),re(R.$$.fragment),Ve=r(),X=s("span"),X.textContent=pt,Ee=r(),j=s("p"),j.innerHTML=ft,Le=r(),q=s("p"),q.textContent=mt,Se=r(),U=s("figure"),U.innerHTML=vt,Ae=r(),J=s("p"),J.textContent=dt,Ie=r(),z=s("img"),Ge=r(),B=s("p"),B.textContent=_t,Ne=r(),F=s("img"),Re=r(),d=s("h2"),x=s("a"),ie=s("span"),re(O.$$.fragment),Xe=r(),Y=s("span"),Y.textContent=yt,je=r(),W=s("p"),W.textContent=xt,qe=r(),K=s("img"),Ue=r(),le=s("p"),this.h()},l(e){const a=qt("svelte-1phssyn",document.head);g=i(a,"META",{name:!0,content:!0}),a.forEach(t),fe=o(e),ee=i(e,"P",{}),c(ee).forEach(t),me=o(e),p=i(e,"H1",{class:!0});var ze=c(p);w=i(ze,"A",{id:!0,class:!0,href:!0});var $t=c(w);te=i($t,"SPAN",{});var Tt=c(te);oe(C.$$.fragment,Tt),Tt.forEach(t),$t.forEach(t),Ke=o(ze),D=i(ze,"SPAN",{"data-svelte-h":!0}),u(D)!=="svelte-85fbwk"&&(D.textContent=Ze),ze.forEach(t),ve=o(e),$=i(e,"IMG",{src:!0,alt:!0}),de=o(e),T=i(e,"P",{"data-svelte-h":!0}),u(T)!=="svelte-tjcuuk"&&(T.innerHTML=tt),we=o(e),f=i(e,"H2",{class:!0});var Be=c(f);_=i(Be,"A",{id:!0,class:!0,href:!0});var kt=c(_);ae=i(kt,"SPAN",{});var Pt=c(ae);oe(k.$$.fragment,Pt),Pt.forEach(t),kt.forEach(t),De=o(Be),Q=i(Be,"SPAN",{"data-svelte-h":!0}),u(Q)!=="svelte-65zg5s"&&(Q.textContent=at),Be.forEach(t),_e=o(e),P=i(e,"P",{"data-svelte-h":!0}),u(P)!=="svelte-1n4q7lh"&&(P.innerHTML=nt),be=o(e),M=i(e,"P",{"data-svelte-h":!0}),u(M)!=="svelte-1kbt7gr"&&(M.innerHTML=st),ye=o(e),H=i(e,"P",{"data-svelte-h":!0}),u(H)!=="svelte-dkh5jq"&&(H.innerHTML=it),xe=o(e),E=i(e,"FIGURE",{"data-svelte-h":!0}),u(E)!=="svelte-1m1t9ww"&&(E.innerHTML=lt),Ce=o(e),m=i(e,"H2",{class:!0});var Fe=c(m);b=i(Fe,"A",{id:!0,class:!0,href:!0});var Mt=c(b);ne=i(Mt,"SPAN",{});var Ht=c(ne);oe(L.$$.fragment,Ht),Ht.forEach(t),Mt.forEach(t),Qe=o(Fe),V=i(Fe,"SPAN",{"data-svelte-h":!0}),u(V)!=="svelte-k8fko"&&(V.textContent=rt),Fe.forEach(t),$e=o(e),S=i(e,"P",{"data-svelte-h":!0}),u(S)!=="svelte-d7uy51"&&(S.innerHTML=ot),Te=o(e),A=i(e,"IMG",{src:!0,alt:!0}),ke=o(e),I=i(e,"P",{"data-svelte-h":!0}),u(I)!=="svelte-17at3tr"&&(I.innerHTML=ut),Pe=o(e),G=i(e,"P",{"data-svelte-h":!0}),u(G)!=="svelte-1sp5sxs"&&(G.textContent=ct),Me=o(e),N=i(e,"IMG",{src:!0,alt:!0}),He=o(e),v=i(e,"H2",{class:!0});var Oe=c(v);y=i(Oe,"A",{id:!0,class:!0,href:!0});var Et=c(y);se=i(Et,"SPAN",{});var Lt=c(se);oe(R.$$.fragment,Lt),Lt.forEach(t),Et.forEach(t),Ve=o(Oe),X=i(Oe,"SPAN",{"data-svelte-h":!0}),u(X)!=="svelte-4ey504"&&(X.textContent=pt),Oe.forEach(t),Ee=o(e),j=i(e,"P",{"data-svelte-h":!0}),u(j)!=="svelte-h5sa4r"&&(j.innerHTML=ft),Le=o(e),q=i(e,"P",{"data-svelte-h":!0}),u(q)!=="svelte-1sy1glw"&&(q.textContent=mt),Se=o(e),U=i(e,"FIGURE",{"data-svelte-h":!0}),u(U)!=="svelte-1ihdfq4"&&(U.innerHTML=vt),Ae=o(e),J=i(e,"P",{"data-svelte-h":!0}),u(J)!=="svelte-q67na8"&&(J.textContent=dt),Ie=o(e),z=i(e,"IMG",{src:!0,alt:!0}),Ge=o(e),B=i(e,"P",{"data-svelte-h":!0}),u(B)!=="svelte-jiha0j"&&(B.textContent=_t),Ne=o(e),F=i(e,"IMG",{src:!0,alt:!0}),Re=o(e),d=i(e,"H2",{class:!0});var We=c(d);x=i(We,"A",{id:!0,class:!0,href:!0});var St=c(x);ie=i(St,"SPAN",{});var At=c(ie);oe(O.$$.fragment,At),At.forEach(t),St.forEach(t),Xe=o(We),Y=i(We,"SPAN",{"data-svelte-h":!0}),u(Y)!=="svelte-1red8jm"&&(Y.textContent=yt),We.forEach(t),je=o(e),W=i(e,"P",{"data-svelte-h":!0}),u(W)!=="svelte-1dhzfig"&&(W.textContent=xt),qe=o(e),K=i(e,"IMG",{src:!0,alt:!0}),Ue=o(e),le=i(e,"P",{}),c(le).forEach(t),this.h()},h(){l(g,"name","hf:doc:metadata"),l(g,"content",JSON.stringify(Jt)),l(w,"id","the-snowballtarget-environment"),l(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(w,"href","#the-snowballtarget-environment"),l(p,"class","relative group"),Z($.src,et="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget.gif")||l($,"src",et),l($,"alt","SnowballTarget"),l(_,"id","the-agents-goal"),l(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_,"href","#the-agents-goal"),l(f,"class","relative group"),l(b,"id","the-reward-function-and-the-reward-engineering-problem"),l(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(b,"href","#the-reward-function-and-the-reward-engineering-problem"),l(m,"class","relative group"),Z(A.src,ht="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget_reward.png")||l(A,"src",ht),l(A,"alt","Reward system"),Z(N.src,gt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget-reward-code.png")||l(N,"src",gt),l(N,"alt","Reward"),l(y,"id","the-observation-space"),l(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(y,"href","#the-observation-space"),l(v,"class","relative group"),Z(z.src,wt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowball_target_raycasts.png")||l(z,"src",wt),l(z,"alt","Raycasts"),Z(F.src,bt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget-obs-code.png")||l(F,"src",bt),l(F,"alt","Obs"),l(x,"id","the-action-space"),l(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(x,"href","#the-action-space"),l(d,"class","relative group"),Z(K.src,Ct="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget_action_space.png")||l(K,"src",Ct),l(K,"alt","Action Space")},m(e,a){h(document.head,g),n(e,fe,a),n(e,ee,a),n(e,me,a),n(e,p,a),h(p,w),h(w,te),he(C,te,null),h(p,Ke),h(p,D),n(e,ve,a),n(e,$,a),n(e,de,a),n(e,T,a),n(e,we,a),n(e,f,a),h(f,_),h(_,ae),he(k,ae,null),h(f,De),h(f,Q),n(e,_e,a),n(e,P,a),n(e,be,a),n(e,M,a),n(e,ye,a),n(e,H,a),n(e,xe,a),n(e,E,a),n(e,Ce,a),n(e,m,a),h(m,b),h(b,ne),he(L,ne,null),h(m,Qe),h(m,V),n(e,$e,a),n(e,S,a),n(e,Te,a),n(e,A,a),n(e,ke,a),n(e,I,a),n(e,Pe,a),n(e,G,a),n(e,Me,a),n(e,N,a),n(e,He,a),n(e,v,a),h(v,y),h(y,se),he(R,se,null),h(v,Ve),h(v,X),n(e,Ee,a),n(e,j,a),n(e,Le,a),n(e,q,a),n(e,Se,a),n(e,U,a),n(e,Ae,a),n(e,J,a),n(e,Ie,a),n(e,z,a),n(e,Ge,a),n(e,B,a),n(e,Ne,a),n(e,F,a),n(e,Re,a),n(e,d,a),h(d,x),h(x,ie),he(O,ie,null),h(d,Xe),h(d,Y),n(e,je,a),n(e,W,a),n(e,qe,a),n(e,K,a),n(e,Ue,a),n(e,le,a),Je=!0},p:Gt,i(e){Je||(ue(C.$$.fragment,e),ue(k.$$.fragment,e),ue(L.$$.fragment,e),ue(R.$$.fragment,e),ue(O.$$.fragment,e),Je=!0)},o(e){ce(C.$$.fragment,e),ce(k.$$.fragment,e),ce(L.$$.fragment,e),ce(R.$$.fragment,e),ce(O.$$.fragment,e),Je=!1},d(e){e&&(t(fe),t(ee),t(me),t(p),t(ve),t($),t(de),t(T),t(we),t(f),t(_e),t(P),t(be),t(M),t(ye),t(H),t(xe),t(E),t(Ce),t(m),t($e),t(S),t(Te),t(A),t(ke),t(I),t(Pe),t(G),t(Me),t(N),t(He),t(v),t(Ee),t(j),t(Le),t(q),t(Se),t(U),t(Ae),t(J),t(Ie),t(z),t(Ge),t(B),t(Ne),t(F),t(Re),t(d),t(je),t(W),t(qe),t(K),t(Ue),t(le)),t(g),ge(C),ge(k),ge(L),ge(R),ge(O)}}}const Jt={local:"the-snowballtarget-environment",sections:[{local:"the-agents-goal",title:"The agent's Goal"},{local:"the-reward-function-and-the-reward-engineering-problem",title:"The reward function and the reward engineering problem"},{local:"the-observation-space",title:"The observation space"},{local:"the-action-space",title:"The action space"}],title:"The SnowballTarget Environment"};function zt(Ye){return Nt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Wt extends Rt{constructor(g){super(),jt(this,g,zt,Ut,It,{})}}export{Wt as component};
