import{s as ot,f as lt,n as rt,o as ct}from"../chunks/scheduler.37c15a92.js";import{S as ut,i as ht,g as s,s as o,u as mt,A as pt,h as a,f as e,c as l,j as H,v as dt,y as r,k as m,o as A,a as n,w as ft,d as vt,t as gt,x as yt}from"../chunks/index.b01106c0.js";import{I as wt}from"../chunks/IconCopyLink.77b762b4.js";function _t(V){let c,k,L,$,u,h,P,p,O,C,D="Introduction",S,d,F,I,f,K="In unit 4, we learned about our first Policy-Based algorithm called <strong>Reinforce</strong>.",B,v,Q="In Policy-Based methods, <strong>we aim to optimize the policy directly without using a value function</strong>. More precisely, Reinforce is part of a subclass of <em>Policy-Based Methods</em> called <em>Policy-Gradient methods</em>. This subclass optimizes the policy directly by <strong>estimating the weights of the optimal policy using Gradient Ascent</strong>.",E,g,X="We saw that Reinforce worked well. However, because we use Monte-Carlo sampling to estimate return (we use an entire episode to calculate the return), <strong>we have significant variance in policy gradient estimation</strong>.",q,y,Y="Remember that the policy gradient estimation is <strong>the direction of the steepest increase in return</strong>. In other words, how to update our policy weights so that actions that lead to good returns have a higher probability of being taken. The Monte Carlo variance, which we will further study in this unit, <strong>leads to slower training since we need a lot of samples to mitigate it</strong>.",z,w,Z="So today we’ll study <strong>Actor-Critic methods</strong>, a hybrid architecture combining value-based and Policy-Based methods that helps to stabilize the training by reducing the variance using:",R,_,tt="<li><em>An Actor</em> that controls <strong>how our agent behaves</strong> (Policy-Based method)</li> <li><em>A Critic</em> that measures <strong>how good the taken action is</strong> (Value-Based method)</li>",G,b,et="We’ll study one of these hybrid methods, Advantage Actor Critic (A2C), <strong>and train our agent using Stable-Baselines3 in robotic environments</strong>. We’ll train:",N,M,it="<li>A robotic arm 🦾 to move to the correct position.</li>",U,x,nt="Sound exciting? Let’s get started!",W,T,j;return p=new wt({}),{c(){c=s("meta"),k=o(),L=s("p"),$=o(),u=s("h1"),h=s("a"),P=s("span"),mt(p.$$.fragment),O=o(),C=s("span"),C.textContent=D,S=o(),d=s("img"),I=o(),f=s("p"),f.innerHTML=K,B=o(),v=s("p"),v.innerHTML=Q,E=o(),g=s("p"),g.innerHTML=X,q=o(),y=s("p"),y.innerHTML=Y,z=o(),w=s("p"),w.innerHTML=Z,R=o(),_=s("ul"),_.innerHTML=tt,G=o(),b=s("p"),b.innerHTML=et,N=o(),M=s("ul"),M.innerHTML=it,U=o(),x=s("p"),x.textContent=nt,W=o(),T=s("p"),this.h()},l(t){const i=pt("svelte-1phssyn",document.head);c=a(i,"META",{name:!0,content:!0}),i.forEach(e),k=l(t),L=a(t,"P",{}),H(L).forEach(e),$=l(t),u=a(t,"H1",{class:!0});var J=H(u);h=a(J,"A",{id:!0,class:!0,href:!0});var st=H(h);P=a(st,"SPAN",{});var at=H(P);dt(p.$$.fragment,at),at.forEach(e),st.forEach(e),O=l(J),C=a(J,"SPAN",{"data-svelte-h":!0}),r(C)!=="svelte-agc3q7"&&(C.textContent=D),J.forEach(e),S=l(t),d=a(t,"IMG",{src:!0,alt:!0}),I=l(t),f=a(t,"P",{"data-svelte-h":!0}),r(f)!=="svelte-dvu1gd"&&(f.innerHTML=K),B=l(t),v=a(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-z9stkq"&&(v.innerHTML=Q),E=l(t),g=a(t,"P",{"data-svelte-h":!0}),r(g)!=="svelte-1p5t49p"&&(g.innerHTML=X),q=l(t),y=a(t,"P",{"data-svelte-h":!0}),r(y)!=="svelte-spae8s"&&(y.innerHTML=Y),z=l(t),w=a(t,"P",{"data-svelte-h":!0}),r(w)!=="svelte-a75o96"&&(w.innerHTML=Z),R=l(t),_=a(t,"UL",{"data-svelte-h":!0}),r(_)!=="svelte-1g2297h"&&(_.innerHTML=tt),G=l(t),b=a(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-54x6jn"&&(b.innerHTML=et),N=l(t),M=a(t,"UL",{"data-svelte-h":!0}),r(M)!=="svelte-10o7xql"&&(M.innerHTML=it),U=l(t),x=a(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1lrk2z4"&&(x.textContent=nt),W=l(t),T=a(t,"P",{}),H(T).forEach(e),this.h()},h(){m(c,"name","hf:doc:metadata"),m(c,"content",JSON.stringify(bt)),m(h,"id","introduction"),m(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(h,"href","#introduction"),m(u,"class","relative group"),lt(d.src,F="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/thumbnail.png")||m(d,"src",F),m(d,"alt","Thumbnail")},m(t,i){A(document.head,c),n(t,k,i),n(t,L,i),n(t,$,i),n(t,u,i),A(u,h),A(h,P),ft(p,P,null),A(u,O),A(u,C),n(t,S,i),n(t,d,i),n(t,I,i),n(t,f,i),n(t,B,i),n(t,v,i),n(t,E,i),n(t,g,i),n(t,q,i),n(t,y,i),n(t,z,i),n(t,w,i),n(t,R,i),n(t,_,i),n(t,G,i),n(t,b,i),n(t,N,i),n(t,M,i),n(t,U,i),n(t,x,i),n(t,W,i),n(t,T,i),j=!0},p:rt,i(t){j||(vt(p.$$.fragment,t),j=!0)},o(t){gt(p.$$.fragment,t),j=!1},d(t){t&&(e(k),e(L),e($),e(u),e(S),e(d),e(I),e(f),e(B),e(v),e(E),e(g),e(q),e(y),e(z),e(w),e(R),e(_),e(G),e(b),e(N),e(M),e(U),e(x),e(W),e(T)),e(c),yt(p)}}}const bt={local:"introduction",title:"Introduction "};function Mt(V){return ct(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pt extends ut{constructor(c){super(),ht(this,c,Mt,_t,ot,{})}}export{Pt as component};
