import{s as ct,f as ut,n as gt,o as pt}from"../chunks/scheduler.37c15a92.js";import{S as ht,i as mt,g as s,s as o,u as ft,A as vt,h as i,f as e,c as r,j as A,v as dt,y as l,k as p,o as k,a,w as wt,d as _t,t as yt,x as xt}from"../chunks/index.b01106c0.js";import{I as Tt}from"../chunks/IconCopyLink.77b762b4.js";function Mt(Q){let c,I,H,S,u,g,P,h,K,L,V="Introduction",$,m,W,E,f,X="Since the beginning of this course, we learned to train agents in a <em>single-agent system</em>  where our agent was alone in its environment: it was <strong>not cooperating or collaborating with other agents</strong>.",q,v,Y="This worked great, and the single-agent system is useful for many applications.",U,d,Z='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/patchwork.jpg" alt="Patchwork"/> <figcaption>A patchwork of all the environments you’ve trained your agents on since the beginning of the course</figcaption>',R,w,tt="But, as humans, <strong>we live in a multi-agent world</strong>. Our intelligence comes from interaction with other agents. And so, our <strong>goal is to create agents that can interact with other humans and other agents</strong>.",j,_,et="Consequently, we must study how to train deep reinforcement learning agents in a <em>multi-agents system</em> to build robust agents that can adapt, collaborate, or compete.",G,y,nt="So today we’re going to <strong>learn the basics of the fascinating topic of multi-agents reinforcement learning (MARL)</strong>.",N,x,at="And the most exciting part is that, during this unit, you’re going to train your first agents in a multi-agents system: <strong>a 2vs2 soccer team that needs to beat the opponent team</strong>.",F,T,st='And you’re going to participate in <strong>AI vs. AI challenge</strong> where your trained agent will compete against other classmates’ agents every day and be ranked on a <a href="https://huggingface.co/spaces/huggingface-projects/AIvsAI-SoccerTwos" rel="nofollow">new leaderboard</a>.',O,M,it='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/soccertwos.gif" alt="SoccerTwos"/> <figcaption>This environment was made by the <a href="https://github.com/Unity-Technologies/ml-agents">Unity MLAgents Team</a></figcaption>',B,C,ot="So let’s get started!",J,b,z;return h=new Tt({}),{c(){c=s("meta"),I=o(),H=s("p"),S=o(),u=s("h1"),g=s("a"),P=s("span"),ft(h.$$.fragment),K=o(),L=s("span"),L.textContent=V,$=o(),m=s("img"),E=o(),f=s("p"),f.innerHTML=X,q=o(),v=s("p"),v.textContent=Y,U=o(),d=s("figure"),d.innerHTML=Z,R=o(),w=s("p"),w.innerHTML=tt,j=o(),_=s("p"),_.innerHTML=et,G=o(),y=s("p"),y.innerHTML=nt,N=o(),x=s("p"),x.innerHTML=at,F=o(),T=s("p"),T.innerHTML=st,O=o(),M=s("figure"),M.innerHTML=it,B=o(),C=s("p"),C.textContent=ot,J=o(),b=s("p"),this.h()},l(t){const n=vt("svelte-1phssyn",document.head);c=i(n,"META",{name:!0,content:!0}),n.forEach(e),I=r(t),H=i(t,"P",{}),A(H).forEach(e),S=r(t),u=i(t,"H1",{class:!0});var D=A(u);g=i(D,"A",{id:!0,class:!0,href:!0});var rt=A(g);P=i(rt,"SPAN",{});var lt=A(P);dt(h.$$.fragment,lt),lt.forEach(e),rt.forEach(e),K=r(D),L=i(D,"SPAN",{"data-svelte-h":!0}),l(L)!=="svelte-agc3q7"&&(L.textContent=V),D.forEach(e),$=r(t),m=i(t,"IMG",{src:!0,alt:!0}),E=r(t),f=i(t,"P",{"data-svelte-h":!0}),l(f)!=="svelte-smsux1"&&(f.innerHTML=X),q=r(t),v=i(t,"P",{"data-svelte-h":!0}),l(v)!=="svelte-e9caw3"&&(v.textContent=Y),U=r(t),d=i(t,"FIGURE",{"data-svelte-h":!0}),l(d)!=="svelte-so1y2c"&&(d.innerHTML=Z),R=r(t),w=i(t,"P",{"data-svelte-h":!0}),l(w)!=="svelte-nf786x"&&(w.innerHTML=tt),j=r(t),_=i(t,"P",{"data-svelte-h":!0}),l(_)!=="svelte-5dt70f"&&(_.innerHTML=et),G=r(t),y=i(t,"P",{"data-svelte-h":!0}),l(y)!=="svelte-19g4sgk"&&(y.innerHTML=nt),N=r(t),x=i(t,"P",{"data-svelte-h":!0}),l(x)!=="svelte-ywv0q0"&&(x.innerHTML=at),F=r(t),T=i(t,"P",{"data-svelte-h":!0}),l(T)!=="svelte-16qx50q"&&(T.innerHTML=st),O=r(t),M=i(t,"FIGURE",{"data-svelte-h":!0}),l(M)!=="svelte-100gprn"&&(M.innerHTML=it),B=r(t),C=i(t,"P",{"data-svelte-h":!0}),l(C)!=="svelte-2tvssp"&&(C.textContent=ot),J=r(t),b=i(t,"P",{}),A(b).forEach(e),this.h()},h(){p(c,"name","hf:doc:metadata"),p(c,"content",JSON.stringify(Ct)),p(g,"id","introduction"),p(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(g,"href","#introduction"),p(u,"class","relative group"),ut(m.src,W="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/thumbnail.png")||p(m,"src",W),p(m,"alt","Thumbnail")},m(t,n){k(document.head,c),a(t,I,n),a(t,H,n),a(t,S,n),a(t,u,n),k(u,g),k(g,P),wt(h,P,null),k(u,K),k(u,L),a(t,$,n),a(t,m,n),a(t,E,n),a(t,f,n),a(t,q,n),a(t,v,n),a(t,U,n),a(t,d,n),a(t,R,n),a(t,w,n),a(t,j,n),a(t,_,n),a(t,G,n),a(t,y,n),a(t,N,n),a(t,x,n),a(t,F,n),a(t,T,n),a(t,O,n),a(t,M,n),a(t,B,n),a(t,C,n),a(t,J,n),a(t,b,n),z=!0},p:gt,i(t){z||(_t(h.$$.fragment,t),z=!0)},o(t){yt(h.$$.fragment,t),z=!1},d(t){t&&(e(I),e(H),e(S),e(u),e($),e(m),e(E),e(f),e(q),e(v),e(U),e(d),e(R),e(w),e(j),e(_),e(G),e(y),e(N),e(x),e(F),e(T),e(O),e(M),e(B),e(C),e(J),e(b)),e(c),xt(h)}}}const Ct={local:"introduction",title:"Introduction "};function Lt(Q){return pt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class At extends ht{constructor(c){super(),mt(this,c,Lt,Mt,ct,{})}}export{At as component};
