import{s as Xe,n as Ze,o as et}from"../chunks/scheduler.37c15a92.js";import{S as tt,i as nt,g as a,s as l,u as de,A as it,h as s,f as t,c as r,j as u,v as we,y as o,k as h,o as c,a as i,w as ye,d as xe,t as _e,x as Ce}from"../chunks/index.b01106c0.js";import{Y as at}from"../chunks/Youtube.9ba47c4c.js";import{I as be}from"../chunks/IconCopyLink.77b762b4.js";function st(Te){let p,O,F,Y,m,f,G,y,$e,R,He="Designing Multi-Agents systems",J,x,ke='For this section, you’re going to watch this excellent introduction to multi-agents made by <a href="https://www.youtube.com/channel/UCq0imsn84ShAe9PBOFnoIrg">Brian Douglas </a>.',K,_,Q,C,Pe="In this video, Brian talked about how to design multi-agent systems. He specifically took a multi-agents system of vacuum cleaners and asked: <strong>how can can cooperate with each other</strong>?",V,$,ze="We have two solutions to design this multi-agent reinforcement learning system (MARL).",X,g,d,j,L,Le,D,Ae="Decentralized system",Z,M,Ie='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/decentralized.png" alt="Decentralized"/> <figcaption>Source: <a href="https://www.youtube.com/watch?v=qgb0gyrpiGk">Introduction to Multi-Agent Reinforcement Learning</a></figcaption>',ee,b,Ee="In decentralized learning, <strong>each agent is trained independently from the others</strong>. In the example given, each vacuum learns to clean as many places as it can <strong>without caring about what other vacuums (agents) are doing</strong>.",te,T,Se="The benefit is that <strong>since no information is shared between agents, these vacuums can be designed and trained like we train single agents</strong>.",ne,H,Ne="The idea here is that <strong>our training agent will consider other agents as part of the environment dynamics</strong>. Not as agents.",ie,k,qe=`However, the big drawback of this technique is that it will <strong>make the environment non-stationary</strong> since the underlying Markov decision process changes over time as other agents are also interacting in the environment.
And this is problematic for many Reinforcement Learning algorithms <strong>that can’t reach a global optimum with a non-stationary environment</strong>.`,ae,v,w,B,P,Me,U,Re="Centralized approach",se,z,De='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/centralized.png" alt="Centralized"/> <figcaption>Source: <a href="https://www.youtube.com/watch?v=qgb0gyrpiGk">Introduction to Multi-Agent Reinforcement Learning</a></figcaption>',le,A,Ue="In this architecture, <strong>we have a high-level process that collects agents’ experiences</strong>: the experience buffer. And we’ll use these experiences <strong>to learn a common policy</strong>.",re,I,Fe="For instance, in the vacuum cleaner example, the observation will be:",oe,E,Ge="<li>The coverage map of the vacuums.</li> <li>The position of all the vacuums.</li>",he,S,je=`We use that collective experience <strong>to train a policy that will move all three robots in the most beneficial way as a whole</strong>. So each robot is learning from their common experience.
We now have a stationary environment since all the agents are treated as a larger entity, and they know the change of other agents’ policies (since it’s the same as theirs).`,ce,N,Be="If we recap:",ue,q,We="<li><p>In a <em>decentralized approach</em>, we <strong>treat all agents independently without considering the existence of the other agents.</strong></p> <ul><li>In this case, all agents <strong>consider others agents as part of the environment</strong>.</li> <li><strong>It’s a non-stationarity environment condition</strong>, so has no guarantee of convergence.</li></ul></li> <li><p>In a <em>centralized approach</em>:</p> <ul><li>A <strong>single policy is learned from all the agents</strong>.</li> <li>Takes as input the present state of an environment and the policy outputs joint actions.</li> <li>The reward is global.</li></ul></li>",pe,W,me;return y=new be({}),_=new at({props:{id:"qgb0gyrpiGk"}}),L=new be({}),P=new be({}),{c(){p=a("meta"),O=l(),F=a("p"),Y=l(),m=a("h1"),f=a("a"),G=a("span"),de(y.$$.fragment),$e=l(),R=a("span"),R.textContent=He,J=l(),x=a("p"),x.innerHTML=ke,K=l(),de(_.$$.fragment),Q=l(),C=a("p"),C.innerHTML=Pe,V=l(),$=a("p"),$.textContent=ze,X=l(),g=a("h2"),d=a("a"),j=a("span"),de(L.$$.fragment),Le=l(),D=a("span"),D.textContent=Ae,Z=l(),M=a("figure"),M.innerHTML=Ie,ee=l(),b=a("p"),b.innerHTML=Ee,te=l(),T=a("p"),T.innerHTML=Se,ne=l(),H=a("p"),H.innerHTML=Ne,ie=l(),k=a("p"),k.innerHTML=qe,ae=l(),v=a("h2"),w=a("a"),B=a("span"),de(P.$$.fragment),Me=l(),U=a("span"),U.textContent=Re,se=l(),z=a("figure"),z.innerHTML=De,le=l(),A=a("p"),A.innerHTML=Ue,re=l(),I=a("p"),I.textContent=Fe,oe=l(),E=a("ul"),E.innerHTML=Ge,he=l(),S=a("p"),S.innerHTML=je,ce=l(),N=a("p"),N.textContent=Be,ue=l(),q=a("ul"),q.innerHTML=We,pe=l(),W=a("p"),this.h()},l(e){const n=it("svelte-1phssyn",document.head);p=s(n,"META",{name:!0,content:!0}),n.forEach(t),O=r(e),F=s(e,"P",{}),u(F).forEach(t),Y=r(e),m=s(e,"H1",{class:!0});var ge=u(m);f=s(ge,"A",{id:!0,class:!0,href:!0});var Oe=u(f);G=s(Oe,"SPAN",{});var Ye=u(G);we(y.$$.fragment,Ye),Ye.forEach(t),Oe.forEach(t),$e=r(ge),R=s(ge,"SPAN",{"data-svelte-h":!0}),o(R)!=="svelte-yx2t8r"&&(R.textContent=He),ge.forEach(t),J=r(e),x=s(e,"P",{"data-svelte-h":!0}),o(x)!=="svelte-s0u6gv"&&(x.innerHTML=ke),K=r(e),we(_.$$.fragment,e),Q=r(e),C=s(e,"P",{"data-svelte-h":!0}),o(C)!=="svelte-12o0rkz"&&(C.innerHTML=Pe),V=r(e),$=s(e,"P",{"data-svelte-h":!0}),o($)!=="svelte-h4778x"&&($.textContent=ze),X=r(e),g=s(e,"H2",{class:!0});var ve=u(g);d=s(ve,"A",{id:!0,class:!0,href:!0});var Je=u(d);j=s(Je,"SPAN",{});var Ke=u(j);we(L.$$.fragment,Ke),Ke.forEach(t),Je.forEach(t),Le=r(ve),D=s(ve,"SPAN",{"data-svelte-h":!0}),o(D)!=="svelte-16ep5vc"&&(D.textContent=Ae),ve.forEach(t),Z=r(e),M=s(e,"FIGURE",{"data-svelte-h":!0}),o(M)!=="svelte-18z4kzt"&&(M.innerHTML=Ie),ee=r(e),b=s(e,"P",{"data-svelte-h":!0}),o(b)!=="svelte-ljzs98"&&(b.innerHTML=Ee),te=r(e),T=s(e,"P",{"data-svelte-h":!0}),o(T)!=="svelte-3o4vn0"&&(T.innerHTML=Se),ne=r(e),H=s(e,"P",{"data-svelte-h":!0}),o(H)!=="svelte-c8dx7v"&&(H.innerHTML=Ne),ie=r(e),k=s(e,"P",{"data-svelte-h":!0}),o(k)!=="svelte-z6wvuu"&&(k.innerHTML=qe),ae=r(e),v=s(e,"H2",{class:!0});var fe=u(v);w=s(fe,"A",{id:!0,class:!0,href:!0});var Qe=u(w);B=s(Qe,"SPAN",{});var Ve=u(B);we(P.$$.fragment,Ve),Ve.forEach(t),Qe.forEach(t),Me=r(fe),U=s(fe,"SPAN",{"data-svelte-h":!0}),o(U)!=="svelte-16qivia"&&(U.textContent=Re),fe.forEach(t),se=r(e),z=s(e,"FIGURE",{"data-svelte-h":!0}),o(z)!=="svelte-ltt229"&&(z.innerHTML=De),le=r(e),A=s(e,"P",{"data-svelte-h":!0}),o(A)!=="svelte-ypcoh6"&&(A.innerHTML=Ue),re=r(e),I=s(e,"P",{"data-svelte-h":!0}),o(I)!=="svelte-1owod73"&&(I.textContent=Fe),oe=r(e),E=s(e,"UL",{"data-svelte-h":!0}),o(E)!=="svelte-dln72i"&&(E.innerHTML=Ge),he=r(e),S=s(e,"P",{"data-svelte-h":!0}),o(S)!=="svelte-14wt5x8"&&(S.innerHTML=je),ce=r(e),N=s(e,"P",{"data-svelte-h":!0}),o(N)!=="svelte-1uwte4"&&(N.textContent=Be),ue=r(e),q=s(e,"UL",{"data-svelte-h":!0}),o(q)!=="svelte-1h1njmy"&&(q.innerHTML=We),pe=r(e),W=s(e,"P",{}),u(W).forEach(t),this.h()},h(){h(p,"name","hf:doc:metadata"),h(p,"content",JSON.stringify(lt)),h(f,"id","designing-multiagents-systems"),h(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(f,"href","#designing-multiagents-systems"),h(m,"class","relative group"),h(d,"id","decentralized-system"),h(d,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(d,"href","#decentralized-system"),h(g,"class","relative group"),h(w,"id","centralized-approach"),h(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(w,"href","#centralized-approach"),h(v,"class","relative group")},m(e,n){c(document.head,p),i(e,O,n),i(e,F,n),i(e,Y,n),i(e,m,n),c(m,f),c(f,G),ye(y,G,null),c(m,$e),c(m,R),i(e,J,n),i(e,x,n),i(e,K,n),ye(_,e,n),i(e,Q,n),i(e,C,n),i(e,V,n),i(e,$,n),i(e,X,n),i(e,g,n),c(g,d),c(d,j),ye(L,j,null),c(g,Le),c(g,D),i(e,Z,n),i(e,M,n),i(e,ee,n),i(e,b,n),i(e,te,n),i(e,T,n),i(e,ne,n),i(e,H,n),i(e,ie,n),i(e,k,n),i(e,ae,n),i(e,v,n),c(v,w),c(w,B),ye(P,B,null),c(v,Me),c(v,U),i(e,se,n),i(e,z,n),i(e,le,n),i(e,A,n),i(e,re,n),i(e,I,n),i(e,oe,n),i(e,E,n),i(e,he,n),i(e,S,n),i(e,ce,n),i(e,N,n),i(e,ue,n),i(e,q,n),i(e,pe,n),i(e,W,n),me=!0},p:Ze,i(e){me||(xe(y.$$.fragment,e),xe(_.$$.fragment,e),xe(L.$$.fragment,e),xe(P.$$.fragment,e),me=!0)},o(e){_e(y.$$.fragment,e),_e(_.$$.fragment,e),_e(L.$$.fragment,e),_e(P.$$.fragment,e),me=!1},d(e){e&&(t(O),t(F),t(Y),t(m),t(J),t(x),t(K),t(Q),t(C),t(V),t($),t(X),t(g),t(Z),t(M),t(ee),t(b),t(te),t(T),t(ne),t(H),t(ie),t(k),t(ae),t(v),t(se),t(z),t(le),t(A),t(re),t(I),t(oe),t(E),t(he),t(S),t(ce),t(N),t(ue),t(q),t(pe),t(W)),t(p),Ce(y),Ce(_,e),Ce(L),Ce(P)}}}const lt={local:"designing-multiagents-systems",sections:[{local:"decentralized-system",title:"Decentralized system"},{local:"centralized-approach",title:"Centralized approach"}],title:"Designing Multi-Agents systems"};function rt(Te){return et(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class pt extends tt{constructor(p){super(),nt(this,p,rt,st,Xe,{})}}export{pt as component};
