import{s as ma,f as ct,n as ca,o as ha}from"../chunks/scheduler.37c15a92.js";import{S as ua,i as ga,g as n,s as p,u as zt,m as h,H as g,A as va,h as l,f as s,c as r,j as m,v as Ht,y as c,n as u,B as v,k as o,o as i,a,w as Et,d as St,t as Ot,x as At}from"../chunks/index.b01106c0.js";import{I as It}from"../chunks/IconCopyLink.77b762b4.js";function da(ce){let y,Rt,kt,Nt,b,T,Mt,A,Xs,ht,he="Introducing the Clipped Surrogate Objective Function",Gt,x,j,Ct,I,Ys,ut,ue="Recap: The Policy Objective Function",qt,R,ge="Let’s remember what the objective is to optimize in Reinforce:",Ft,N,ve,Ut,G,de="The idea was that by taking a gradient ascent step on this function (equivalent to taking gradient descent of the negative of this function), we would <strong>push our agent to take actions that lead to higher rewards and avoid harmful actions.</strong>",Bt,q,fe="However, the problem comes from the step size:",Wt,F,we="<li>Too small, <strong>the training process was too slow</strong></li> <li>Too high, <strong>there was too much variability in the training</strong></li>",Jt,U,ye="With PPO, the idea is to constrain our policy update with a new objective function called the <em>Clipped surrogate objective function</em> that <strong>will constrain the policy change in a small range using a clip.</strong>",Kt,B,be="This new function <strong>is designed to avoid destructively large weights updates</strong> :",Dt,W,xe,Qt,J,_e="Let’s study each part to understand how it works.",Vt,_,L,Pt,K,Zs,gt,ke="The Ratio Function",Xt,D,Me,Yt,Q,Ce="This ratio is calculated as follows:",Zt,V,Pe,ts,d,te,ss,Ze='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> a_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',es,as,ta='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> s_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ns,ls,$,se,is,sa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',ps,rs,z,H,ee,os,ea='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo><mo>&gt;</mo><mn>1</mn></mrow><annotation encoding="application/x-tex"> r_t(\\theta) &gt; 1 </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">&gt;</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',ms,k,ae,cs,aa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> a_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',hs,us,na='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> s_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',gs,ne,M,le,vs,la='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',ds,vt,Te="action is less likely for the current policy than for the old one",ie,fs,X,je="So this probability ratio is an <strong>easy way to estimate the divergence between old and current policy.</strong>",ws,C,E,Tt,Y,pe,dt,Le="The unclipped part of the Clipped Surrogate Objective function",ys,Z,$e,bs,tt,ze="This ratio <strong>can replace the log probability we use in the policy objective function</strong>. This gives us the left part of the new objective function: multiplying the ratio by the advantage.",xs,S,He='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/unclipped2.jpg" alt="PPO"/> <figcaption><a href="https://arxiv.org/pdf/1707.06347.pdf">Proximal Policy Optimization Algorithms</a></figcaption>',_s,st,Ee="However, without a constraint, if the action taken is much more probable in our current policy than in our former, <strong>this would lead to a significant policy gradient step</strong> and, therefore, an <strong>excessive policy update.</strong>",ks,P,O,jt,et,re,ft,Se="The clipped Part of the Clipped Surrogate Objective function",Ms,at,Oe,Cs,nt,Ae="Consequently, we need to constrain this objective function by penalizing changes that lead to a ratio far away from 1 (in the paper, the ratio can only vary from 0.8 to 1.2).",Ps,lt,Ie="<strong>By clipping the ratio, we ensure that we do not have a too large policy update because the current policy can’t be too different from the older one.</strong>",Ts,it,Re="To do that, we have two solutions:",js,pt,Ne="<li><em>TRPO (Trust Region Policy Optimization)</em> uses KL divergence constraints outside the objective function to constrain the policy update. But this method <strong>is complicated to implement and takes more computation time.</strong></li> <li><em>PPO</em> clip probability ratio directly in the objective function with its <strong>Clipped surrogate objective function.</strong></li>",Ls,rt,Ge,$s,f,oe,zs,ia='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Hs,Es,pa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',Ss,Os,w,me,As,ra='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',Is,Rs,oa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>ϵ</mi><mo>=</mo><mn>0.2</mn></mrow><annotation encoding="application/x-tex"> \\epsilon = 0.2 </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.2</span></span></span></span>',Ns,Gs,ot,qe="Then, we take the minimum of the clipped and non-clipped objective, <strong>so the final objective is a lower bound (pessimistic bound) of the unclipped objective.</strong>",qs,mt,Fe="Taking the minimum of the clipped and non-clipped objective means <strong>we’ll select either the clipped or the non-clipped objective based on the ratio and advantage situation</strong>.",Fs,Lt,Us;return A=new It({}),I=new It({}),K=new It({}),Y=new It({}),et=new It({}),{c(){y=n("meta"),Rt=p(),kt=n("p"),Nt=p(),b=n("h1"),T=n("a"),Mt=n("span"),zt(A.$$.fragment),Xs=p(),ht=n("span"),ht.textContent=he,Gt=p(),x=n("h2"),j=n("a"),Ct=n("span"),zt(I.$$.fragment),Ys=p(),ut=n("span"),ut.textContent=ue,qt=p(),R=n("p"),R.textContent=ge,Ft=p(),N=n("img"),Ut=p(),G=n("p"),G.innerHTML=de,Bt=p(),q=n("p"),q.textContent=fe,Wt=p(),F=n("ul"),F.innerHTML=we,Jt=p(),U=n("p"),U.innerHTML=ye,Kt=p(),B=n("p"),B.innerHTML=be,Dt=p(),W=n("img"),Qt=p(),J=n("p"),J.textContent=_e,Vt=p(),_=n("h2"),L=n("a"),Pt=n("span"),zt(K.$$.fragment),Zs=p(),gt=n("span"),gt.textContent=ke,Xt=p(),D=n("img"),Yt=p(),Q=n("p"),Q.textContent=Ce,Zt=p(),V=n("img"),ts=p(),d=n("p"),te=h("It’s the probability of taking action "),ss=new g(!1),es=h(" at state "),as=new g(!1),ns=h(" in the current policy, divided by the same for the previous policy."),ls=p(),$=n("p"),se=h("As we can see, "),is=new g(!1),ps=h(" denotes the probability ratio between the current and old policy:"),rs=p(),z=n("ul"),H=n("li"),ee=h("If "),os=new g(!1),ms=h(", the "),k=n("strong"),ae=h("action "),cs=new g(!1),hs=h(" at state "),us=new g(!1),gs=h(" is more likely in the current policy than the old policy."),ne=p(),M=n("li"),le=h("If "),vs=new g(!1),ds=h(" is between 0 and 1, the "),vt=n("strong"),vt.textContent=Te,ie=h("."),fs=p(),X=n("p"),X.innerHTML=je,ws=p(),C=n("h2"),E=n("a"),Tt=n("span"),zt(Y.$$.fragment),pe=p(),dt=n("span"),dt.textContent=Le,ys=p(),Z=n("img"),bs=p(),tt=n("p"),tt.innerHTML=ze,xs=p(),S=n("figure"),S.innerHTML=He,_s=p(),st=n("p"),st.innerHTML=Ee,ks=p(),P=n("h2"),O=n("a"),jt=n("span"),zt(et.$$.fragment),re=p(),ft=n("span"),ft.textContent=Se,Ms=p(),at=n("img"),Cs=p(),nt=n("p"),nt.textContent=Ae,Ps=p(),lt=n("p"),lt.innerHTML=Ie,Ts=p(),it=n("p"),it.textContent=Re,js=p(),pt=n("ul"),pt.innerHTML=Ne,Ls=p(),rt=n("img"),$s=p(),f=n("p"),oe=h("This clipped part is a version where "),zs=new g(!1),Hs=h(" is clipped between  "),Es=new g(!1),Ss=h("."),Os=p(),w=n("p"),me=h("With the Clipped Surrogate Objective function, we have two probability ratios, one non-clipped and one clipped in a range between  "),As=new g(!1),Is=h(", epsilon is a hyperparameter that helps us to define this clip range (in the paper  "),Rs=new g(!1),Ns=h(".)."),Gs=p(),ot=n("p"),ot.innerHTML=qe,qs=p(),mt=n("p"),mt.innerHTML=Fe,Fs=p(),Lt=n("p"),this.h()},l(t){const e=va("svelte-1phssyn",document.head);y=l(e,"META",{name:!0,content:!0}),e.forEach(s),Rt=r(t),kt=l(t,"P",{}),m(kt).forEach(s),Nt=r(t),b=l(t,"H1",{class:!0});var Bs=m(b);T=l(Bs,"A",{id:!0,class:!0,href:!0});var Ue=m(T);Mt=l(Ue,"SPAN",{});var Be=m(Mt);Ht(A.$$.fragment,Be),Be.forEach(s),Ue.forEach(s),Xs=r(Bs),ht=l(Bs,"SPAN",{"data-svelte-h":!0}),c(ht)!=="svelte-ieqciu"&&(ht.textContent=he),Bs.forEach(s),Gt=r(t),x=l(t,"H2",{class:!0});var Ws=m(x);j=l(Ws,"A",{id:!0,class:!0,href:!0});var We=m(j);Ct=l(We,"SPAN",{});var Je=m(Ct);Ht(I.$$.fragment,Je),Je.forEach(s),We.forEach(s),Ys=r(Ws),ut=l(Ws,"SPAN",{"data-svelte-h":!0}),c(ut)!=="svelte-1djil2g"&&(ut.textContent=ue),Ws.forEach(s),qt=r(t),R=l(t,"P",{"data-svelte-h":!0}),c(R)!=="svelte-1jx0086"&&(R.textContent=ge),Ft=r(t),N=l(t,"IMG",{src:!0,alt:!0}),Ut=r(t),G=l(t,"P",{"data-svelte-h":!0}),c(G)!=="svelte-1wz1mni"&&(G.innerHTML=de),Bt=r(t),q=l(t,"P",{"data-svelte-h":!0}),c(q)!=="svelte-70fob"&&(q.textContent=fe),Wt=r(t),F=l(t,"UL",{"data-svelte-h":!0}),c(F)!=="svelte-9oh9id"&&(F.innerHTML=we),Jt=r(t),U=l(t,"P",{"data-svelte-h":!0}),c(U)!=="svelte-mlpukg"&&(U.innerHTML=ye),Kt=r(t),B=l(t,"P",{"data-svelte-h":!0}),c(B)!=="svelte-1tgcet3"&&(B.innerHTML=be),Dt=r(t),W=l(t,"IMG",{src:!0,alt:!0}),Qt=r(t),J=l(t,"P",{"data-svelte-h":!0}),c(J)!=="svelte-pc0b8m"&&(J.textContent=_e),Vt=r(t),_=l(t,"H2",{class:!0});var Js=m(_);L=l(Js,"A",{id:!0,class:!0,href:!0});var Ke=m(L);Pt=l(Ke,"SPAN",{});var De=m(Pt);Ht(K.$$.fragment,De),De.forEach(s),Ke.forEach(s),Zs=r(Js),gt=l(Js,"SPAN",{"data-svelte-h":!0}),c(gt)!=="svelte-zqh555"&&(gt.textContent=ke),Js.forEach(s),Xt=r(t),D=l(t,"IMG",{src:!0,alt:!0}),Yt=r(t),Q=l(t,"P",{"data-svelte-h":!0}),c(Q)!=="svelte-1sbo9d1"&&(Q.textContent=Ce),Zt=r(t),V=l(t,"IMG",{src:!0,alt:!0}),ts=r(t),d=l(t,"P",{});var wt=m(d);te=u(wt,"It’s the probability of taking action "),ss=v(wt,!1),es=u(wt," at state "),as=v(wt,!1),ns=u(wt," in the current policy, divided by the same for the previous policy."),wt.forEach(s),ls=r(t),$=l(t,"P",{});var Ks=m($);se=u(Ks,"As we can see, "),is=v(Ks,!1),ps=u(Ks," denotes the probability ratio between the current and old policy:"),Ks.forEach(s),rs=r(t),z=l(t,"UL",{});var Ds=m(z);H=l(Ds,"LI",{});var $t=m(H);ee=u($t,"If "),os=v($t,!1),ms=u($t,", the "),k=l($t,"STRONG",{});var yt=m(k);ae=u(yt,"action "),cs=v(yt,!1),hs=u(yt," at state "),us=v(yt,!1),gs=u(yt," is more likely in the current policy than the old policy."),yt.forEach(s),$t.forEach(s),ne=r(Ds),M=l(Ds,"LI",{});var bt=m(M);le=u(bt,"If "),vs=v(bt,!1),ds=u(bt," is between 0 and 1, the "),vt=l(bt,"STRONG",{"data-svelte-h":!0}),c(vt)!=="svelte-sxr5di"&&(vt.textContent=Te),ie=u(bt,"."),bt.forEach(s),Ds.forEach(s),fs=r(t),X=l(t,"P",{"data-svelte-h":!0}),c(X)!=="svelte-m31yz6"&&(X.innerHTML=je),ws=r(t),C=l(t,"H2",{class:!0});var Qs=m(C);E=l(Qs,"A",{id:!0,class:!0,href:!0});var Qe=m(E);Tt=l(Qe,"SPAN",{});var Ve=m(Tt);Ht(Y.$$.fragment,Ve),Ve.forEach(s),Qe.forEach(s),pe=r(Qs),dt=l(Qs,"SPAN",{"data-svelte-h":!0}),c(dt)!=="svelte-18wnmw7"&&(dt.textContent=Le),Qs.forEach(s),ys=r(t),Z=l(t,"IMG",{src:!0,alt:!0}),bs=r(t),tt=l(t,"P",{"data-svelte-h":!0}),c(tt)!=="svelte-zxswmp"&&(tt.innerHTML=ze),xs=r(t),S=l(t,"FIGURE",{class:!0,"data-svelte-h":!0}),c(S)!=="svelte-13ku1ey"&&(S.innerHTML=He),_s=r(t),st=l(t,"P",{"data-svelte-h":!0}),c(st)!=="svelte-1e78bt7"&&(st.innerHTML=Ee),ks=r(t),P=l(t,"H2",{class:!0});var Vs=m(P);O=l(Vs,"A",{id:!0,class:!0,href:!0});var Xe=m(O);jt=l(Xe,"SPAN",{});var Ye=m(jt);Ht(et.$$.fragment,Ye),Ye.forEach(s),Xe.forEach(s),re=r(Vs),ft=l(Vs,"SPAN",{"data-svelte-h":!0}),c(ft)!=="svelte-1nr370u"&&(ft.textContent=Se),Vs.forEach(s),Ms=r(t),at=l(t,"IMG",{src:!0,alt:!0}),Cs=r(t),nt=l(t,"P",{"data-svelte-h":!0}),c(nt)!=="svelte-cpftrh"&&(nt.textContent=Ae),Ps=r(t),lt=l(t,"P",{"data-svelte-h":!0}),c(lt)!=="svelte-1iqqwcw"&&(lt.innerHTML=Ie),Ts=r(t),it=l(t,"P",{"data-svelte-h":!0}),c(it)!=="svelte-aufndz"&&(it.textContent=Re),js=r(t),pt=l(t,"UL",{"data-svelte-h":!0}),c(pt)!=="svelte-5n19r6"&&(pt.innerHTML=Ne),Ls=r(t),rt=l(t,"IMG",{src:!0,alt:!0}),$s=r(t),f=l(t,"P",{});var xt=m(f);oe=u(xt,"This clipped part is a version where "),zs=v(xt,!1),Hs=u(xt," is clipped between  "),Es=v(xt,!1),Ss=u(xt,"."),xt.forEach(s),Os=r(t),w=l(t,"P",{});var _t=m(w);me=u(_t,"With the Clipped Surrogate Objective function, we have two probability ratios, one non-clipped and one clipped in a range between  "),As=v(_t,!1),Is=u(_t,", epsilon is a hyperparameter that helps us to define this clip range (in the paper  "),Rs=v(_t,!1),Ns=u(_t,".)."),_t.forEach(s),Gs=r(t),ot=l(t,"P",{"data-svelte-h":!0}),c(ot)!=="svelte-eqkgrh"&&(ot.innerHTML=qe),qs=r(t),mt=l(t,"P",{"data-svelte-h":!0}),c(mt)!=="svelte-1k9oa10"&&(mt.innerHTML=Fe),Fs=r(t),Lt=l(t,"P",{}),m(Lt).forEach(s),this.h()},h(){o(y,"name","hf:doc:metadata"),o(y,"content",JSON.stringify(fa)),o(T,"id","introducing-the-clipped-surrogate-objective-function"),o(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(T,"href","#introducing-the-clipped-surrogate-objective-function"),o(b,"class","relative group"),o(j,"id","recap-the-policy-objective-function"),o(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(j,"href","#recap-the-policy-objective-function"),o(x,"class","relative group"),ct(N.src,ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/lpg.jpg")||o(N,"src",ve),o(N,"alt","Reinforce"),ct(W.src,xe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ppo-surrogate.jpg")||o(W,"src",xe),o(W,"alt","PPO surrogate function"),o(L,"id","the-ratio-function"),o(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(L,"href","#the-ratio-function"),o(_,"class","relative group"),ct(D.src,Me="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ratio1.jpg")||o(D,"src",Me),o(D,"alt","Ratio"),ct(V.src,Pe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ratio2.jpg")||o(V,"src",Pe),o(V,"alt","Ratio"),ss.a=es,as.a=ns,is.a=ps,os.a=ms,cs.a=hs,us.a=gs,vs.a=ds,o(E,"id","the-unclipped-part-of-the-clipped-surrogate-objective-function"),o(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(E,"href","#the-unclipped-part-of-the-clipped-surrogate-objective-function"),o(C,"class","relative group"),ct(Z.src,$e="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/unclipped1.jpg")||o(Z,"src",$e),o(Z,"alt","PPO"),o(S,"class","image table text-center m-0 w-full"),o(O,"id","the-clipped-part-of-the-clipped-surrogate-objective-function"),o(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(O,"href","#the-clipped-part-of-the-clipped-surrogate-objective-function"),o(P,"class","relative group"),ct(at.src,Oe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/clipped.jpg")||o(at,"src",Oe),o(at,"alt","PPO"),ct(rt.src,Ge="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/clipped.jpg")||o(rt,"src",Ge),o(rt,"alt","PPO"),zs.a=Hs,Es.a=Ss,As.a=Is,Rs.a=Ns},m(t,e){i(document.head,y),a(t,Rt,e),a(t,kt,e),a(t,Nt,e),a(t,b,e),i(b,T),i(T,Mt),Et(A,Mt,null),i(b,Xs),i(b,ht),a(t,Gt,e),a(t,x,e),i(x,j),i(j,Ct),Et(I,Ct,null),i(x,Ys),i(x,ut),a(t,qt,e),a(t,R,e),a(t,Ft,e),a(t,N,e),a(t,Ut,e),a(t,G,e),a(t,Bt,e),a(t,q,e),a(t,Wt,e),a(t,F,e),a(t,Jt,e),a(t,U,e),a(t,Kt,e),a(t,B,e),a(t,Dt,e),a(t,W,e),a(t,Qt,e),a(t,J,e),a(t,Vt,e),a(t,_,e),i(_,L),i(L,Pt),Et(K,Pt,null),i(_,Zs),i(_,gt),a(t,Xt,e),a(t,D,e),a(t,Yt,e),a(t,Q,e),a(t,Zt,e),a(t,V,e),a(t,ts,e),a(t,d,e),i(d,te),ss.m(Ze,d),i(d,es),as.m(ta,d),i(d,ns),a(t,ls,e),a(t,$,e),i($,se),is.m(sa,$),i($,ps),a(t,rs,e),a(t,z,e),i(z,H),i(H,ee),os.m(ea,H),i(H,ms),i(H,k),i(k,ae),cs.m(aa,k),i(k,hs),us.m(na,k),i(k,gs),i(z,ne),i(z,M),i(M,le),vs.m(la,M),i(M,ds),i(M,vt),i(M,ie),a(t,fs,e),a(t,X,e),a(t,ws,e),a(t,C,e),i(C,E),i(E,Tt),Et(Y,Tt,null),i(C,pe),i(C,dt),a(t,ys,e),a(t,Z,e),a(t,bs,e),a(t,tt,e),a(t,xs,e),a(t,S,e),a(t,_s,e),a(t,st,e),a(t,ks,e),a(t,P,e),i(P,O),i(O,jt),Et(et,jt,null),i(P,re),i(P,ft),a(t,Ms,e),a(t,at,e),a(t,Cs,e),a(t,nt,e),a(t,Ps,e),a(t,lt,e),a(t,Ts,e),a(t,it,e),a(t,js,e),a(t,pt,e),a(t,Ls,e),a(t,rt,e),a(t,$s,e),a(t,f,e),i(f,oe),zs.m(ia,f),i(f,Hs),Es.m(pa,f),i(f,Ss),a(t,Os,e),a(t,w,e),i(w,me),As.m(ra,w),i(w,Is),Rs.m(oa,w),i(w,Ns),a(t,Gs,e),a(t,ot,e),a(t,qs,e),a(t,mt,e),a(t,Fs,e),a(t,Lt,e),Us=!0},p:ca,i(t){Us||(St(A.$$.fragment,t),St(I.$$.fragment,t),St(K.$$.fragment,t),St(Y.$$.fragment,t),St(et.$$.fragment,t),Us=!0)},o(t){Ot(A.$$.fragment,t),Ot(I.$$.fragment,t),Ot(K.$$.fragment,t),Ot(Y.$$.fragment,t),Ot(et.$$.fragment,t),Us=!1},d(t){t&&(s(Rt),s(kt),s(Nt),s(b),s(Gt),s(x),s(qt),s(R),s(Ft),s(N),s(Ut),s(G),s(Bt),s(q),s(Wt),s(F),s(Jt),s(U),s(Kt),s(B),s(Dt),s(W),s(Qt),s(J),s(Vt),s(_),s(Xt),s(D),s(Yt),s(Q),s(Zt),s(V),s(ts),s(d),s(ls),s($),s(rs),s(z),s(fs),s(X),s(ws),s(C),s(ys),s(Z),s(bs),s(tt),s(xs),s(S),s(_s),s(st),s(ks),s(P),s(Ms),s(at),s(Cs),s(nt),s(Ps),s(lt),s(Ts),s(it),s(js),s(pt),s(Ls),s(rt),s($s),s(f),s(Os),s(w),s(Gs),s(ot),s(qs),s(mt),s(Fs),s(Lt)),s(y),At(A),At(I),At(K),At(Y),At(et)}}}const fa={local:"introducing-the-clipped-surrogate-objective-function",sections:[{local:"recap-the-policy-objective-function",title:"Recap: The Policy Objective Function"},{local:"the-ratio-function",title:"The Ratio Function"},{local:"the-unclipped-part-of-the-clipped-surrogate-objective-function",title:"The unclipped part of the Clipped Surrogate Objective function"},{local:"the-clipped-part-of-the-clipped-surrogate-objective-function",title:"The clipped Part of the Clipped Surrogate Objective function"}],title:"Introducing the Clipped Surrogate Objective Function"};function wa(ce){return ha(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class _a extends ua{constructor(y){super(),ga(this,y,wa,da,ma,{})}}export{_a as component};
