import{s as vt,n as gt,o as dt}from"../chunks/scheduler.37c15a92.js";import{S as wt,i as _t,g as i,s as l,u as ee,A as Ct,h as r,f as t,c as o,j as c,v as te,y as u,k as s,o as h,a,w as ne,d as ae,t as ie,x as re}from"../chunks/index.b01106c0.js";import{I as le}from"../chunks/IconCopyLink.77b762b4.js";function Lt(ze){let f,oe,K,se,p,w,Q,y,Se,U,Fe="(Automatic) Curriculum Learning for RL",he,b,Oe="While most of the RL methods seen in this course work well in practice, there are some cases where using them alone fails. This can happen, for instance, when:",ue,$,Ue="<li>the task to learn is hard and requires an <strong>incremental acquisition of skills</strong> (for instance when one wants to make a bipedal agent learn to go through hard obstacles, it must first learn to stand, then walk, then maybe jump…)</li> <li>there are variations in the environment (that affect the difficulty) and one wants its agent to be <strong>robust</strong> to them</li>",ce,k,je='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/bipedal.gif" alt="Bipedal"/> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/movable_creepers.gif" alt="Movable creepers"/> <figcaption><a href="https://developmentalsystems.org/TeachMyAgent/">TeachMyAgent</a></figcaption>',fe,A,Be="In such cases, it seems needed to propose different tasks to our RL agent and organize them such that the agent progressively acquires skills. This approach is called <strong>Curriculum Learning</strong> and usually implies a hand-designed curriculum (or set of tasks organized in a specific order). In practice, one can, for instance, control the generation of the environment, the initial states, or use Self-Play and control the level of opponents proposed to the RL agent.",pe,T,Ge="As designing such a curriculum is not always trivial, the field of <strong>Automatic Curriculum Learning (ACL) proposes to design approaches that learn to create such an organization of tasks in order to maximize the RL agent’s performances</strong>. Portelas et al. proposed to define ACL as:",me,H,Je="<p>… a family of mechanisms that automatically adapt the distribution of training data by learning to adjust the selection of learning situations to the capabilities of RL agents.</p>",ve,M,Ke="As an example, OpenAI used <strong>Domain Randomization</strong> (they applied random variations on the environment) to make a robot hand solve Rubik’s Cubes.",ge,R,Qe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/dr.jpg" alt="Dr"/> <figcaption><a href="https://openai.com/blog/solving-rubiks-cube/">OpenAI - Solving Rubik’s Cube with a Robot Hand</a></figcaption>',de,P,We='Finally, you can play with the robustness of agents trained in the <a href="https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo">TeachMyAgent</a> benchmark by controlling environment variations or even drawing the terrain 👇',we,E,Ve='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/demo.png" alt="Demo"/> <figcaption><a href="https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo">https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo</a></figcaption>',_e,m,_,W,S,Ie,j,Xe="Further reading",Ce,I,Ye="For more information, we recommend that you check out the following resources:",Le,v,C,V,q,qe,B,Ze="Overview of the field",xe,D,et='<li><a href="https://arxiv.org/pdf/2003.04664.pdf" rel="nofollow">Automatic Curriculum Learning For Deep RL: A Short Survey</a></li> <li><a href="https://lilianweng.github.io/posts/2020-01-29-curriculum-rl/" rel="nofollow">Curriculum for Reinforcement Learning</a></li>',ye,g,L,X,N,De,G,tt="Recent methods",be,z,nt='<li><a href="https://arxiv.org/abs/2203.01302" rel="nofollow">Evolving Curricula with Regret-Based Environment Design</a></li> <li><a href="https://proceedings.mlr.press/v162/klink22a.html" rel="nofollow">Curriculum Reinforcement Learning via Constrained Optimal Transport</a></li> <li><a href="https://arxiv.org/abs/2010.03934" rel="nofollow">Prioritized Level Replay</a></li>',$e,d,x,Y,F,Ne,J,at="Author",ke,O,it='This section was written by <a href="https://twitter.com/ClementRomac">Clément Romac</a>',Ae,Z,Te;return y=new le({}),S=new le({}),q=new le({}),N=new le({}),F=new le({}),{c(){f=i("meta"),oe=l(),K=i("p"),se=l(),p=i("h1"),w=i("a"),Q=i("span"),ee(y.$$.fragment),Se=l(),U=i("span"),U.textContent=Fe,he=l(),b=i("p"),b.textContent=Oe,ue=l(),$=i("ul"),$.innerHTML=Ue,ce=l(),k=i("figure"),k.innerHTML=je,fe=l(),A=i("p"),A.innerHTML=Be,pe=l(),T=i("p"),T.innerHTML=Ge,me=l(),H=i("blockquote"),H.innerHTML=Je,ve=l(),M=i("p"),M.innerHTML=Ke,ge=l(),R=i("figure"),R.innerHTML=Qe,de=l(),P=i("p"),P.innerHTML=We,we=l(),E=i("figure"),E.innerHTML=Ve,_e=l(),m=i("h2"),_=i("a"),W=i("span"),ee(S.$$.fragment),Ie=l(),j=i("span"),j.textContent=Xe,Ce=l(),I=i("p"),I.textContent=Ye,Le=l(),v=i("h3"),C=i("a"),V=i("span"),ee(q.$$.fragment),qe=l(),B=i("span"),B.textContent=Ze,xe=l(),D=i("ul"),D.innerHTML=et,ye=l(),g=i("h3"),L=i("a"),X=i("span"),ee(N.$$.fragment),De=l(),G=i("span"),G.textContent=tt,be=l(),z=i("ul"),z.innerHTML=nt,$e=l(),d=i("h2"),x=i("a"),Y=i("span"),ee(F.$$.fragment),Ne=l(),J=i("span"),J.textContent=at,ke=l(),O=i("p"),O.innerHTML=it,Ae=l(),Z=i("p"),this.h()},l(e){const n=Ct("svelte-1phssyn",document.head);f=r(n,"META",{name:!0,content:!0}),n.forEach(t),oe=o(e),K=r(e,"P",{}),c(K).forEach(t),se=o(e),p=r(e,"H1",{class:!0});var He=c(p);w=r(He,"A",{id:!0,class:!0,href:!0});var rt=c(w);Q=r(rt,"SPAN",{});var lt=c(Q);te(y.$$.fragment,lt),lt.forEach(t),rt.forEach(t),Se=o(He),U=r(He,"SPAN",{"data-svelte-h":!0}),u(U)!=="svelte-yfbuil"&&(U.textContent=Fe),He.forEach(t),he=o(e),b=r(e,"P",{"data-svelte-h":!0}),u(b)!=="svelte-divgy0"&&(b.textContent=Oe),ue=o(e),$=r(e,"UL",{"data-svelte-h":!0}),u($)!=="svelte-1fijmic"&&($.innerHTML=Ue),ce=o(e),k=r(e,"FIGURE",{"data-svelte-h":!0}),u(k)!=="svelte-259cr2"&&(k.innerHTML=je),fe=o(e),A=r(e,"P",{"data-svelte-h":!0}),u(A)!=="svelte-16unqvo"&&(A.innerHTML=Be),pe=o(e),T=r(e,"P",{"data-svelte-h":!0}),u(T)!=="svelte-t9kiqj"&&(T.innerHTML=Ge),me=o(e),H=r(e,"BLOCKQUOTE",{"data-svelte-h":!0}),u(H)!=="svelte-1i9zwqs"&&(H.innerHTML=Je),ve=o(e),M=r(e,"P",{"data-svelte-h":!0}),u(M)!=="svelte-q06j09"&&(M.innerHTML=Ke),ge=o(e),R=r(e,"FIGURE",{"data-svelte-h":!0}),u(R)!=="svelte-habslb"&&(R.innerHTML=Qe),de=o(e),P=r(e,"P",{"data-svelte-h":!0}),u(P)!=="svelte-4l6fnl"&&(P.innerHTML=We),we=o(e),E=r(e,"FIGURE",{"data-svelte-h":!0}),u(E)!=="svelte-15rau72"&&(E.innerHTML=Ve),_e=o(e),m=r(e,"H2",{class:!0});var Me=c(m);_=r(Me,"A",{id:!0,class:!0,href:!0});var ot=c(_);W=r(ot,"SPAN",{});var st=c(W);te(S.$$.fragment,st),st.forEach(t),ot.forEach(t),Ie=o(Me),j=r(Me,"SPAN",{"data-svelte-h":!0}),u(j)!=="svelte-1gvwyzx"&&(j.textContent=Xe),Me.forEach(t),Ce=o(e),I=r(e,"P",{"data-svelte-h":!0}),u(I)!=="svelte-144wssd"&&(I.textContent=Ye),Le=o(e),v=r(e,"H3",{class:!0});var Re=c(v);C=r(Re,"A",{id:!0,class:!0,href:!0});var ht=c(C);V=r(ht,"SPAN",{});var ut=c(V);te(q.$$.fragment,ut),ut.forEach(t),ht.forEach(t),qe=o(Re),B=r(Re,"SPAN",{"data-svelte-h":!0}),u(B)!=="svelte-1iyg844"&&(B.textContent=Ze),Re.forEach(t),xe=o(e),D=r(e,"UL",{"data-svelte-h":!0}),u(D)!=="svelte-19o2s58"&&(D.innerHTML=et),ye=o(e),g=r(e,"H3",{class:!0});var Pe=c(g);L=r(Pe,"A",{id:!0,class:!0,href:!0});var ct=c(L);X=r(ct,"SPAN",{});var ft=c(X);te(N.$$.fragment,ft),ft.forEach(t),ct.forEach(t),De=o(Pe),G=r(Pe,"SPAN",{"data-svelte-h":!0}),u(G)!=="svelte-7rb9da"&&(G.textContent=tt),Pe.forEach(t),be=o(e),z=r(e,"UL",{"data-svelte-h":!0}),u(z)!=="svelte-1cnmd2q"&&(z.innerHTML=nt),$e=o(e),d=r(e,"H2",{class:!0});var Ee=c(d);x=r(Ee,"A",{id:!0,class:!0,href:!0});var pt=c(x);Y=r(pt,"SPAN",{});var mt=c(Y);te(F.$$.fragment,mt),mt.forEach(t),pt.forEach(t),Ne=o(Ee),J=r(Ee,"SPAN",{"data-svelte-h":!0}),u(J)!=="svelte-hw3i4s"&&(J.textContent=at),Ee.forEach(t),ke=o(e),O=r(e,"P",{"data-svelte-h":!0}),u(O)!=="svelte-a8x2u9"&&(O.innerHTML=it),Ae=o(e),Z=r(e,"P",{}),c(Z).forEach(t),this.h()},h(){s(f,"name","hf:doc:metadata"),s(f,"content",JSON.stringify(xt)),s(w,"id","automatic-curriculum-learning-for-rl"),s(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(w,"href","#automatic-curriculum-learning-for-rl"),s(p,"class","relative group"),s(_,"id","further-reading"),s(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(_,"href","#further-reading"),s(m,"class","relative group"),s(C,"id","overview-of-the-field"),s(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(C,"href","#overview-of-the-field"),s(v,"class","relative group"),s(L,"id","recent-methods"),s(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(L,"href","#recent-methods"),s(g,"class","relative group"),s(x,"id","author"),s(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(x,"href","#author"),s(d,"class","relative group")},m(e,n){h(document.head,f),a(e,oe,n),a(e,K,n),a(e,se,n),a(e,p,n),h(p,w),h(w,Q),ne(y,Q,null),h(p,Se),h(p,U),a(e,he,n),a(e,b,n),a(e,ue,n),a(e,$,n),a(e,ce,n),a(e,k,n),a(e,fe,n),a(e,A,n),a(e,pe,n),a(e,T,n),a(e,me,n),a(e,H,n),a(e,ve,n),a(e,M,n),a(e,ge,n),a(e,R,n),a(e,de,n),a(e,P,n),a(e,we,n),a(e,E,n),a(e,_e,n),a(e,m,n),h(m,_),h(_,W),ne(S,W,null),h(m,Ie),h(m,j),a(e,Ce,n),a(e,I,n),a(e,Le,n),a(e,v,n),h(v,C),h(C,V),ne(q,V,null),h(v,qe),h(v,B),a(e,xe,n),a(e,D,n),a(e,ye,n),a(e,g,n),h(g,L),h(L,X),ne(N,X,null),h(g,De),h(g,G),a(e,be,n),a(e,z,n),a(e,$e,n),a(e,d,n),h(d,x),h(x,Y),ne(F,Y,null),h(d,Ne),h(d,J),a(e,ke,n),a(e,O,n),a(e,Ae,n),a(e,Z,n),Te=!0},p:gt,i(e){Te||(ae(y.$$.fragment,e),ae(S.$$.fragment,e),ae(q.$$.fragment,e),ae(N.$$.fragment,e),ae(F.$$.fragment,e),Te=!0)},o(e){ie(y.$$.fragment,e),ie(S.$$.fragment,e),ie(q.$$.fragment,e),ie(N.$$.fragment,e),ie(F.$$.fragment,e),Te=!1},d(e){e&&(t(oe),t(K),t(se),t(p),t(he),t(b),t(ue),t($),t(ce),t(k),t(fe),t(A),t(pe),t(T),t(me),t(H),t(ve),t(M),t(ge),t(R),t(de),t(P),t(we),t(E),t(_e),t(m),t(Ce),t(I),t(Le),t(v),t(xe),t(D),t(ye),t(g),t(be),t(z),t($e),t(d),t(ke),t(O),t(Ae),t(Z)),t(f),re(y),re(S),re(q),re(N),re(F)}}}const xt={local:"automatic-curriculum-learning-for-rl",sections:[{local:"further-reading",sections:[{local:"overview-of-the-field",title:"Overview of the field"},{local:"recent-methods",title:"Recent methods"}],title:"Further reading"},{local:"author",title:"Author"}],title:"(Automatic) Curriculum Learning for RL"};function yt(ze){return dt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class At extends wt{constructor(f){super(),_t(this,f,yt,Lt,vt,{})}}export{At as component};
