import{s as nt,n as at,o as it}from"../chunks/scheduler.37c15a92.js";import{S as ot,i as st,g as a,s as o,u as W,A as lt,h as i,f as t,c as s,j as f,v as X,y as u,k as l,o as h,a as n,w as Y,d as Z,t as ee,x as te}from"../chunks/index.b01106c0.js";import{I as re}from"../chunks/IconCopyLink.77b762b4.js";function ht(Ae){let c,ne,U,ae,p,w,B,y,ke,z,Me="Decision Transformers",ie,b,De='The Decision Transformer model was introduced by <a href="https://arxiv.org/abs/2106.01345" rel="nofollow">“Decision Transformer: Reinforcement Learning via Sequence Modeling” by Chen L. et al</a>. It abstracts Reinforcement Learning as a conditional-sequence modeling problem.',oe,C,Se=`The main idea is that instead of training a policy using RL methods, such as fitting a value function, that will tell us what action to take to maximize the return (cumulative reward), <strong>we use a sequence modeling algorithm (Transformer) that, given a desired return, past states, and actions, will generate future actions to achieve this desired return</strong>.
It’s an autoregressive model conditioned on the desired return, past states, and actions to generate future actions that achieve the desired return.`,se,k,Ne="This is a complete shift in the Reinforcement Learning paradigm since we use generative trajectory modeling (modeling the joint distribution of the sequence of states, actions, and rewards) to replace conventional RL algorithms. This means that in Decision Transformers, we don’t maximize the return but rather generate a series of future actions that achieve the desired return.",le,L,qe="The 🤗 Transformers team integrated the Decision Transformer, an Offline Reinforcement Learning method, into the library as well as the Hugging Face Hub.",he,m,x,J,P,Le,F,Re="Learn about Decision Transformers",fe,H,ze='To learn more about Decision Transformers, you should read the blogpost we wrote about it <a href="https://huggingface.co/blog/decision-transformers" rel="nofollow">Introducing Decision Transformers on Hugging Face</a>',ue,d,_,G,E,Pe,I,Fe="Train your first Decision Transformers",ce,A,Ie='Now that you understand how Decision Transformers work thanks to <a href="https://huggingface.co/blog/decision-transformers" rel="nofollow">Introducing Decision Transformers on Hugging Face</a>, you’re ready to learn to train your first Offline Decision Transformer model from scratch to make a half-cheetah run.',pe,M,je='Start the tutorial here 👉 <a href="https://huggingface.co/blog/train-decision-transformers" rel="nofollow">https://huggingface.co/blog/train-decision-transformers</a>',me,v,T,K,D,He,j,Oe="Further reading",de,S,Ue="For more information, we recommend that you check out the following resources:",ve,N,Be='<li><a href="https://arxiv.org/abs/2106.01345" rel="nofollow">Decision Transformer: Reinforcement Learning via Sequence Modeling</a></li> <li><a href="https://arxiv.org/abs/2202.05607" rel="nofollow">Online Decision Transformer</a></li>',ge,g,$,Q,q,Ee,O,Je="Author",we,R,Ge='This section was written by <a href="https://twitter.com/edwardbeeching">Edward Beeching</a>',xe,V,_e;return y=new re({}),P=new re({}),E=new re({}),D=new re({}),q=new re({}),{c(){c=a("meta"),ne=o(),U=a("p"),ae=o(),p=a("h1"),w=a("a"),B=a("span"),W(y.$$.fragment),ke=o(),z=a("span"),z.textContent=Me,ie=o(),b=a("p"),b.innerHTML=De,oe=o(),C=a("p"),C.innerHTML=Se,se=o(),k=a("p"),k.textContent=Ne,le=o(),L=a("p"),L.textContent=qe,he=o(),m=a("h2"),x=a("a"),J=a("span"),W(P.$$.fragment),Le=o(),F=a("span"),F.textContent=Re,fe=o(),H=a("p"),H.innerHTML=ze,ue=o(),d=a("h2"),_=a("a"),G=a("span"),W(E.$$.fragment),Pe=o(),I=a("span"),I.textContent=Fe,ce=o(),A=a("p"),A.innerHTML=Ie,pe=o(),M=a("p"),M.innerHTML=je,me=o(),v=a("h2"),T=a("a"),K=a("span"),W(D.$$.fragment),He=o(),j=a("span"),j.textContent=Oe,de=o(),S=a("p"),S.textContent=Ue,ve=o(),N=a("ul"),N.innerHTML=Be,ge=o(),g=a("h2"),$=a("a"),Q=a("span"),W(q.$$.fragment),Ee=o(),O=a("span"),O.textContent=Je,we=o(),R=a("p"),R.innerHTML=Ge,xe=o(),V=a("p"),this.h()},l(e){const r=lt("svelte-1phssyn",document.head);c=i(r,"META",{name:!0,content:!0}),r.forEach(t),ne=s(e),U=i(e,"P",{}),f(U).forEach(t),ae=s(e),p=i(e,"H1",{class:!0});var Te=f(p);w=i(Te,"A",{id:!0,class:!0,href:!0});var Ke=f(w);B=i(Ke,"SPAN",{});var Qe=f(B);X(y.$$.fragment,Qe),Qe.forEach(t),Ke.forEach(t),ke=s(Te),z=i(Te,"SPAN",{"data-svelte-h":!0}),u(z)!=="svelte-6qh08h"&&(z.textContent=Me),Te.forEach(t),ie=s(e),b=i(e,"P",{"data-svelte-h":!0}),u(b)!=="svelte-1pl0nz2"&&(b.innerHTML=De),oe=s(e),C=i(e,"P",{"data-svelte-h":!0}),u(C)!=="svelte-1kfqzgt"&&(C.innerHTML=Se),se=s(e),k=i(e,"P",{"data-svelte-h":!0}),u(k)!=="svelte-1j807k8"&&(k.textContent=Ne),le=s(e),L=i(e,"P",{"data-svelte-h":!0}),u(L)!=="svelte-zczmxc"&&(L.textContent=qe),he=s(e),m=i(e,"H2",{class:!0});var $e=f(m);x=i($e,"A",{id:!0,class:!0,href:!0});var Ve=f(x);J=i(Ve,"SPAN",{});var We=f(J);X(P.$$.fragment,We),We.forEach(t),Ve.forEach(t),Le=s($e),F=i($e,"SPAN",{"data-svelte-h":!0}),u(F)!=="svelte-1iwwlkm"&&(F.textContent=Re),$e.forEach(t),fe=s(e),H=i(e,"P",{"data-svelte-h":!0}),u(H)!=="svelte-pb625j"&&(H.innerHTML=ze),ue=s(e),d=i(e,"H2",{class:!0});var ye=f(d);_=i(ye,"A",{id:!0,class:!0,href:!0});var Xe=f(_);G=i(Xe,"SPAN",{});var Ye=f(G);X(E.$$.fragment,Ye),Ye.forEach(t),Xe.forEach(t),Pe=s(ye),I=i(ye,"SPAN",{"data-svelte-h":!0}),u(I)!=="svelte-1rt0oni"&&(I.textContent=Fe),ye.forEach(t),ce=s(e),A=i(e,"P",{"data-svelte-h":!0}),u(A)!=="svelte-kwpyu2"&&(A.innerHTML=Ie),pe=s(e),M=i(e,"P",{"data-svelte-h":!0}),u(M)!=="svelte-rvkt4a"&&(M.innerHTML=je),me=s(e),v=i(e,"H2",{class:!0});var be=f(v);T=i(be,"A",{id:!0,class:!0,href:!0});var Ze=f(T);K=i(Ze,"SPAN",{});var et=f(K);X(D.$$.fragment,et),et.forEach(t),Ze.forEach(t),He=s(be),j=i(be,"SPAN",{"data-svelte-h":!0}),u(j)!=="svelte-1gvwyzx"&&(j.textContent=Oe),be.forEach(t),de=s(e),S=i(e,"P",{"data-svelte-h":!0}),u(S)!=="svelte-144wssd"&&(S.textContent=Ue),ve=s(e),N=i(e,"UL",{"data-svelte-h":!0}),u(N)!=="svelte-iqu6oe"&&(N.innerHTML=Be),ge=s(e),g=i(e,"H2",{class:!0});var Ce=f(g);$=i(Ce,"A",{id:!0,class:!0,href:!0});var tt=f($);Q=i(tt,"SPAN",{});var rt=f(Q);X(q.$$.fragment,rt),rt.forEach(t),tt.forEach(t),Ee=s(Ce),O=i(Ce,"SPAN",{"data-svelte-h":!0}),u(O)!=="svelte-hw3i4s"&&(O.textContent=Je),Ce.forEach(t),we=s(e),R=i(e,"P",{"data-svelte-h":!0}),u(R)!=="svelte-11016ov"&&(R.innerHTML=Ge),xe=s(e),V=i(e,"P",{}),f(V).forEach(t),this.h()},h(){l(c,"name","hf:doc:metadata"),l(c,"content",JSON.stringify(ft)),l(w,"id","decision-transformers"),l(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(w,"href","#decision-transformers"),l(p,"class","relative group"),l(x,"id","learn-about-decision-transformers"),l(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(x,"href","#learn-about-decision-transformers"),l(m,"class","relative group"),l(_,"id","train-your-first-decision-transformers"),l(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_,"href","#train-your-first-decision-transformers"),l(d,"class","relative group"),l(T,"id","further-reading"),l(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(T,"href","#further-reading"),l(v,"class","relative group"),l($,"id","author"),l($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l($,"href","#author"),l(g,"class","relative group")},m(e,r){h(document.head,c),n(e,ne,r),n(e,U,r),n(e,ae,r),n(e,p,r),h(p,w),h(w,B),Y(y,B,null),h(p,ke),h(p,z),n(e,ie,r),n(e,b,r),n(e,oe,r),n(e,C,r),n(e,se,r),n(e,k,r),n(e,le,r),n(e,L,r),n(e,he,r),n(e,m,r),h(m,x),h(x,J),Y(P,J,null),h(m,Le),h(m,F),n(e,fe,r),n(e,H,r),n(e,ue,r),n(e,d,r),h(d,_),h(_,G),Y(E,G,null),h(d,Pe),h(d,I),n(e,ce,r),n(e,A,r),n(e,pe,r),n(e,M,r),n(e,me,r),n(e,v,r),h(v,T),h(T,K),Y(D,K,null),h(v,He),h(v,j),n(e,de,r),n(e,S,r),n(e,ve,r),n(e,N,r),n(e,ge,r),n(e,g,r),h(g,$),h($,Q),Y(q,Q,null),h(g,Ee),h(g,O),n(e,we,r),n(e,R,r),n(e,xe,r),n(e,V,r),_e=!0},p:at,i(e){_e||(Z(y.$$.fragment,e),Z(P.$$.fragment,e),Z(E.$$.fragment,e),Z(D.$$.fragment,e),Z(q.$$.fragment,e),_e=!0)},o(e){ee(y.$$.fragment,e),ee(P.$$.fragment,e),ee(E.$$.fragment,e),ee(D.$$.fragment,e),ee(q.$$.fragment,e),_e=!1},d(e){e&&(t(ne),t(U),t(ae),t(p),t(ie),t(b),t(oe),t(C),t(se),t(k),t(le),t(L),t(he),t(m),t(fe),t(H),t(ue),t(d),t(ce),t(A),t(pe),t(M),t(me),t(v),t(de),t(S),t(ve),t(N),t(ge),t(g),t(we),t(R),t(xe),t(V)),t(c),te(y),te(P),te(E),te(D),te(q)}}}const ft={local:"decision-transformers",sections:[{local:"learn-about-decision-transformers",title:"Learn about Decision Transformers"},{local:"train-your-first-decision-transformers",title:"Train your first Decision Transformers"},{local:"further-reading",title:"Further reading"},{local:"author",title:"Author"}],title:"Decision Transformers"};function ut(Ae){return it(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class dt extends ot{constructor(c){super(),st(this,c,ut,ht,nt,{})}}export{dt as component};
